*-----------------------------------------------------------------------
      SUBROUTINE AD2LST(ISLOT,NAM,CMT,SPC,NOI,XPOS,MSK,LCAL,ILCAL)
*-----------------------------------------------------------------------
* Copies the spectrum info from the parameters into the list.
*
* islot  : Slot number in which to insert;
* nam    : Spectrum name;
* cmt    : Spectrum comments;
* noi    : Spectrum noise values;
* xpos   : Spectrum channel x-positions
* msk    : Spectrum mask
* lcal   : Spectrum real calibration constants;
* ilcal  : Spectrum integer calibration constants;
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'speccom.inc'
*-----------------------------------------------------------------------
      INTEGER ISLOT,ILINE,ILCAL(MCAL)
      CHARACTER NAM*(*),CMT(MCOMMT)*(MCMTLEN)
      REAL SPC(LSPEC),NOI(LSPEC),XPOS(LSPEC),LCAL(MCAL)
      LOGICAL MSK(LSPEC)
*-----------------------------------------------------------------------
      INTEGER I,NPTS
 
C Copy character values
      SPCNAM(ISLOT) = NAM
      DO 100 ILINE = 1,MCOMMT
        SPCCMT(ILINE,ISLOT) = CMT(ILINE)
 100  CONTINUE
 
C Copy real values
      NPTS = ILCAL(1)
      CALL VCOPY(NPTS,SPC,SPCTRA(1,ISLOT))
      CALL VCOPY(NPTS,NOI,SPCNOI(1,ISLOT))
      CALL VCOPY(NPTS,XPOS,XSPC(1,ISLOT))
      CALL VCOPY(MCAL,LCAL,SPCCAL(1,ISLOT))
 
C Copy logical values
      DO 200 I = 1,NPTS
        SPCMSK(I,ISLOT) = MSK(I)
 200  CONTINUE
 
C Copy integer values
      DO 300 I = 1,MCAL
        ICALSP(I,ISLOT) = ILCAL(I)
 300  CONTINUE
 
      RETURN
      END
