      SUBROUTINE ADDEXP
*     Adds experimental spectra.
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 900627tk
*---mru : 26Jul93 cs; 971216 tk
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'parcom.inc'
      include 'speccom.inc'

      real sclnoy, blsrc1, arsrc1, blsrc2, arsrc2, bldest, ardest
      real tmpspc(LSPEC), tmpnoi(LSPEC ), tmpcal(MCAL)
      integer i, ichr, isrc1, isrc2, idest, npts, c1, itype
      character*(MFLLEN) newnam

      integer chuspc
      external chuspc
*-----------------------------------------------------------------------
*---close window since ADDEXP requires text mode.
        CALL WNCLOS(1)
*---Go to Text mode and clear screen
        CALL ENDGR
        CALL CLSCRN
 
c     ;; define new spectrum number on LIST
      idest = min(spctot + 1, MMAIN) 
 
c     ;; Choose First spectrum from list
      isrc1 = chuspc('Choose First Spectrum')
      itype = icalsp(10,isrc1)
      if(itype.ne.0)then
         call errmsg('ADDEXP currently only for Mossbauer data.')
         goto 1000
      endif
      if (isrc1.le.0) goto 1000
      npts  = icalsp(1,isrc1)
      blsrc1   = spccal(3,isrc1)
      arsrc1 = spccal(4,isrc1)
      

c     ;; Copy calibration info
      do 100 i = 1, MCAL
         tmpcal(i) = spccal(i,isrc1)
 100  continue

c     ;; Choose second spectrum
      isrc2 = chuspc('Choose Second Spectrum')
      itype = icalsp(10,isrc2)
      if(itype.ne.0)then
         call errmsg('ADDEXP currently only for Mossbauer data.')
         goto 1000
      endif
      if (isrc2.le.0) goto 1000
      blsrc2   = spccal(3,isrc2)
      arsrc2 = spccal(4,isrc2)
      if (icalsp(1,isrc2).ne.npts) then
         call errmsg('WARNING: The two spectra are of '//
     &      'different lengths!')
      endif

c     ;; Construct (unnormalized) sum of unnormalized spectra
      do 200 i = 1, npts
         tmpspc(i) = blsrc1 + arsrc1 * spctra(i,isrc1) + blsrc2 + 
     &      arsrc2 * spctra(i,isrc2)
 200  continue
 
c     ;; Remove baseline and normalize area of sum spectrum
      call mbnorm(npts, tmpspc, mcal, icalsp(1,isrc1), tmpcal)
      bldest = tmpcal(3) 
      ardest = tmpcal(4)

c     ;; Calculate noise vector for sum spectrum
      sclnoy = sqrt(bldest) / ardest
      do 300 i = 1, npts
        tmpnoi(i) = sclnoy
 300  continue
 
c     ;; define text colors
      call normal
 
c     ;; Get name for sum spectrum
      call outsxy(1, 12, 'Spectrum #1 is named ' // spcnam(isrc1))
      call outsxy(1, 14, 'Spectrum #2 is named ' // spcnam(isrc2))
      newnam = ' '
      call outsxy(1, 16, 'Name of sum ?')
      call gets(15, 16, newnam, MFLLEN, ichr, .false.)
 
c     ;; Put new spectrum and cal onto list
      call ad2lst(idest, newnam, spccmt(1,isrc1), tmpspc, tmpnoi,
     &   xspc(1,isrc1), spcmsk(1,isrc1), tmpcal, icalsp(1,isrc1))
      call clrmsk(idest)
      spctot = idest
 
c     ;; make new spectrum the active spectrum
      actspc = idest
 
c     ;; Give advice
      call outsxy(1, 16, 'Comments may be changed in [Files | ' //
     &   'Edit Data Header]')
      call outsxy(1, 18, 'Press any key to continue ...')
      call inkey(c1)

1000  continue
*---return to graphics mode
        CALL INTGRA
*---Update screen with new plot of active spectrum and numerical info.
          CALL SHOACT(.FALSE.)
 
      return
      end
