      subroutine analyze(anlopt)
*-----------------------------------------------------------------------
      integer anlopt
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig1991 cs&tk
*---mru 02nov93 cs
*     MOSS Version
*
*     Dispatches an analytical routine, including pre- and post-
*     processing.
*
*     anlopt : [Input]  Flag which determines the routine to execute:
*                       1) Flash on current spectrum;
*                       2) LSub from current spectrum;
*                       3) SSub from current spectrum;
*                       4) Least-Squares Fit;
*                       5) Least-Squares Fit w/o saving results to list.
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'parcom.inc'
      include 'speccom.inc'
      include 'togcom.inc'
      include 'scrncom.inc'
*-----------------------------------------------------------------------
      integer i, ispc1, ispc2
      logical pchnge
 
      integer getspc
      external getspc
*----------------------------------------------------------------------

      if (anlopt.eq.1) THEN
c        ;;;;;;;;;;;;;;;
c        ;;; FLASHER ;;;
c        ;;;;;;;;;;;;;;;
   50    if (spctot.le.0) then
            call errmsg('Please load some data first!')
            call files(1)
            if (spctot.gt.0) goto 50
         elseif (.not.parlod) then   
            call errmsg('No parameters have been entered yet!')
            call files(5)
            if (parlod) goto 50
         else
            call maktab(-actspc)
            datchu = .true.
            call makvec
            call flasher
c           ;; Restore fit-table calibration info
            call maktab(-actspc)
         endif
      elseif (anlopt.eq.2) then
c        ;;;;;;;;;;;;
c        ;;; LSUB ;;;
c        ;;;;;;;;;;;; 
  100    if (spctot.gt.0) then
            call lsub
         else
            call errmsg('Please load some data first!')
            call files(1)
            if (spctot.gt.0) goto 100
         endif
      elseif (anlopt.eq.3) then
c        ;;;;;;;;;;;;
c        ;;; SSUB ;;;
c        ;;;;;;;;;;;;
  150    if (spctot.gt.0) then
            pchnge = .false.
            ispc1 = actspc

            call message('Please choose spectrum #2 from the list...')
 
            do 160 i = 1, spctot
               select(i) = .false.
  160       continue
            ispc2 = getspc()
 
            if (ispc2.ge.0) then
               call sholst
               call ssub(ispc1,ispc2)
               select(ispc2) = .false.
               call sholst
            endif
         else
            call errmsg('Please load some data first!')
            call files(1)
            if (spctot.gt.0) goto 150
         endif
      ELSEIF ((ANLOPT.EQ.4).or.(anlopt.eq.5)) THEN
c        ;;;;;;;;;;;;;;
c        ;;; DO FIT ;;;
c        ;;;;;;;;;;;;;; 
  200    if (datchu) then
            if (parlod) then
               if (anlopt.eq.4) call maktab(0)
               call dofit(anlopt-3)
            else
               call errmsg('No parameters have been entered yet!')
               call files(5)
               if (parlod) goto 200
            endif
         elseif ((spctot.eq.1).and.parlod) then
            call maktab(-1)
            datchu = .true.
            call sholst
            call makvec
            goto 200
         else
*----Jump Directly to [List : Choose Data]
            call errmsg('Please choose some data!')
            call list(4)
            if (datchu) goto 200
         endif
      else
         call errmsg('Internal Error! Bad argument to ANALYZE')
      endif
 
      return
      end
