      subroutine asc35p(FILNAM,md,SPEC,NTX,TEXT,ICAL,RCAL,IERR)
C
C     1. READ unfolded SPECTRUM AND ITS HEADER from ASCII file.
*        THIS FORMAT COMPATIBLE WITH FILES created by
*        Canberra 35 Plus Multi Channel Analyzer
*     2. fold the spectrum 
*     3. return folded  channel spectrum in SPEC
 
C       HEADER IS FOLLOWED BY A REAL ARRAY CONTAINING THE
C       SPECTRAL DATA.  LOWER BOUND SUBSCRIPT OF THE ARRAY
C       IS 1.   UPPER BOUND SUBSCRIPT IS NCHANS=ical(1).
C
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    Orig: 920922 MRU 920922 tk
C --------------------------------------------------
      include 'limits.inc'
      INCLUDE 'iocom.inc'
      include 'keycom.inc'
*---externals 
      character filnam*(*)
      character*72 text(MCOMMT)
      REAL SPEC(md),RCAL(*)
      INTEGER I,ICAL(*),IERR
      INTEGER NTX
*---internals
      integer ispec(2*lspec), md, nl, l
      real tmpspc(2*lspec)
      character key*5
      integer nover, mca, megs
 
*---number of channels in unfolded spectrum
      integer nuf,nf

      integer ichr
      integer infocu
      external infocu
 
C OPEN FILE
      OPEN (JDISK,FILE=FILNAM,IOSTAT=IERR)
      IF ( IERR.NE.0 ) RETURN
 
 
      do 45 i=1,6
         text(i)=' '
   45 continue
      Text(1)= 'Canberra 35P ASCII file'
*---skip the first 5 lines
      DO 55 I = 1,5
         READ (JDISK,*,IOSTAT=IERR,ERR=999) 
   55 CONTINUE
 
C READ IN THE unfolded NUF channel SPECTRUM
*---only 512 channels files for now    920922 tk
      nl=8
      nuf = 512
      do 900 l=0,nuf/nl - 1
         read (jdisk,9001,iostat=ierr,end=903,err=999) key, 
     &      (ispec(i+8*l),i=1,nl)
 9001    format(1x,a5,i11,i8,i9,i8,i9,i8,i9,i8)
*---Make sure a Canberra 35P file is being read.
         if(l.eq.0 .and. key.ne.'    0')then
            ierr=-889
            goto 999
         endif
  900 continue
  903 close(jdisk, iostat=ierr)

*---check spectrum length
      if(nuf.gt.2*lspec)then
         ierr=-nuf
         goto 999
      endif

*---Ask for Foldovers and convert to floating point storage
      nover=0
      call scbell('ON')
      call scbell(' ')
      call message('How many overflows? ')
      call geti(infocu(1),infocu(2),nover,ichr,.false.)
      if (ichr.eq.ESC) then
         ierr = -999
         goto 999
      endif
      if(nover.gt.0)then
  902    mca=30
         call message('Is your MCA a Series ~30~ or ~35~?')
         call geti(infocu(1),infocu(2),mca,ichr,.false.)
         if (ichr.eq.ESC) then
            ierr = -999
            goto 999
         endif
         call scbell(' ')
         if(mca.eq.30)then
            megs=10**6*nover
         elseif(mca.eq.35)then
            megs = 2**20*nover
         else
            goto 902
         endif
      else
         megs=0
      endif

*---repair channels 1 and 2
      ispec(1)=ispec(3)
      ispec(2)=ispec(3)  
      do 904 i=1,nuf
         tmpspc(i)=ispec(i)+ megs
  904 continue
 
*----fold spectrum
      CALL FALT(filnam, nuf, tmpspc, nf, spec, rcal(5), rcal(6),
     &   rcal(7), ierr)
      if (ierr.eq.0) then
         ical(1) = nf
         ical(2) = 1
         do 200 i=3, 10
            ical(i) = 0
  200    continue
*---set file type (see readsp.for)
            ical(5) = 9

         do 210 i = 1,4
            rcal(i) = 0.0
  210    continue
         do 220 i = 8,10
            rcal(i) = 0.0
  220    continue
      endif
 
  999 continue
      RETURN
 
      END
