      SUBROUTINE ASCIn(FILNAM,IORO,NSP,IFRMT,SPEC,NTX,TEXT,NIC,ICAL,NRC,
     &                 RCAL,IERR)
C
C       READ one SPECTRUM AND ITS HEADER to/from ASCII file.
*
C       File FORMAT IS AS FOLLOWS:
C     DATA     No. of elements    Total Bytes   Format
c     text         ntx            ntx*72      character
*     ical         nic            nic*4        integer
C     rcal         nrc            nrc*4        real
c     spec         nsp            nsp*4        real
C
C     TOTAL HEADER SIZE = ntx*72 + nic*72 + nrc*4 BYTES
C
C       HEADER IS FOLLOWED BY A REAL ARRAY CONTAINING THE
C       SPECTRAL DATA.  LOWER BOUND SUBSCRIPT OF THE ARRAY
C       IS 1.   UPPER BOUND SUBSCRIPT IS NCHANS=ical(1).
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 920816 tk
*---mru : 960115 tk
C --------------------------------------------------
      INCLUDE 'iocom.inc'
      include 'limits.inc'

      real specuf(2*lspec)
      CHARACTER FILNAM*(*),TEXT(MCOMMT)*72,DUMMY*72
      REAL SPEC(NSP),RCAL(MCAL)
      INTEGER ICAL(MCAL),IORO,IERR,IFRMT
      INTEGER NSP,NTX,NIC,NRC

      integer i,j,irow, irow1, nrow, nuf, ierr1
*-------------------------------------------------------
*---executables

*---clear header info in RAM
      do 10 i=1,mcal
         ical(i)=0
         rcal(i)=0.0
   10 continue
         do 40 i=1,mcommt
40         text(i)=' '

C OPEN FILE
      OPEN (JDISK,FILE=FILNAM,IOSTAT=IERR)
      IF ( IERR.NE.0 ) RETURN
 
C READ IN THE HEADER
        DO 50 I = 1,MIN(6,NTX)
          READ (JDISK,'(a)',IOSTAT=IERR,ERR=300) TEXT(I)
 50     CONTINUE
*---if more than six comment lines, skip the rest of the comments
        DO 100 I = 7,NTX
          READ (JDISK,'(a)',IOSTAT=IERR,ERR=300) DUMMY
  100  CONTINUE
*---READ INTEGER VALUED CALIBRATION PARAMETERS
        IF ( NIC.GT.0 ) READ (JDISK,*,IOSTAT=IERR,ERR=300)
     &                        (ICAL(I),I=1,NIC)
*---READ REAL VALUED CALIBRATION PARAMETERS
        IF ( NRC.GT.0 ) then
           READ (JDISK,*,IOSTAT=IERR,ERR=300) (RCAL(I),I=1,NRC)
         if(nrc.eq.4)then
*---must be Munck type file.
*---copy cal info from 3rd line to proper position in rcal array.
          rcal(5)=rcal(1)
          rcal(6)=rcal(2)
          rcal(7)=rcal(3)
          rcal(1)=0.0
          rcal(2)=0.0
          rcal(3)=0.0
         endif
      endif
 
C READ IN THE SPECTRUM
            if(nic.gt.0)then
              if(ical(1).lt.0 .or. ical(1).gt.nsp) then
               ierr=99
               return
              endif
           endif

        IF ( IFRMT.EQ.0 ) THEN
          READ (JDISK,*,IOSTAT=IERR,ERR=300) (SPEC(I),I=1,ICAL(1))
       ELSEIF ( IFRMT.EQ.1 ) THEN
*---PATCH TO ACCOMODATE UNPACK ASCII FILES WITH 5 LINE HEADER
         NROW = (ICAL(1)/8) - 1
*---read first row 
         READ (JDISK,'(8F9.0)',IOSTAT=IERR,ERR=300)
     &          (SPEC(I),I=1,8)
*---is first point valid part of spectrum?
*---Does rcal(4) not contain baseline information?
*---if not then this file is an unpacked file.
*---read first line again.
         if( abs(spec(1)-rcal(4)) .gt. 0.02*rcal(4) .and.
     &       rcal(4).gt.1.0 )then
            irow1=0
         else
            irow1=1
         endif
         DO 140 IROW=irow1,NROW
          READ (JDISK,'(8F9.0)',IOSTAT=IERR,ERR=300)
     &          (SPEC(I+8*IROW),I=1,8)
  140  continue
*---Try reading 2nd half of unfolded  spectrum.
         DO 145 IROW=0,NROW
          READ (JDISK,'(8F9.0)',IOSTAT=IERR,ERR=147,end=148)
     &          (SPECuf(ical(1)+I+8*IROW),I=1,8)
  145  continue
  147 continue
      if(ierr.eq.0)then
*---2nd half of unfolded spectrum read correctly. Now fold the data.
          do 1471 i=1,ical(1)
             specuf(i)=spec(i)
 1471     continue
          nuf=2*ical(1)
         CALL FALT(filnam, nuf, specuf, ical(1), spec, rcal(5),
     &       rcal(6), rcal(7), ierr)
      else
*---Unexpected error.
      goto 300
       endif
 
  148 continue 
*---must be normal folded spectrum. proceed.
      ierr=0

       elseIF ( IFRMT.EQ.2 ) THEN
*---Huynh file
          READ (JDISK,*,IOSTAT=IERR,ERR=300) (SPEC(I),I=1,nsp)
        ENDIF
 
  300 CLOSE (JDISK, IOSTAT=IERR1)
      if (ierr1.ne.0) ierr = ierr1
      RETURN
      END
