      SUBROUTINE ASCmaa(FILNAM,IORO,NSP,IFRMT,SPEC,NTX,TEXT,
     &                  NIC,ICAL,NRC,RCAL,IERR)
C  EG&G  Maestro ASCII (print to file) format
c  for reading pulse height spectra from TRUMP card.
C       READ one SPECTRUM AND ITS HEADER from ASCII file.
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 960805 tk
*---mru : 980503 tk
C --------------------------------------------------
      INCLUDE 'iocom.inc'
      include 'limits.inc'

      integer spec0(2048)
      CHARACTER FILNAM*(*),TEXT(MCOMMT)*72
      REAL SPEC(NSP),RCAL(MCAL)
      INTEGER ICAL(MCAL),IORO,IERR,IFRMT
      INTEGER NSP,NTX,NIC,NRC

      integer i,j,irow, nchan0, ncol, nrow, ierr1
      integer nlast, nskip, taq
*-------------------------------------------------------
*---executables

*---clear header info in RAM
      do 10 i=1,mcal
         ical(i)=0
         rcal(i)=0.0
   10 continue
         do 40 i=1,mcommt
40         text(i)=' '

C OPEN FILE
      OPEN (JDISK,FILE=FILNAM,IOSTAT=IERR)
      IF ( IERR.NE.0 ) RETURN
 
C READ IN THE HEADER
*---read blank line
      read(jdisk,*)
*---read 2 lines of text
        DO 50 I = 1,2
          READ (JDISK,'(a)',IOSTAT=IERR,ERR=300) TEXT(I)
 50     CONTINUE
*---Confirm EG&G Maestro Print to File format
      if(text(1)(1:7).eq.'Maestro')then
       ierr=0
      else
       ierr=1
       goto 300
      endif
*---4th line might contain aquisition time [sec live]
      read(jdisk,*,iostat=ierr) taq
      if (ierr.ne.0)then
        call errmsg('No aquisition time information. Set Taq = 1')
        taq = 1
      endif
      rcal(9) = taq

 
C READ IN THE SPECTRUM
       nchan0 = 2048
       ncol  = 12
       nrow  = nchan0/ncol
       nlast  = nchan0 - nrow*ncol
      do 100 irow=1,nrow
          READ (JDISK,900,IOSTAT=IERR,ERR=300)
     1         (SPEC0((irow-1)*ncol+j),j=1,ncol)
 100  continue
 900      format(7x,12i10)
c---read last line
          READ (JDISK,900,IOSTAT=IERR,ERR=300)
     1         (SPEC0(nrow*ncol+j),j=1,nlast)

c--define cal info and force 2048 channels to fit LSPEC limit
c--by summing neighbors
      
        nskip = (nchan0-1)/lspec +1
        nchan0 = nchan0/nskip
        do 200i=1,nchan0
          spec(i) = 0.0
          do 180 j=1,nskip
            spec(i) = spec(i) + spec0( (i-1)*nskip + j)
180   continue
*---Convert counts to count rate by dividing by aquisition time.
        spec(i) = spec(i) / taq
200   continue
c--Number of channels
      ical(1) = nchan0
c--File Type
      ical(5) = 17
c--Data Type
      ical(10) = 4000
c--baseline
      rcal(3) = 0.0
c--Area
      rcal(4) = 1.0
c--X = 0 chan
      rcal(6) = 0.0
c--dX / Chan
      rcal(7) = 1.0
  300 CLOSE (JDISK, IOSTAT=IERR1)
      if (ierr1.ne.0) ierr = ierr1
      RETURN
      END
