      SUBROUTINE ASCoc(FILNAM,Itype,NSP,xspc,SPEC,NTX,TEXT,NIC,ICAL,
     &                 NRC,RCAL,IERR)
C
C       Write a SPECTRUM AND ITS HEADER to/from ASCII file,  [counts] only
*---Input:
*---FILNAM
*---ITYPE
*---NSP
*---XSPC    Calibrated X-values
*---SPEC    Area Normalized Mossbauer spectrum
*---NTX
*---TEXT
*---NIC
*---ICAL
*---NRC
*---RCAL
*---IERR    Error Flag
*
C       File FORMAT IS AS FOLLOWS:
C     DATA     No. of elements    Total Bytes   Format
c     text         ntx            ntx*72      character
*     ical         nic            nic*4        integer
C     rcal         nrc            nrc*4        real
c     spec         nsp            nsp*4        real
C
C     TOTAL HEADER SIZE = ntx*72 + nic*72 + nrc*4 BYTES
C
C       HEADER IS FOLLOWED BY A REAL ARRAY CONTAINING THE
C       SPECTRAL DATA.  LOWER BOUND SUBSCRIPT OF THE ARRAY
C       IS 1.   UPPER BOUND SUBSCRIPT IS NCHANS=ical(1).
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
C  FWBI  RLT   10/23/75
*---MRU 921228 TK
*---920816 tk
*---mru 960102 tk; 980102 tk
C --------------------------------------------------
*---externals
      INCLUDE 'iocom.inc'
      include 'limits.inc'
      CHARACTER FILNAM*(*),TEXT(MCOMMT)*72
      REAL xspc(nsp),SPEC(NSP),RCAL(MCAL)
      INTEGER I,ICAL(MCAL),Itype,IERR
      INTEGER NSP,NTX,NIC,NRC
*---internals
      integer ierr1
      real counts
*---executables

C OPEN FILE
      OPEN (JDISK,FILE=FILNAM,IOSTAT=IERR)
      IF ( IERR.NE.0 ) RETURN
 
*----------------------------------------------------------------------- 
c Write to file
*---text header
        DO 150 I = 1,MIN(6,NTX)
          WRITE (JDISK,'(a)',IOSTAT=IERR,ERR=300) TEXT(I)
 150    CONTINUE
        DO 200 I = 7,NTX
          WRITE (JDISK,'(a)',IOSTAT=IERR,ERR=300)
 200    CONTINUE
*---integer calibration constants
        IF ( NIC.GT.0 ) WRITE (JDISK,'(5i14)',IOSTAT=IERR,ERR=300)
     &                         (ICAL(I),I=1,NIC)
*---floating point calibration constants
        IF ( NRC.GT.0 ) WRITE (JDISK,'(5e14.6)',IOSTAT=IERR,ERR=300)
     &                         (RCAL(I),I=1,NRC)

      

*---write data
*---single column, [counts]
*---write raw counts, y -only
          do 220 i=1,ical(1)
          counts = rcal(3) + rcal(4)*spec(i)
          WRITE (JDISK,'(i10)',IOSTAT=IERR,ERR=300) int(counts)
220       continue

 
  300 CLOSE (JDISK, IOSTAT=IERR1)
      if (ierr1.ne.0) ierr = ierr1
      RETURN
      END
