      subroutine binio(filnam, jdisk, ioro, inout, text, ical, rcal,
     &   spec, ninout, ierr)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 1991 tk
*--- mru: 13Aug93 cs; 960118 tk
*-----------------------------------------------------------------------
*---common blocks and parameters
      include 'limits.inc'
      include 'errcodes.inc'
*---externals
      character*(MFLLEN) filnam(inout)
      character text(MCOMMT,inout)*72
      integer ioro, irec, ierr, jdisk, inout, ninout
      integer ical(MCAL, inout)
      real rcal(MCAL,inout), spec(LSPEC,inout)
*-----------------------------------------------------------------------
*     This routine reads or writes one or more spectra in an 
*     unformatted, direct-access file, though it currently accesses
*     this file only sequentially.  Each spectrum consists of a
*     single 512 byte header and as many following blocks each
*     containing 512 bytes of data as the length of the spectrum
*     requires. 
*
*     filnam : [In/Out] Array of names; first is filename to access;
*     jdisk  : [Input]  FORTRAN unit number to use;
*     ioro   : [Input]  Read/write toggle: 0 to read, 1 to write;
*     inout  : [Input]  Reading: Maximum number of spectra to read;
*            :          Writing: Number of spectra to write;
*     text   : [In/Out] Array of six-line comments to read/write;
*     ical   : [In/Out] Array of integer calibration constants to read/write;
*     rcal   : [In/Out] Array of real calibration constants to read/write;
*     spec   : [In/Out] Array of spectra to read/write;
*     ninout : [Output] Number of spectra read or written;
*     ierr   : [Output] Error code.
*--------------------------------------------------------------------------
*---internals 
c     ;; All records have a length of 512 bytes
      integer LREC, LREAL, IPAD
      parameter (LREC = 512, LREAL = LREC / 4)
c	parameter (LREC = 256, LREAL = LREC / 4)
      parameter (IPAD = LREC - MCOMMT * 72 - MCAL * 4 - MCAL * 4)
	integer piona
      real tmparr(LREAL)
      integer i, j, k, ispec, ierr1, idatum, ndata
      character name*80
      character*1 tmpblk(LREC)
*--------------------------------------------------------------------------
*---executables
*---clear error flag
      ierr=NoError
*---check length of header
	a=-1
	a=IPAD
      if(mcommt*72+mcal*8 .gt. lrec)then
         call errmsg('Data File Header too long in routine BINIO.')
         ierr = 1
         return
      endif
*---check length of data record
      if(lreal.gt.lspec)then
         call errmsg('Data record length too long  in routine BINIO.')
         ierr = 2
         return
      endif

*---Attempt to open file
      ninout = 0
 
      if ((ioro.eq.0).and.(inout.gt.0)) then
c        ;;;;;;;;;;;;;;;;;;
c        ;; Read spectra ;;
c        ;;;;;;;;;;;;;;;;;;
*---for every slot on list,
      do 12 j= 1,inout
C Clear calibration info
       do 10 i = 1, MCAL
         rcal(i,j) = 0.0
         ical(i,j) = 0
  10   continue
* Clear comments
       do 11 i = 1, MCOMMT
         text(i,j) = ' '
   11  continue
 12   continue
* Modify form Binary (from Unformatted)
         open (jdisk, file=filnam(1), access='DIRECT',
     &      form='BINARY', recl=lrec, status='OLD', err=1100,
     &      iostat=ierr)
         irec = 0
         name = filnam(1)
         do 150 ispec = 1, inout
            irec = irec + 1
*---read header
            read (jdisk, rec=irec, iostat=ierr) 
     &         (text(k,ninout+1), k = 1, MCOMMT), 
     &         (ical(k,ninout+1), k = 1, MCAL),
     &         (rcal(k,ninout+1), k = 1, MCAL),
     &         (tmpblk(k), k = 1, IPAD)
c	PION 11.06
c            if ((ierr.eq.SalfordEndOfFile).and.(ninout.gt.0)) then
	      if ((ierr.eq.IntelEndOfFile).and.(ninout.gt.0)) then
               ierr = NoError
               goto 170 
c            elseif ((ierr.eq.SalfordBadRecNum).and.(ninout.gt.0)) then
            elseif ((ierr.eq.36).and.(ninout.gt.0)) then

               ierr = NoError
               goto 170
            elseif((ical(1,ninout+1).lt.0.or.
     &         ical(1,ninout+1).gt.LSPEC)) then
               if (ninout.eq.1) then
                  call errmsg('~WARNING~:  Disk file too long; ' //
     &               ' please fix by SAVING BACK TO DISK!')
                  call errmsg('~WARNING~:  SAVE ' // name)
                  ierr = NoError
               else
                  ierr = ErrBadFileFormat
               endif
               goto 1000
            elseif (ierr.ne.NoError) then
               goto 1000
            endif
*---read data
            do 100 i = 0, (ical(1,ninout+1) - 1) / LREAL
               irec = irec + 1
               read(jdisk, rec=irec, iostat=ierr) tmparr
c               if ((ierr.eq.SalfordBadRecNum).and.(ninout.eq.1)) then
               if ((ierr.eq.36).and.(ninout.eq.1)) then
c                 ;; Patch: For a few months, BINIO always wrote out
c                 ;; a single extra record at the end of the file;
c                 ;; Warn if this is detected.
                  call errmsg('~WARNING~:  Disk file too long; ' //
     &               ' please fix by SAVING BACK TO DISK!')
                  call errmsg('~WARNING~:  save '//name)
                  ierr = NoError
                  goto 1000
               elseif (ierr.ne.NoError) then
                  goto 1000
               endif
               do 110 j = 1, lreal
                  spec((i*lreal)+j, ninout+1) = tmparr(j)
  110          continue
  100       continue
            ninout = ninout + 1
  150    continue
*----------------------------------------------------------------------
*960118 tk : conditional file name adjustment
c        ;; Adjust filenames for multi-spectra files.
  170 continue 
      if (ninout.gt.1) then
            do 180 i = 1, ninout
               if (text(MCOMMT,i)(1:11).eq.'listname = ') then
                  filnam(i) = text(MCOMMT,i)(12:)
               else
                  filnam(i) = char(ichar('0')+(i/10)) //
     &               char(ichar('0')+mod(i,10)) // '-' // name
               endif
  180       continue
         endif
*-----------------------------------------------------------------------
      elseif ((ioro.eq.1).and.(inout.gt.0)) then
c        ;;;;;;;;;;;;;;;;;;;
c        ;; Write spectra ;;
c        ;;;;;;;;;;;;;;;;;;;
         open (jdisk, file=filnam(1), access='DIRECT', ACTION='write',
     &      form='BINARY', recl=lrec, status='REPLACE', err=1100, 
     &      iostat=ierr)
         do 50 i = 1, Lrec-1, 4
            tmpblk(i)   = 'W'
            tmpblk(i+1) = 'E'
            tmpblk(i+2) = 'B'
            tmpblk(i+3) = '!'
   50    continue
         irec = 0
         do 300 ispec = 1, inout
*---write header
            irec = irec + 1
            write (jdisk, rec=irec, iostat=ierr, err=1000)
     &         (text(k,ninout+1), k = 1, MCOMMT), 
     &         (ical(k,ninout+1), k = 1, MCAL),
     &         (rcal(k,ninout+1), k = 1, MCAL),
     &         (tmpblk(k), k = 1, IPAD)
*---write data
            ndata = ical(1,ninout+1)
            do 200 i = 0, ((ndata-1)/lreal)
               irec = irec + 1
               do 210 j = 1, lreal
                  idatum = i*lreal + j
                  if(idatum.le.ndata)then
                     tmparr(j) = spec(idatum,ninout+1)
                  else
                     tmparr(j) = j
                  endif
  210          continue
               write(jdisk, rec=irec, iostat=ierr, err=1000) tmparr
  200       continue
            ninout = ninout + 1
  300    continue
      else
         call errmsg('~Internal Error~:  Bad argument to BINIO!')
         ierr = ErrBadArgument
         goto 1100
      endif

 1000 close (jdisk, iostat=ierr1)
      if (ierr.eq.NoError) ierr = ierr1

 1100 return
      end
