      SUBROUTINE BOPOP(ND,N,T,E,BOPR)
*-------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:  ?
*---mru : 930718 tk
*---Purpose:
*     Calculates Boltzmann probabilities for N states with
*     energy E.
*
*     ND     : Array size
*     N      : Number of states
*     T      : Temperature (Kelvin).  T<0 picks one state int(abs(T)).
*     E      : Energy in wave numbers
*     BOPR   : Output Boltzmann probabilities
*-------------------------------------------------------------------
      INCLUDE 'constcom.inc'
 
      INTEGER ND,N
      REAL T,E(ND),BOPR(ND)
 
      INTEGER I
      REAL BKT,E0,H1
      REAL*8 HSUM,H2
*-------------------------------------------------------------------
*---zero all populations
      DO 100 I = 1,N
        BOPR(I) = 0.0
 100  CONTINUE
 
      IF ( T.EQ.0.0 ) THEN
*---ground state only. avoid division by zero.
        BOPR(1) = 1.0
      ELSEIF ( T.LT.-0.5 ) THEN
*---use negative temperature value to choose one state only.
        BOPR(NINT(ABS(T))) = 1.0
 
      ELSE
*---For positive temperature values, calc normal Boltzman populations
        BKT = BK*T
*---Find minimum energy
        E0 = E(1)
        DO 150 I = 2,N
          IF ( E0.GT.E(I) ) E0 = E(I)
 150    CONTINUE
 
        HSUM = 0.
        DO 200 I = 1,N
          H1 = (E(I)-E0)/BKT
          IF ( H1.GT.10. ) THEN
            BOPR(I) = 0.
          ELSE
            H2 = EXP(-H1)
            BOPR(I) = H2
            HSUM = HSUM + H2
          ENDIF
 200    CONTINUE
*---normalized such that sum(BOPR(i)) = 1.0
        DO 250 I = 1,N
          BOPR(I) = BOPR(I)/HSUM
 250    CONTINUE
 
      ENDIF
 
      RETURN
      END
