      subroutine caladj(mcal,rcal,ical,npts,xval,yval,ynoi)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 921115 tk
*---mru : 26Jul93 cs; 960118 tk; 980303 tk
*     WMOSS version
*
*     Adjusts calibration info and recalulates dependent quantities.
*-----------------------------------------------------------------------
*---externals
      integer mcal, ical(mcal), npts
      real rcal(mcal), xval(npts), yval(npts), ynoi(npts)
*---internals
      real c0, dv
      integer i, itype
*-----------------------------------------------------------------------
*---executables
c---data type
      itype = ical(10)

      if(itype.lt.1000)then
*---Mossbauer type.
c     ;; Zero-Velocity position [chan]
      c0 = rcal(6)
c     ;; Step [mm/s/chan]
      dv = rcal(7)

c     ;; Calculate x value for each channel
      do 10 i=1,npts
         xval(i)=(i-c0)*dv
   10 continue

c     ;; Define normalized noise values.
c     ;; ical(mcal) .eq. 0 indicates normalized experimental Mossbauer
c     ;; absoption spectrum.
      if ( itype.eq.0 .and. (rcal(4).ne.0.0) ) then
*---tk 960102: itype=ical(10)=0 -->data ; rcal(4)=area ; rcal(3)=baseline
*---tk 19980303         sclnoi = sqrt(abs(rcal(3)))/rcal(4)
*---Do not use baseline estimate for noise calc.
*---Instead noise as sqrt of counts in each channel.
      do 20 i = 1, npts
         ynoi(i) = sqrt( rcal(3)+rcal(4)*yval(i) ) / abs (rcal(4))
   20 continue
      elseif(itype.eq.60)then
*---load file type 6 [Vel., % abs.] .  No baseline info.
      do 21 i = 1, npts
         ynoi(i) = 0.0
   21 continue
       
      else
c--- itype <> 0 --> theoretical spectrum.
      do 22 i = 1, npts
         ynoi(i) = 0.0
   22 continue
      endif

      elseif(itype.ge.4000 .and. itype.lt.5000)then
C---Pulse Height Spectrum
c     ;; Zero-Energy channel
      c0 = rcal(6)
c     ;; Step [keV/chan]
      dv = rcal(7)

c     ;; Calculate x value for each channel
      do 110 i=1,npts
         xval(i)=(i-c0)*dv
  110 continue
c---calc. noise vaules
      do 220 i = 1, npts
         ynoi(i) = sqrt(yval(i))
  220 continue

      endif

      return
      end 
