      subroutine callin(half, npts, spc, noi, xpos, ilines, linpos, 
     &   ierr)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig 1992 CS
*---mru 930129 tk; 980127 tk
*----------------------------------------------------------------------
      integer npts, ierr, linpos(6), half
      real spc(npts), xpos(npts), noi(npts)

      INCLUDE 'limits.inc'
      include 'parcom.inc'
      include 'keycom.inc'

      integer i, j, ilines, ichr, ichan, hlfpos(6)
      real ymin, ymax, signif, high

      real nocal(mcal), xs(lspec)
      integer inocal(mcal)
      logical nomask(lspec)
      character nocmt(6)*72, noname*(mfllen)
      save nocal, nomask, nocmt, noname
      data nocal/0.,0.,100.,1.,0.,0.,1.,0.,0.,0./
      data inocal/mcal*0/
      data nomask/lspec*.true./
      data nocmt/6*' '/
      data noname/' '/
*----------------------------------------------------------------------

*---Clear error code
      ierr = 0

*---Zero line positions
      ilines = 0
      do 50 i = 1, 6
         linpos(i) = 0
   50 continue

*---Make channel-number x-position array
      do 100 i = 1, npts
         xs(i) = i
  100 continue

*---Determine significant peak height
      call armm1(spc, npts, ymin, ymax)
      signif = (ymax-ymin)/5.0

*---Display spectrum
      inocal(1) = npts
      if (half.eq.1) then
         nocmt(1) = 'First half.'
      elseif (half.eq.2) then
         nocmt(1) = 'Second half.'
      else
         nocmt(1) = ' '
      endif
      call shodat(.true., npts, xs, spc, noi, 
     &   inocal, nocal, nomask, 1.0, 0, 0, noname, nocmt, .false.)

*---Auto-search for lines
      ilines = 0
      do 200 i = 1 + 5, npts - 5
         if ((spc(i)-ymin).gt.signif) then
            if ((spc(i-1).le.spc(i)).and.(spc(i+1).le.spc(i)).and.
     &          (spc(i-2).le.spc(i)).and.(spc(i+2).le.spc(i)).and.
     &          (spc(i-3).le.spc(i)).and.(spc(i+3).le.spc(i)).and.
     &          (spc(i-4).le.spc(i)).and.(spc(i+4).le.spc(i)))then

*---Prospective peak found: check for significant height:
               high = spc(i)
               do 210 j = i-1, 1, -1
                  if (spc(j).gt.spc(i)) then
                     goto 220
                  else
                     high = min(high, spc(j))
                  endif
  210          continue
  220          if (spc(i)-high.lt.signif) goto 200
               
               high = spc(i)
               do 230 j = i+1, npts
                  if (spc(j).gt.spc(i)) then
                     goto 240
                  else
                     high = min(high,spc(j))
                  endif
  230          continue
  240          if (spc(i)-high.lt.signif) goto 200
             
               ilines = ilines + 1
               hlfpos(ilines) = i
               linpos(ilines) = nint(xpos(i))
               call arrow(float(i), spc(i), noi(i))
               if (ilines.eq.6) goto 300
            endif
         endif
  200 continue

  300 if (half.eq.1) then
         call message('Use these lines for fitting the '//
     &      'first half (~Y~/~N~) ?')
      elseif (half.eq.2) then
         call message('Use these lines for fitting the '//
     &      'second half (~Y~/~N~) ?')
      else
         call message('Use these lines for fitting the '//
     &      'spectrum (~Y~/~N~) ?')
      endif
      call inkey(ichr)

      if (ichr.eq.ESC) then
         ierr = -999
         goto 1000
      elseif ((ichr.eq.ichar('N')).or.(ichr.eq.ichar('n'))) then

*---Erase computer's suggestions for lines
         do 320 i = 1, ilines
            CALL ARROW(float(hlfpos(i)), spc(hlfpos(i)),
     &         noi(hlfpos(i)))
  320    continue

         ilines = 0
         ichan = 1
         do 350 i = 1, 6
            call message('Mark 4 or 6 lines; ~ENTER~: mark;'//
     &         ' ~ESC~ exits.  Cursor at: ')

            call getpnt(npts, xs, spc, noi, ichan, ichr)
            if (ichr.eq.ESC) goto 400
            ilines = ilines + 1
            hlfpos(ilines) = ichan
            linpos(ilines) = nint(xpos(ichan))
            call arrow(xs(ichan), spc(ichan), noi(ichan))
  350    continue
      elseif ((ichr.ne.ichar('Y')).and.(ichr.ne.ichar('y'))) then
         goto 300
      endif

  400 if ((ilines.ne.4).and.(ilines.ne.6)) ierr = -999

 1000 return
      end
