      SUBROUTINE CALSER(NSERIES, NAME, PARVAL, LB, UB, PTYPE, PINDEX,
     &   PARLST, minchg, ierr)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:  1991 cs & tk 
*---mru :  930602 tk; 971209 tk; 980313 tk
*---Purpose:
*     checks for the special case nseries=1; uses value, not lower bnd.
*     expects all values related to baselines will be passed as
*        scaled y-values (i.e., % absorption).
*---externals
      INTEGER NSERIES, PTYPE, PINDEX, PARLST, minchg, ierr
      REAL PARVAL, LB, UB
      CHARACTER*10 NAME
*---parameters and common blocks
      INCLUDE 'iocom.inc'
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'varcom.inc'
      INCLUDE 'mancom.inc'
      include 'constcom.inc'
*---internals
 
      integer lenact
      external lenact
      external calbas
 
      real vfree, chi2
      integer i, j, k, isub, iser, ispec, nerr, nsppts(LT1)
      integer ikonln(MLLPAR,MLOC)
      character*8 VARVAL
*---external functions
      real ystoy
      external ystoy
*-----------------------------------------------------------------------
      integer kon2i, kon2j, ij2kon
      kon2i(i) = 1 + mod(i-1, 100)
      kon2j(i) = i / 100
      ij2kon(i,j) = i * 100 + j
*-----------------------------------------------------------------------
*---executables

*---fix all linear parameters
      do 105 isub = 1, nsubs
         do 100 i = 1, ilp(3,isub)
            ikonln(i,isub) = konln(i,isub)
            konln(i,isub) = 0
  100    continue
  105 continue
      do 115 ispec = 1, nspec
         do 110 i = 1, iblp(2,ispec)
            konbl(i,ispec) = 0
  110    continue
  115 continue

      call cnstrn(konln, indln, nlnfr, MLLPAR, nsubs, ierr, nerr)
      if (ierr.ne.0) goto 1000
      call cnstrn(konbl, indbl, nblfr, MBLPAR, nspec, ierr, nerr)
      if (ierr.ne.0) goto 1000

      call getvc2

      DO 400 ispec = 1, nspec
         do 300 i = 1, iblp(2,ispec)
            pbl0(i,ispec) = ystoy(pbl0(i,ispec), cal(1,ispec))
  300    continue
 400  continue
 
*---Write over the previous series
      stktot = spctot

      if (minchg.lt.99) call intfun(minchg,ierr)
      if ((minchg.le.GNLTYP).and.(ptype.gt.GNLTYP)) call uloglo(ierr)
      if ((minchg.le.LNLTYP).and.(ptype.gt.LNLTYP)) call uloloc
      if ((minchg.le.GARTYP).and.(ptype.gt.GARTYP)) call ulogar
 
      do 800 iser = 1, nseries
         if (nseries.gt.1) then   
            vfree = float(iser-1) / (nseries-1) * (ub-lb) + lb
            minchg = ptype
         else
            vfree = parval
         endif
 
         i = kon2i(pindex)
         j = kon2j(pindex)
         
         if (ptype.eq.GNLTYP) then
            pgbest(i,j) = vfree
         elseif (ptype.eq.LINTYP) then
            pln0(i,j) = vfree
         elseif (ptype.eq.BLTYP) then
            pbl0(i,j) = ystoy(vfree, cal(1,j))
         elseif (ptype.eq.LNLTYP) then
            plbest(i,j) = vfree
         elseif (ptype.eq.GARTYP) then
            pabest(i,j) = vfree
         elseif (ptype.eq.CALTYP) THEN
            cal(i,j) = vfree
         endif

*---ASSUME that theoretical model has been initialized previously
*---(before call to CALSER) at
*---all levels.  Re-initialize now at highest appropriate level.
        if (minchg.lt.99) call intfun(minchg, ierr)
        if (ierr.ne.0) goto 1000
 
*---CALCULATE THEORETICAL SIMULATION.
        if (minchg.le.GNLTYP) call uloglo(ierr)
        if (minchg.le.LNLTYP) call uloloc
        if (minchg.le.GARTYP) call ulogar
 
*---Apply baselines and relative areas to generate final spectrum
        do 450 ispec = 1, nspec
           nsppts(ispec) = ical(1,ispec)
  450   continue

        call linfit(nlnfr, vlnb, nblfr, vblb, nsppts, spec(1,1,1),
     &     slcspc, snoys, calbas, chi2, spec(1,1,2))
 
*---Store Spectrum
        if (stktot.lt.MMAIN) stktot = stktot + 1
        call convrt(vfree, varval, .true.)
        call justif(varval, 'Left')
        spcnam(stktot) = name(1:lenact(name)) // '=' //
     &     varval(1:lenact(varval))
 
        call convrt(chi2, spccmt(1,stktot), .true.)
        do 550 k = 2, 6
          spccmt(k,stktot) = ' '
 550    continue
 
        do 650 j = 1, ical(1,1)
          spctra(j, stktot) = spec(j, 1, 2)
          spcnoi(j, stktot) = 0.
          xspc  (j, stktot) = specx(j, 1)
  650  CONTINUE

*---copy data header info from Fit Table to List
        do 700 k = 1, MCAL
           spccal(k, stktot) = cal(k, 1)
           icalsp(k, stktot) = ical(k, 1)
 700    continue

*---for simulations define model # flag and data type
           icalsp(MCAL, stktot) =
     &       (ical(10,1)/1000)*1000 + 100 + ifp(11)
 
        stkval(stktot) = vfree
        stklst(stktot) = parlst
 800  continue
 
c clear keyboard buffer before returning
 1000 call inflsh

*---Restore constraints
      do 1105 isub = 1, nsubs
         do 1100 i = 1, ilp(3,isub)
            konln(i,isub) = ikonln(i,isub)
 1100    continue
 1105 continue
      do 1115 ispec = 1, nspec
         do 1110 i = 1, iblp(2,ispec)
            konbl(i,ispec) = ij2kon(i,ispec)
 1110    continue
 1115 continue

      return
      end
