*-----------------------------------------------------------------------
      SUBROUTINE CALXI2(NLNFR1,VLNFR,NBLFR,VBLFR,RHS,SUBSP,SIG,TSPEC,
     &                  CHI2)
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INTEGER NLNFR1,NBLFR
      REAL VLNFR(NLNFR1),VBLFR(NBLFR)
      REAL TSPEC(LSPEC,LT1),SIG(LSPEC,LT1),RHS(LSPEC,LT1)
      REAL SUBSP(LSPEC,LT1,MBASIS),CHI2
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     1991 cs,  mru 26May94 cs
*
*     Given the variables found by LINFIT and the basis vectors,
*     constructs the corresponding theory spectra and calculates
*     the (non-reduced) chi-squared.
*
*     nlnfr1 : [Input]  Number of local-linear free variables;
*     vlnfr  : [Input]  Local-linear free variables;
*     nblfr  : [Input]  Number of baseline free variables;
*     vlnfr  : [Input]  Baseline free variables;
*     rhs    : [Input]  Sum of bases that had fixed coefficients;
*     subsp  : [Input]  List of basis vectors;
*     sig    : [Input]  Noise values for data (why not use snoys?);
*     tspec  : [Output] Combined basis vectors;
*     chi2   : [Output] Chi-squared value (not reduced).
*-----------------------------------------------------------------------
      INCLUDE 'parcom.inc'
 
      REAL PLINB(MLLPAR,MLOC),PBBEST(MBLPAR,LT1)
      COMMON /RLINB / PLINB,PBBEST
 
      REAL SUM
      INTEGER I,J,K
 
*-----------------------------------------------------------------------
      CHI2 = 0.
 
      DO 100 I = 1,NSPEC
        DO 50 K = 1,ICAL(1,I)
          SUM = 0.
          DO 20 J = 1,NLNFR1
            SUM = SUM + VLNFR(J)*SUBSP(K,I,J)
 20       CONTINUE
          DO 40 J = 1,NBLFR
            SUM = SUM + VBLFR(J)*SUBSP(K,I,NLNFR1+J)
 40       CONTINUE
          TSPEC(K,I) = RHS(K,I) + SUM
          IF ( SMASK(K,I) ) THEN
            IF ( SIG(K,I).GT.0 ) THEN
              CHI2 = CHI2 + ((SPEC(K,I,1)-TSPEC(K,I))/SIG(K,I))**2
            ELSE
              CHI2 = CHI2 + (SPEC(K,I,1)-TSPEC(K,I))**2
            ENDIF
          ENDIF
 50     CONTINUE
 100  CONTINUE
 
      CALL CNSAPP(NLNFR1,VLNFR,MLLPAR,NSUBS,PLN0,PLNLB,PLNUB,PLINB,
     &            INDLN,KONLN,WEILN)
      CALL CNSAPP(NBLFR,VBLFR,MBLPAR,NSPEC,PBL0,PBLLB,PBLUB,PBBEST,
     &            INDBL,KONBL,WEIBL)
 
      RETURN
      END
