      SUBROUTINE CAN512(FILNAM,MD,SPEC,NTX,TEXT,ICAL,RCAL,IERR)
C
C     1.READ a nchans=512 channel SPECTRUM AND ITS HEADER from ASCII file.
*       THIS FORMAT COMPATIBLE WITH FILES CREATED BY PRINT COMMAND
*       IN CANBERRA'S MCA PROGRAM.
*     2. fold the spectrum
*     3. return folded nchans/2 channel spectrum in SPEC
 
C       HEADER IS FOLLOWED BY A REAL ARRAY CONTAINING THE
C       SPECTRAL DATA.  LOWER BOUND SUBSCRIPT OF THE ARRAY
C       IS 1.   UPPER BOUND SUBSCRIPT IS NCHANS=ical(1).
C
C  FWBI  RLT   10/23/75 MRU 950503 TK
C --------------------------------------------------
      INCLUDE 'iocom.inc'
      INCLUDE 'limits.inc'
*---externals
      CHARACTER FILNAM*(*),TEXT(6)*72
      REAL SPEC(MD),RCAL(*)
      INTEGER I,ICAL(*),IERR
      INTEGER NTX
*---external funcions
      logical getyn
      external getyn
*---internals
      INTEGER NSP,ISPEC(2*lspec), md, iii, nchans, nf
      REAL TMPSPC(2*lspec)
      CHARACTER KEY*6
      REAL NONOYS(2*LSPEC),XPOS(2*LSPEC),NOCAL(MCAL)
      INTEGER INOCAL(MCAL)
      LOGICAL NOMASK(2*LSPEC)
      CHARACTER NOCMT(6)*72
*---define no cal values
      save nocal, nocmt
      DATA NOCAL/0.,0.,100.,1.,0.,0.,1.,0.,0.,0./
      DATA NOCMT/6*' '/
*---------------------------------------------------------------------------
*---executables
*---950503 patch tk 
      nchans = 512

*---initialize data header values so that raw data may be plotted.
      DO 100 I = 1,6
        TEXT(I) = ' '
 100  CONTINUE
         DO 400 I = 1,mcal
            ICAL(I) = 0
  400    CONTINUE
         DO 500 I = 1,mcal
            RCAL(I) = 0.0
  500    CONTINUE
         ICAL(2) = 1
*---set file type (see readsp.for)
         ical(5) = 6
*---SET baseline to 1.0
         rcal(3)=1.0
*---set area to 1.0
         rcal(4)=1.0

C OPEN FILE
      OPEN (JDISK,FILE=FILNAM,IOSTAT=IERR)
      IF ( IERR.NE.0 ) RETURN
 
C READ IN THE HEADER

C READ IN THE unfolded nchans channel SPECTRUM
      DO 200 III = 1,nchans/5
 150    READ (JDISK,9001,IOSTAT=IERR,END=600) KEY,
     &        (ISPEC(I+5*(III-1)),I=1,5)
        IF ( KEY(6:6).NE.':' ) GOTO 150
 200  CONTINUE
      READ (JDISK,9002,IOSTAT=IERR,ERR=600) 
     &  ISPEC(nchans-1),ISPEC(nchans)
 
      CLOSE (JDISK)
*---convert to floating point storage
      TMPSPC(1) = ISPEC(2)
      DO 300 I = 2,nchans
        TMPSPC(I) = ISPEC(I)
 300  CONTINUE

***
*---display raw data
          do 350 i=1,nchans
             xpos(i)=i
             nonoys(i)=0.0
             nomask(i)=.true.
  350     continue
      CALL SHODAT(.TRUE.,Nchans,XPOS,tmpspc,NONOYS,INOCAL,NOCAL,
     &   NOMASK,1.0,0,0,FILNAM,NOCMT,.FALSE.)

      NSP = nchans
         call message(' ')
      if(getyn('Fold data ?'))then
*----fold spectrum
         CALL FALT(filnam, nsp, tmpspc, nf, spec, rcal(5), rcal(6),
     &      rcal(7), ierr)
         if (ierr.eq.0) ical(1) = nf
      else
*---do not fold spectrum
         call fixsawth(filnam,tmpspc,spec,nsp,rcal(5),rcal(6),
     &      rcal(7),ierr)
         if (ierr.eq.0) ical(1) = nsp
      endif
***
         
      RETURN
 
  600 continue
*      CALL MESSAGE('End-of-File Error')
 
      RETURN
 9001 FORMAT (A6,4(I11,2X),I11)
 9002 FORMAT (6X,I11,2X,I13)
      END
