      SUBROUTINE CATFUN(CAT,NPTS,XS,YS)

*--- PION 110620: replace gcoln()
*-----------------------------------------------------
*--- PLOT branch for all spectra with CAT.NE.0 (theory or residuals, or ... some result)
*---1. Set plotting mode.
*---2. Set color.
*---3. If needed, erase old spectrum.
*---4. Store new data for later erase.
*---5. Reset plotting mode.
 
      INCLUDE 'limits.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'plotcom.inc'
      INTEGER CAT,NPTS,I
      REAL XS(NPTS),YS(NPTS)
 
      INTEGER MCOLS
      PARAMETER (MCOLS=4)
 
      INTEGER COLORS(0:MCOLS-1)
 
*---0. Initialize "Other spectrum" colors
      COLORS(0) = 176
      COLORS(1) = 128
      COLORS(2) = 96
      COLORS(3) = 64
 
*---1. Set plotting mode to XOR
      CALL GPLOTM('E')
 
*---2. Set color
      IF ( CAT.EQ.1 ) THEN
	call igrcolourn(THRCOL)
c        CALL GCOLN(THRCOL)
      ELSEIF ( CAT.EQ.2 ) THEN
	call igrcolourn(RESCOL)
c        CALL GCOLN(RESCOL)
      ELSEIF ( CAT.GT.OTHOFF ) THEN
	call igrcolourn(COLORS(MOD(CAT-OTHOFF,MCOLS)))
c        CALL GCOLN(COLORS(MOD(CAT-OTHOFF,MCOLS)))
      ELSEIF ( CAT.LT.0 ) THEN
	call igrcolourn(SUBCOL)
c        CALL GCOLN(SUBCOL)
      ENDIF
*---3. If needed, do fast-erase and reset toggle.
      IF ( CAT.EQ.1 .AND. TB4 ) THEN
        CALL THRERA
        TB4 = .FALSE.
      ENDIF
      IF ( CAT.EQ.2 .AND. RB4 ) THEN
        CALL RESERA
        RB4 = .FALSE.
      ENDIF
      IF ( CAT.GT.OTHOFF ) THEN
        IF ( OB4(CAT-OTHOFF) ) THEN
          CALL OTHERA(CAT-OTHOFF)
          OB4(CAT-OTHOFF) = .FALSE.
        ENDIF
      ENDIF
      IF ( CAT.LT.0 ) THEN
        IF ( SB4(-CAT) ) THEN
          CALL SUBERA(-CAT)
          SB4(-CAT) = .FALSE.
        ENDIF
      ENDIF
 
*---4. Store new data for later erase
      IF ( CAT.EQ.1 ) THEN
*---STORE THEORY IN THRSPC
        TBOUND(1) = 1
        TBOUND(2) = NPTS
        DO 50 I = TBOUND(1),TBOUND(2)
          THRSPC(I) = YS(I)
          THRX(I) = XS(I)
 50     CONTINUE
      ELSEIF ( CAT.EQ.2 ) THEN
*---STORE RESIDUALS
        RBOUND(1) = 1
        RBOUND(2) = NPTS
        DO 100 I = RBOUND(1),RBOUND(2)
          RESSPC(I) = YS(I)
          RESX(I) = XS(I)
 100    CONTINUE
      ELSEIF ( CAT.GT.OTHOFF ) THEN
*---STORE SOME OTHER SPECTRUM
        OBOUND(1) = 1
        OBOUND(2) = NPTS
        DO 150 I = OBOUND(1),OBOUND(2)
          OTHSPC(I,CAT-OTHOFF) = YS(I)
          OTHX(I,CAT-OTHOFF) = XS(I)
 150    CONTINUE
      ELSEIF ( CAT.LT.0 ) THEN
*---STORE Sub-spectrum
        SBOUND(1) = 1
        SBOUND(2) = NPTS
        DO 200 I = SBOUND(1),SBOUND(2)
          SBSPC(I,ABS(CAT)) = YS(I)
          SBX(I) = XS(I)
 200    CONTINUE
      ENDIF
 
*---5. Reset plotting mode to normal
      CALL GPLOTM('N')
 
      RETURN
      END
