      subroutine cndns
*---Purpose: Condense spectrum by summing pairs. Nchan <-- Nchan/2
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 960102 tk
*---mru:  971215 tk
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'iocom.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'togcom.inc'
 
      INTEGER I,npts
      real tmpspc(lspec)
*-----------------------------------------------------------------------
*---executables
      IF ( SPCTOT.GT.0 ) THEN

*---actspc points to active spectrum on LIST.

C Calculate unnormalized spectrum
      npts = icalsp(1,actspc)
      do 200 i = 1, npts
         tmpspc(i) = spccal(3,actspc) + spccal(4,actspc) *
     &      spctra(i,actspc)
  200 continue

*---divide number of channel in active spectrum by 2.
      npts=npts/2

*---sum pairs and store
           do 100 i=1,npts
              spctra(i,actspc) = tmpspc(2*i-1)+tmpspc(2*i)
  100      continue

*---store new number of channel
           icalsp(1,actspc)=npts

*---zero extra storage
      do 210 I = npts+1, lspec
         spctra(i,actspc) = 0.
  210 continue

*---Calc. new calibration constants
*---Folding point:  no meaning now
      spccal(5,actspc) = 0
*---vel. = 0 channel
      spccal(6,actspc) = 0.5*spccal(6,actspc) + 0.25
*---step
      spccal(7,actspc) = 2.0*spccal(7,actspc)

*---normalize new spectrum (also store new baseline and area)
           CALL MBNORM(npts,spctra(1,actspc),mcal,icalsp(1,actspc),
     &                 spccal(1,actspc))
*---adjust velocity scale values and noise values.
           call caladj(mcal,spccal(1,actspc),icalsp(1,actspc),
     &        icalsp(1,actspc),xspc(1,actspc),spctra(1,actspc),
     &        spcnoi(1,actspc))

*---Update screen with new plot and numerical info.
          CALL SHOACT(.FALSE.)

       else
         call errmsg('No data loaded.')
      ENDIF
 
      RETURN
      END
