      SUBROUTINE CNSAPP(NFREE,VFREE,ROWS,COLS,P0,PLB,PUB,P,IND,KON,WEI)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:
*     G. Lang and B. W. Dale, Harwell, 1973
*     T. K. 11/81
*     Enhanced by CS 29Oct92 to use negative ind values (see cnstrn).
*---mru :  15Jul93 cs
*---Purpose:  Applies constraints ala' G. Lang and B. W. Dale
*----------------------------------------------------------------------
*---externals
*     nfree  : [Input]  Number of free variable values;
*     vfree  : [Input]  Array of free variable values;
*     rows   : [Input]  Bound for vfree array
*     cols   : [Input]    "    "    "     "
*     p0     : [Input]  Initial parameter values;
*     pub    : [Input]  Parameter upper bounds
*     plb    : [Input]  Parameter lower bounds
*     p      : [Output] Parameter array with variables inserted;
*     ind    : [Input]  Pointers from parameters to free variables;
*     kon    : [Input]  Constraint codes from parameter file
*     wei    : [Input]  Array of weights (used for dependent variables).
      INTEGER NFREE,ROWS,COLS
      REAL VFREE(NFREE),P(ROWS,COLS),P0(ROWS,COLS)
      REAL PLB(ROWS,COLS),PUB(ROWS,COLS),WEI(ROWS,COLS)
      INTEGER IND(ROWS,COLS),KON(ROWS,COLS)
*---internals
      INTEGER I,J,IND1,INDNUM,INDSUB
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
 
      DO 100 J = 1,COLS
        DO 50 I = 1,ROWS
          IND1 = IND(I,J)
          IF ( IND1.EQ.0 ) THEN
            P(I,J) = P0(I,J)
          ELSEIF ( IND1.GT.0 ) THEN
            P(I,J) = VFREE(IND1)*WEI(I,J)
          ELSE
            INDNUM = 1 + MOD((-IND1)-1,100)
            INDSUB = (-IND1)/100
            P(I,J) = P0(INDNUM,INDSUB)
          ENDIF
 50     CONTINUE
 100  CONTINUE
 
      RETURN
      END
