*-----------------------------------------------------------------------
      SUBROUTINE CNSTRN(KON,IND,NFREE,ROWS,COLS,IERR,NERR)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*   Orig tk 11/81, mru 19Sep93 cs
*  Sets up constraint vector ind ala George Lang & B. W. Dale.
*  Enhanced by CS 29Oct92:  Added possibility of negative ind values
*     and out-of-order or chained constraint codes.  A negative
*     ind value -i signifies that the parameter is to be fixed at
*     the initial value of parameter #i;  this comes up if a constraint
*     code points to a fixed parameter.
*
*     kon    : (input) array of constraint codes
*     ind    : (output) array of ind values for CNSAPP
*     nfree  : (output) number of free variables
*     nall   : (input) length of kon & ind arrays
*     ierr   : (output) nonzero if and only if the constraints
*            : are invalid.
*     nerr   : (output) constraint number involved in the error.
*-----------------------------------------------------------------------
      INTEGER NFREE,ROWS,COLS,IERR,NERR
      INTEGER KON(ROWS,COLS),IND(ROWS,COLS)
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
 
      INTEGER EMPTY,VISITING,DONE
      PARAMETER (EMPTY=1,VISITING=2,DONE=3)
 
      INTEGER I,J,K,INDVAL,NEXT,STACK(MVAR),TOP
      INTEGER ISTACK,JSTACK,INEXT,JNEXT
      INTEGER STATUS(MVAR,MVAR)
*-----------------------------------------------------------------------
      INTEGER IJ2KON,KON2I,KON2J
      IJ2KON(I,J) = I + 100*J
      KON2I(I) = 1 + MOD(I-1,100)
      KON2J(I) = I/100
*-----------------------------------------------------------------------
 
      IERR = 0
      NERR = 0
      NFREE = 0
 
c     /* Do the easy cases: Fixed parameters and totally free variables */
      DO 100 J = 1,COLS
        DO 50 I = 1,ROWS
          IF ( KON(I,J).EQ.IJ2KON(I,J) ) THEN
            NFREE = NFREE + 1
            IND(I,J) = NFREE
            STATUS(I,J) = DONE
          ELSEIF ( KON(I,J).EQ.0 ) THEN
            IND(I,J) = 0
            STATUS(I,J) = DONE
          ELSE
            STATUS(I,J) = EMPTY
          ENDIF
 50     CONTINUE
 100  CONTINUE
 
c     /* Do the more difficult cases: dependent variables */
      DO 200 J = 1,COLS
        DO 150 I = 1,ROWS
          IF ( STATUS(I,J).EQ.EMPTY ) THEN
            TOP = 1
            STACK(TOP) = IJ2KON(I,J)
            STATUS(I,J) = VISITING
 
 110        ISTACK = KON2I(STACK(TOP))
            JSTACK = KON2J(STACK(TOP))
            NEXT = KON(ISTACK,JSTACK)
            INEXT = KON2I(NEXT)
            JNEXT = KON2J(NEXT)
            IF ( STATUS(INEXT,JNEXT).EQ.EMPTY ) THEN
              TOP = TOP + 1
              STACK(TOP) = NEXT
              STATUS(INEXT,JNEXT) = VISITING
              GOTO 110
            ELSEIF ( STATUS(INEXT,JNEXT).EQ.VISITING ) THEN
c                 /* Cyclic constraints detected */
              IERR = -1
              NERR = STACK(TOP)
              GOTO 300
            ENDIF
 
c              /* We've reached the end of a chain of constraints */
            IF ( KON(INEXT,JNEXT).EQ.0 ) THEN
              INDVAL = -NEXT
            ELSE
              INDVAL = IND(INEXT,JNEXT)
            ENDIF
 
c              /* Unwind back up along the chain */
            DO 120 K = TOP,1, - 1
              ISTACK = KON2I(STACK(K))
              JSTACK = KON2J(STACK(K))
              IND(ISTACK,JSTACK) = INDVAL
              STATUS(ISTACK,JSTACK) = DONE
 120        CONTINUE
          ENDIF
 150    CONTINUE
 200  CONTINUE
 
 300  RETURN
      END
