*---File: CONSTDEF.INC
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:
*---mru 930602 tk; 971215 tk
*-------------------------------------------------------------------
*---define constants used by MAIN and some subroutines

*--Pi
      pi = atan2(0.0,-1.0)
*---degrees per radian
      rpd = pi/180.
*---radians per radian
      dpr = 180./pi
*---Bohr magneton [(1/cm)/kGauss]    (Data files have H in kG.)
      betae = 0.0466872
*---N beta [Joules/(Tesla mole)]  (SI units for magnetization calc.)
      betaN = 5.584892
*---Boltzman constant [(1/cm)/Kelvin]
      Bk = 0.695028
*---Bohr Magneton / Boltzman constant    [ Kelvin / kGauss ]
      bvk = betae/Bk
*---Minimun Lorenztian width observable [mm/s]
      fwhml0 = 0.19
*---splitting of a Fe metal spectrum [MM/S]
      dv16 = 10.66
      dv25 = 6.17
      dv34 = 1.68
*---limit & counter for number of files loaded under "demo" license.
      mfldmo= -1
      nfldmo=  0
*---Path separator character
*---Set by default to "\"; note that many UNIX
*---FORTRAN compilers require a backslash in a string to be 
*---denoted \\, as in C, so the backslash is here represented in ASCII.
      pthsep = char(92)
*---demo floppy path
*---      dmopth = 'A:'//pthsep
*---Program name
      prog = 'WMOSS'  
*-------------------------------------------------------------------

      rcalnm(1) = 'Field [kG]'
      rcalnm(2) = 'Temperature [K]'
      rcalnm(3) = 'Baseline'
      rcalnm(4) = 'Area'
      rcalnm(5) = 'Folding Point'
      rcalnm(6) = 'V=0 Channel'
      rcalnm(7) = 'Step [mm/s/chan]'
      rcalnm(8) = 'Noise [norm.] '
      rcalnm(9) = 'Aquisition Time [s] '
      rcalnm(10) = ' '

      icalnm(1) = 'Channels'
      icalnm(2) = 'Record'
      icalnm(3) = 'Pol.(0=Par,-1=Trans)'
      icalnm(4) = 'Relax(0=Fast,1=Slow)'
      icalnm(5) = 'File Version (1)'
      icalnm(6) = ' '
      icalnm(7) = ' '
      icalnm(8) = ' '
      icalnm(9) = ' '
      icalnm(mcal) = 'Data type'

*---Set WEBDIR string via WEBDIR environment variable; otherwise
*---set WEBDIR to be the directory from which the program was started.
c      call osvar('WEBDIR',webdir)
c      weblen = lenact(webdir)
      weblen=0
      if (weblen.eq.0) then
        webdir = '\web\'
	weblen = lenact(webdir)
        pgmdir = '\web\mos\'
      else
      	pgmdir = webdir(1:weblen)//'mos'//webdir(weblen:weblen)
      endif
      pgmlen = lenact(pgmdir)

*---internal defaults for some software configuration switches
      scrfil = 'vga.scr'
      psport = 'lpt1'
      ljport = 'lpt1'
      hpglport = 'lpt1'
      epport = 'lpt1'
      txport = 'lpt1'
      psinit = pgmdir(1:pgmlen)//'psinit.mos'
      psout  = pgmdir(1:pgmlen)//'psout'
      monte  = 'monte.out'
      pfmask = '*.pi'
      sfmask = '*.b'
      ugrprt = 'lpr'
      utxprt = 'lpr'
      
*---Set default shell: command.com for MSDOS
      shell = 'cmd.com'

      temp0  = 10
      
