*-----------------------------------------------------------------------
      SUBROUTINE CONVRT(PARAM,INSTR,STRIP)
*-----------------------------------------------------------------------
      REAL PARAM
      LOGICAL STRIP
      CHARACTER*8 INSTR
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     cs, mru 26Jul93 cs
*
*     param  : [Input]  Value to be converted;
*     instr  : [Output] Real value as a string;
*     strip  : [Input]  Should trailing zeros, periods be removed?
*-----------------------------------------------------------------------
      INTEGER LEN
      REAL TOL
      PARAMETER (LEN=8,TOL=5.E-7)
 
      REAL APARAM,EXPNT
      INTEGER DECLEN,MINWID,DIGITS,LEN2,L,LEXPT,LFRAC,IEXP
      CHARACTER FRMAT*8,INSTR2*14,EXPT*3,FRAC*9
 
      INTEGER LENACT
      EXTERNAL LENACT
 
      CHARACTER*1 DIGCHR
      INTEGER IDIG
*-----------------------------------------------------------------------
      DIGCHR(IDIG) = CHAR(IDIG+ICHAR('0'))
 
*---aparam = abs(param)
*---minwid = number of characters to leave for a leading minus sign
      IF ( PARAM.LT.0 ) THEN
        MINWID = 1
        APARAM = -PARAM
      ELSE
        MINWID = 0
        APARAM = PARAM
      ENDIF
 
      IF ( APARAM.GE.(1.-TOL) ) THEN
*---digits = number of digits to the left of the decimal
        DIGITS = AINT(LOG10(APARAM)) + 1
        DECLEN = (LEN-1) - (DIGITS+MINWID)
      ELSEIF ( APARAM.GT.0 ) THEN
        DIGITS = 1
c         DECLEN = LEN - 1 - DIGITS - MINWID
        DECLEN = LEN - DIGITS - MINWID
      ELSE
        DIGITS = 0
        DECLEN = 0
      ENDIF
 
      IF ( STRIP .AND. (DIGITS+MINWID).LT.LEN ) THEN
*---Floating format
        FRMAT = '(F'//DIGCHR(LEN)//'.'//DIGCHR(DECLEN)//')'
        WRITE (INSTR,FRMAT) PARAM
        LEN2 = LEN
*---Loop to remove trailing zeros
 50     IF ( (INSTR(LEN2:LEN2).EQ.' ') .OR. (INSTR(LEN2:LEN2).EQ.'0') )
     &       THEN
          LEN2 = LEN2 - 1
          GOTO 50
        ENDIF
        FRMAT = '(F'//DIGCHR(LEN)//'.'//DIGCHR(DECLEN+LEN2-LEN)//')'
        WRITE (INSTR,FRMAT) PARAM
        CALL JUSTIF(INSTR,'L')
*---Remove trailing decimal point
        L = LENACT(INSTR)
        IF ( INSTR(L:L).EQ.'.' ) INSTR(L:L) = ' '
*---Remove leading zero if 0 < |param| < 1.
        IF ( (ABS(PARAM).LT.1) .AND. (ABS(PARAM).GT.0) ) THEN
          INSTR2 = INSTR
          IF ( INSTR(1:2).EQ.'0.' ) THEN
            INSTR = INSTR2(2:)
          ELSEIF ( INSTR(1:3).EQ.'-0.' ) THEN
            INSTR = '-'//INSTR2(3:)
          ENDIF
        ENDIF
        GOTO 200
********************************************************
** 8-digit numbers like 12345678 could be displayed,
** in non-exponential format, but this is beyond the
** precision of a real*4.  [instr3 must be char*(len+1)]
********************************************************
**      elseif (strip.and.(digits+minwid).eq.len) then
**        frmat = '(F'//digchr(len+1)//'.0)'
**        call reastr(param,instr3,frmat)
**        instr = instr3(1:len)
*******************************************************
      ELSEIF ( .NOT.STRIP .AND. DIGITS+MINWID.LE.4 .AND. APARAM.GT..1 )
     &         THEN
        WRITE (INSTR,'(F8.3)') PARAM
        GOTO 200
      ELSEIF ( .NOT.STRIP .AND. APARAM.EQ.0. ) THEN
        INSTR = '   0.000'
        GOTO 200
      ELSEIF ( .NOT.STRIP .AND. APARAM.GE..001 .AND. APARAM.LE.0.1 )
     &         THEN
        IF ( ABS(ANINT(APARAM*1000.)-APARAM*1000).LT.1E-3 ) THEN
          WRITE (INSTR,'(F8.3)') PARAM
          GOTO 200
        ENDIF
      ENDIF
 
c     ;; Exponential Format Required
      EXPNT = LOG10(ABS(PARAM))
      IF ( EXPNT.GT.0 ) THEN
        IEXP = INT(EXPNT)
      ELSEIF ( EXPNT.GE.AINT(EXPNT) ) THEN
        IEXP = AINT(EXPNT)
      ELSE
        IEXP = AINT(EXPNT) - 1
      ENDIF
      WRITE (INSTR2,'(I3)') IEXP
      IF ( INSTR2(1:1).NE.' ' ) THEN
        LEXPT = 3
      ELSEIF ( INSTR2(2:2).NE.' ' ) THEN
        LEXPT = 2
      ELSE
        LEXPT = 1
      ENDIF
      EXPT = INSTR2(4-LEXPT:)
      LFRAC = 8 - 2 - LEXPT
      WRITE (INSTR2,'(E14.7)') ABS(PARAM)
      IF ( PARAM.GT.0 ) THEN
        FRAC = INSTR2(4:4)//'.'//INSTR2(5:LFRAC+3)
      ELSE
        FRAC = '-'//INSTR2(4:4)//'.'//INSTR2(5:LFRAC+2)
      ENDIF
      IF ( STRIP ) THEN
 100    IF ( FRAC(LFRAC+1:LFRAC+1).EQ.'0' ) THEN
          LFRAC = LFRAC - 1
          GOTO 100
        ENDIF
        IF ( FRAC(LFRAC+1:LFRAC+1).EQ.'.' ) LFRAC = LFRAC - 1
      ENDIF
      INSTR = FRAC(1:LFRAC+1)//'e'//EXPT
 
 200  RETURN
      END
