      SUBROUTINE DATPLT(NPTS,X,Y,YNOI,MSK,KSYM,SIZE,ZERO,CAT)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig tk 1991
*---mru 931202 tk
*     Plots a section of the arrays x,y with symbol defined by "ksym"
*     and "size".
*     Use window defined by axes box as stored in common/pbox/
*     Use data units as stored in common /pbox/
*
*     Colors are dependant upon SPCMSK in 'speccom.inc'.
*     npts   : number of points to plot
*     x      : starting address of x coordinates
*     y      : starting address of y coordinates
*     ynoi   : half height of vertical error bars
*     ksym   : code for plotting symbol
*     size   : size of plotting symbol
*     zero   : logical switch for starting line plot at origin
*     cat    : catagory index. If(cat.ne.0)then [set color and fast erase]
*
*--- ksym    plot symbol
*---  -1      vertical error bars (+/-ynoi)
*---   0      line plot, no marker
*--- 1 to 10  symbol as defined in Interacter routine GMRKRA
*---  11      single dots (circles of radius defined below)
*-----------------------------------------------------------------------
*---parameters and common blocks
      INCLUDE 'limits.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'plotcom.inc'
      INCLUDE 'togcom.inc'
*---externals
      INTEGER NPTS,KSYM,CAT
      REAL X(NPTS),Y(NPTS),YNOI(NPTS)
      REAL SIZE
      LOGICAL MSK(NPTS),ZERO
*--internals
      INTEGER I
      REAL RADIUS
*-------------------------------------------------------------------------
*---executables
*---define window and units (see common /pbox/)
      CALL GAREA(PA1,QA1,PA2,QA2)
      CALL GUNIT(XA1,YA1,XA2,YA2)
 
*---define radius of circles used by ksym=11 "dots"
      RADIUS = 0.5*ABS(XA2-XA1)/400.0
 
*---select plotting mode and, if cat<>0, set color and fast-erase
      IF ( CAT.EQ.0 ) THEN
        CALL GPLOTM('N')
      ELSE
        CALL CATFUN(CAT,NPTS,X,Y)
        CALL GPLOTM('E')
      ENDIF
*---define plotting symbol size relative to standard text size
      CALL GCHSIZ(1.0*SIZE,0.5*SIZE)
*---Start line plot at origin?
      IF ( ZERO .AND. KSYM.EQ.0 ) THEN
        CALL GMOVEA(0.0,0.0)
      ELSEIF ( YFLIP ) THEN
        CALL GMOVEA(X(1),-Y(1))
      ELSE
        CALL GMOVEA(X(1),Y(1))
      ENDIF
*---plot the data
      DO 100 I = 1,NPTS
*---if data plot, check mask
        IF ( CAT.EQ.0 ) THEN
          IF ( MSK(I) ) THEN
            CALL GNORMC()
          ELSE
            CALL GMASKC()
          ENDIF
        ENDIF
*---choose plotting symbol
 
        IF ( (KSYM.EQ.11) .OR. 
     &       ((CAT.EQ.0) .AND. .NOT.MSK(I) .AND. PRNTNG) ) THEN
*---Point plot
          IF ( YFLIP ) THEN
*               call gpoina(x(i),-y(i))
            CALL GCIRCA(X(I),-Y(I),RADIUS)
          ELSE
*               call gpoina(x(i),y(i))
            CALL GCIRCA(X(I),Y(I),RADIUS)
          ENDIF
        ELSEIF ( KSYM.EQ.0 ) THEN
*---line plot
          IF ( YFLIP ) THEN
            CALL GLINEA(X(I),-Y(I))
          ELSE
            CALL GLINEA(X(I),Y(I))
          ENDIF
          CALL GPOINR(0.0,0.0)
        ELSEIF ( (KSYM.EQ.-1) .AND. (MSK(I) .OR. .NOT.PRNTNG) ) THEN
*---vertical error bars
          IF ( YFLIP ) THEN
            CALL GMOVEA(X(I),-Y(I)-YNOI(I))
          ELSE
            CALL GMOVEA(X(I),Y(I)-YNOI(I))
          ENDIF
          CALL GLINER(0.0,2.0*YNOI(I))
*---Interacter marker plot
*---PION : fixing vertical bars
c        ELSEIF ( YFLIP ) THEN
* corrected section
        ELSEIF ((KSYM.GT.0).AND.(KSYM.LT.11)) THEN
	    IF ( YFLIP ) THEN
*
            CALL GMRKRA(X(I),-Y(I),MOD(KSYM,10))
          ELSE
            CALL GMRKRA(X(I),Y(I),MOD(KSYM,10))
*
          ENDIF
*
	  ENDIF
 100  CONTINUE
 
*---Set Fast-Erase Toggle
      IF ( CAT.EQ.1 ) TB4 = .TRUE.
      IF ( CAT.EQ.2 ) RB4 = .TRUE.
      IF ( CAT.GT.OTHOFF ) OB4(CAT-OTHOFF) = .TRUE.
      IF ( CAT.LT.0 ) SB4(-CAT) = .TRUE.
 
*---restore default character size & plotting mode
      CALL GCHSIZ(1.0,1.0)
      CALL GPLOTM('N')
 
      RETURN
      END
