*-----------------------------------------------------------------------
      SUBROUTINE DELSUB(ISUBDL,IERR)
*-----------------------------------------------------------------------
      INTEGER ISUBDL,IERR
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     03Aug93 cs
*
*     Deletes subsite #ISUB and moves all following subsites one down.
*     Will not delete a subsite if there is only one remaining.
*
*     isubdl : [Input]  Subsite number to delete;
*     ierr   : [Output] Error code.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'errcodes.inc'
 
      INTEGER I,J,ISUB,IPAR
*-----------------------------------------------------------------------
      INTEGER IJ2KON,KON2I,KON2J
 
      IJ2KON(I,J) = I + 100*J
      KON2I(I) = 1 + MOD(I-1,100)
      KON2J(I) = I/100
*-----------------------------------------------------------------------
 
      IF ( (NSUBS.LE.1) .OR. (ISUBDL.GT.NSUBS) ) THEN
        IERR = ERRTOOFEWSITES
        CALL ERRMSG('~Error~:  Too few subsites to do delete!')
      ELSE
c        ;; Move down all following subsites
        DO 50 ISUB = ISUBDL + 1,NSUBS
          CALL CPYLOC(ISUB,ISUB-1,.FALSE.)
 50     CONTINUE
        NSUBS = NSUBS - 1
 
c        ;; Correct constraints for the moved subsites
        DO 100 ISUB = 1,NSUBS
c           ;; Nonlinear constraints
          DO 60 IPAR = 1,ILP(2,ISUB)
            I = KON2I(KONL(IPAR,ISUB))
            J = KON2J(KONL(IPAR,ISUB))
            IF ( J.EQ.ISUBDL ) THEN
              KONL(IPAR,ISUB) = 0
            ELSEIF ( J.GT.ISUBDL ) THEN
              KONL(IPAR,ISUB) = IJ2KON(I,J-1)
            ENDIF
 60       CONTINUE
 
c           ;; Linear constraints
          DO 80 IPAR = 1,ILP(3,ISUB)
            I = KON2I(KONLN(IPAR,ISUB))
            J = KON2J(KONLN(IPAR,ISUB))
            IF ( J.EQ.ISUBDL ) THEN
              KONLN(IPAR,ISUB) = 0
            ELSEIF ( J.GT.ISUBDL ) THEN
              KONLN(IPAR,ISUB) = IJ2KON(I,J-1)
            ENDIF
 80       CONTINUE
 100    CONTINUE
        IERR = NOERROR
      ENDIF
 
      RETURN
      END
