      SUBROUTINE DOFIT(FITOPT)
*-----------------------------------------------------------------------
      INTEGER FITOPT
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig tk & cs 1992
*---mru 940126 tk; 19980313 tk
*
*     Does pre- and post-processing for a fit.  Assumes everything
*     is set up properly (data picked, parameters loaded, etc.)
*
*     fitopt : [Input] 1) Least-Squares Fit;
*                      2) Least-Squares Fit w/o saving results to list;
*                      3) Non-Interactive Fit w/o saving results.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'bestcom.inc'
      INCLUDE 'constcom.inc'
 
      INTEGER I,ISPC,ISUB,ISPEC,IERR
      CHARACTER*2 SUBSTR
 
      REAL PGBEST(MGPAR,MGLO),XI2BST
      COMMON /RGBEST/ PGBEST,XI2BST
 
      INTEGER LENACT
      EXTERNAL LENACT
 
      REAL NONOYS(LSPEC)
      LOGICAL NOMSK(LSPEC)
      SAVE NONOYS,NOMSK
      DATA NONOYS,NOMSK/LSPEC*0.0,LSPEC*.TRUE./
*-----------------------------------------------------------------------
 
      IF ( (FITOPT.LT.1) .OR. (FITOPT.GT.3) ) THEN
        CALL ERRMSG('~Internal Error~:  Bad argument to DOFIT!')
        GOTO 300
      ENDIF
 
c     ;; Clear screen
      CALL CLRALL
      CALL NORMAL
 
c     ;; Initialize fitting
      REPSPC = 1
      FITTING = .TRUE.
 
c     ;; Initialize parm file comments
      WRITE (PARCMT(4),9001) (SNAME(I)(1:8),I=1,NSPEC)
      WRITE (PARCMT(3),'(A20)') 'Best chi-squared undetermined.'
 
c     ;; Initialize fit table
      IF ( FITOPT.EQ.1 ) THEN
        CALL MAKTAB(0)
        CALL NUDATA(.FALSE.)
      ENDIF
*-------------------------------
c     ;; Do fit
      CALL PSUBAY(IERR)
      IF ( IERR.NE.0 ) GOTO 300
*-------------------------------
 
c     ;; Update parameter vector
      IF ( FITOPT.NE.3 ) CALL MAKVEC
 
      IF ( FITOPT.NE.2 ) THEN
        IF ( FITOPT.EQ.3 ) GOTO 200
 
c     ;; Copy fit results into list
        DO 50 ISPEC = 1,NSPEC
          IF ( SPCTOT.GE.MMAIN ) GOTO 100
 
c        ;; Theory Spectrum
          SPCTOT = SPCTOT + 1
          CALL AD2LST(SPCTOT,'Th '//SNAME(ISPEC),SCOMNT(1,ISPEC),
     &                RESPONSE(1,ISPEC,0,0),NONOYS,SPECX(1,ISPEC),NOMSK,
     &                CAL(1,ISPEC),ICAL(1,ISPEC))
*------------------------------------------------------------------------
*---971210 tk: set type to (data type + theory flag + model number )
*---980313 tk: truncate picked spectrum type to normal data type.
      icalsp(10,spctot) =
     &  (icalsp(10,spctot)/1000)*1000 + 100 + IFP(11)
*------------------------------------------------------------------------
 
*---Subspectra
          IF ( STOSUB ) THEN
            DO 10 ISUB = 1,NSUBS
              IF ( SPCTOT.GE.MMAIN ) GOTO 100
              SPCTOT = SPCTOT + 1
              CALL INTSTR(ISUB,SUBSTR,'(I2)')
              CALL AD2LST(SPCTOT,'Sub'//SUBSTR(1:LENACT(SUBSTR))
     &                    //':'//SNAME(ISPEC),SCOMNT(1,ISPEC),
     &                    RESPONSE(1,ISPEC,ISUB,0),NONOYS,SPECX(1,ISPEC)
     &                    ,NOMSK,CAL(1,ISPEC),ICAL(1,ISPEC))

*980313 tk:???????????????????????????????????????????????????????????????
      icalsp(10,spctot) =
     &  (icalsp(10,spctot)/1000)*1000 + 100 + IFP(11)
*              IF ( (PROG.EQ.'WMAG') .OR. (PROG.EQ.'WEPR') ) THEN
*                ICALSP(MCAL,SPCTOT) = ILP(4,ISUB)
*              ELSE
*                ICALSP(MCAL,SPCTOT) = IGP(3,ISUB)
*              ENDIF
*?????????????????????????????????????????????????????????????????????????
 10         CONTINUE
          ENDIF
 
c        ;; Difference spectrum
          IF ( PROG.EQ.'WMRS' ) THEN
            IF ( (NSPEC.EQ.1) .AND. (SPCTOT.LT.MMAIN) ) THEN
              IF ( SPCTOT.GE.MMAIN ) GOTO 100
              ISPC = SPCTOT
              SPCTOT = SPCTOT + 1
              CALL AD2LST(SPCTOT,'Diff.',SPCCMT(1,ISPC),SPCTRA(1,ISPC),
     &                    SPCNOI(1,ISPC),XSPC(1,ISPC),SPCMSK(1,ISPC),
     &                    SPCCAL(1,ISPC),ICALSP(1,ISPC))
              DO 15 I = 1,ICAL(1,ISPEC)
                SPCTRA(I,SPCTOT) = SPEC0(I,ISPEC,1) - SPCTRA(I,ISPC)
 15           CONTINUE
            ENDIF
          ENDIF
 50     CONTINUE
      ENDIF
 
 100  ACTSPC = SPCTOT
      CALL REPPLT(.FALSE.)
      CALL SIMPLT(0,.FALSE.)
      CALL PFMENU
 
 200  FITTING = .FALSE.
 
      IF ( FITOPT.EQ.1 ) THEN
        CALL CLRALL
        CALL SHOLST
        CALL SHOACT(.FALSE.)
      ENDIF
 
 300  RETURN
 
 9001 FORMAT (6(1X,A8))
      END
