*-----------------------------------------------------------------------
      INTEGER FUNCTION EDTFIT()
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     mru 14Jul93
*
*     Editing routine for the integer fitting parameters, filenames,
*     and parameter comments.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'keycom.inc'

      integer intmod, iwid
      integer TOPIFP, TOPFIL, TOPCMT
      parameter (TOPIFP=5, IWID = 5, INTMOD = 7-IWID)
      integer icol, irow, ichr, ix, iy, i
      
      integer colat

      character*10 header(2)
      save header
      DATA HEADER/'Name','   Value'/
*-----------------------------------------------------------------------
      colat(i) = 10*i + 3
*-----------------------------------------------------------------------
 
      TOPFIL = TOPIFP + nfipar - 1
      TOPCMT = TOPFIL + 3

      call normal
      CALL FRAME1(5,1,65,30,'C',
     & 'Page 1            FIT CONTROL PARAMETERS            ')
 
      call bright
      CALL OUTSXY(colat(1)-5,5,'#')
      do 100 i = 1, 2
         call outsxy(colat(i), 5, header(i))
  100 continue
 
      call normal

      do 200 i = 3, nfipar
         call outixy(colat(1)-6, TOPIFP+i-2, i-2, 4)
         call outstr(')')
         call outsxy(colat(1), TOPIFP+i-2, fitnam(i))
         call outixy(colat(2)+intmod,TOPIFP+i-2, ifp(i), iwid)
  200 continue
 
      call outsxy(colat(1)-6, TOPFIL+1, '    Input File :')
      call outsxy(colat(2)+2, TOPFIL+1, filnam(1))
      call outsxy(colat(1)-6, TOPFIL+2, '    Output File:')
      call outsxy(colat(2)+2, TOPFIL+2, filnam(2))
 
      call outsxy(colat(1)-6, TOPCMT+1, parcmt(1))
      call outsxy(colat(1)-6, TOPCMT+2, parcmt(2))
*--This last two lines are not editable.  tk 911221
      call outsxy(colat(1)-6, TOPCMT+3, parcmt(3))
      call outsxy(colat(1)-6, TOPCMT+4, parcmt(4))

      irow = 1
 
  300 icol = 2
      if (irow.lt.3) THEN
         irow = 3
      elseif (irow.gt.nfipar+4) then
         irow = nfipar + 4
      endif
 
      if (irow.le.nfipar) then
         iy = TOPIFP + (irow - 2)
         ix = colat(icol)
         call geti(ix+intmod, iy, ifp(irow), ichr, .true.)
      elseif (irow.le.nfipar+2) then
         iy = TOPFIL + (irow - nfipar)
         ix = colat(2) + 2
         call gets(ix, iy, filnam(irow-nfipar), mfllen, ichr, .true.)
      else
         iy = TOPCMT + (irow - nfipar - 2)
         ix = colat(1) - 6
         call gets(ix, iy, parcmt(irow-nfipar-2), len(parcmt(1)), ichr,
     &      .true.)
      endif

      if (ichr.eq.UPARR) then
         irow = irow - 1
      elseif (ichr.eq.DNARR) then
         irow = irow + 1
      elseif (ichr.eq.RTARR) then
         icol = icol + 1
      elseif (ichr.eq.LTARR) then
         icol = icol - 1
      elseif (ichr.eq.PGUP) THEN
         edtfit = -1
         goto 1000
      elseif (ichr.eq.PGDN) then
         edtfit = 1
         goto 1000
      elseif (ichr.eq.ESC) then
         edtfit = 0
         goto 1000
      endif
      goto 300

1000  return
      end
