*-----------------------------------------------------------------------
      integer function edtgl2(iglo)
*-----------------------------------------------------------------------
      integer iglo
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*      mru 15Jul93 cs
*
*     Editing routine for the global nonlinear and integer parameters
*     stored in the pg0 and igp arrays, respectively.
*
*     MOSS-specific version to display symmetry parameter for Spin
*     Hamiltonian models (model in {1,4}).
*
*     iglo   : Number of the global parameter set to edit (1).
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'parcom.inc'
      include 'speccom.inc'
      include 'togcom.inc'
      include 'keycom.inc'
      include 'varcom.inc'
 
      integer icol, irow, ichr, ix, iy, i, j, ipar, topigp
      character*10 header(5), symmet(0:4)
      logical zspin

      integer TOPPG, INTMOD, INTWID
      parameter (TOPPG = 5, INTWID = 5, INTMOD = 7-INTWID)
 
      integer colat, ij2kon

      save header, symmet
      data header/'Name',' Value','Constr.','Lower B','Upper B'/
      data symmet/'Isotropic','Axial','Rhombic','Monoclinic','None'/
*-----------------------------------------------------------------------
      colat(i) = 3 + 10 * i
      ij2kon(i,j) = i + 100 * j
*-----------------------------------------------------------------------

      topigp = TOPPG + igp(2,iglo) + 2
 
      call normal
      call frame1(5, 1, 65, 30, 'C', 
     &  'Page 3            GLOBAL PARAMETERS            ')
 
      call bright
      call outsxy(colat(1)-5, 5, '#')
      do 100 i = 1, 5
         call outsxy(colat(i), 5, header(i))
 100  continue
 
      call normal
 
c     /* Display Global Nonlinear parameters */
      do 200 i = 1, igp(2,iglo)
         call outixy(colat(1)-6, TOPPG+i, ij2kon(i,iglo) ,4)
         call outstr(')')
         call outsxy(colat(1), TOPPG+i, pgnam(i,iglo))
         call putr  (colat(2), TOPPG+i, pg0(i,iglo))
         call outixy(colat(3)+intmod, TOPPG+i, kong(i,iglo), intwid)
         call putr  (colat(4), TOPPG+i, pglb(i,iglo))
         call putr  (colat(5), TOPPG+i, pgub(I,iglo))
  200 continue
 
c     /* Display Nontrivial Global Integer parameters */
      do 500 i = 3, igp(1,iglo)
        call outsxy(colat(1), TOPIGP-2+i, igpnam(i,iglo))
        call outixy(colat(2)+INTMOD, TOPIGP-2+i, igp(i,iglo), intwid)
  500 continue
c     /* Display symmetry if appropriate */

      zspin = ((model.eq.1).or.(model.eq.4))
      if (zspin) then
         call bright
         if ((igp(4,iglo).ge.0).and.(igp(4,iglo).le.4)) then
            call outsxy(colat(3), TOPIGP+2, symmet(igp(4,iglo)))
         else
            call outsxy(colat(3), TOPIGP+2, 'ERROR!    ')
         endif
         call normal
      endif
 
c     /* Check for the case in which there's nothing global to edit */
      if ((igp(1,iglo).eq.2).and.(igp(2,iglo).eq.0)) then
 550     call inkey(ichr)
         if (ichr.eq.PGUP) then
            edtgl2 = -1
         elseif (ichr.eq.PGDN) then
            edtgl2 = 1
         elseif (ichr.eq.ESC) then
            edtgl2 = 0
         else
            goto 550
         endif
         goto 1000
      endif

      icol = 2
      irow = 1

c     /* Check bounds and determine new screen coordinates (ix,iy) */
  600 if (irow.le.igp(2,iglo)) then
         if (icol.lt.2) then
            icol = 2
         elseif (icol.gt.5) then
            icol = 5
         elseif (irow.lt.1) then
            irow = 1
         endif
         iy = irow + TOPPG
      elseif (irow.gt.igp(2,iglo)) then
         if (igp(1,iglo).le.2) then
            irow = igp(2,iglo)
            goto 600
         else
            icol = 2
            irow = min(irow, igp(2,iglo) + igp(1,iglo) - 2)
            iy = (irow - igp(2,iglo)) + TOPIGP
         endif
      endif
      ix = colat(icol)
 
      if (irow.le.igp(2,iglo)) then
         if (icol.eq.2) then
            call getr(ix, iy, pg0(irow,iglo),  ichr, .true.)
         elseif (icol.eq.3) then
            call geti(ix+intmod, iy, kong(irow,iglo), ichr, .true.)
         elseif (icol.eq.4) then
            call getr(ix, iy, pglb(irow,iglo), ichr, .true.)
         elseif (icol.eq.5) then
            call getr(ix, iy, pgub(irow,iglo), ichr, .true.)
         endif
      else
         ipar = irow - igp(2,iglo) + 2
         call geti(ix+intmod, iy, igp(ipar,iglo), ichr, .true.)
         if (zspin.and.(ipar.eq.4)) then
            call bright
            if ((igp(4,iglo).ge.0).and.(igp(4,iglo).le.4)) then
               call outsxy(colat(3), TOPIGP+2, symmet(igp(4,iglo)))
            else
               call outsxy(colat(3), TOPIGP+2, 'ERROR!    ')
            endif
            call normal
         endif
      endif
 
c     /* Check Keystrokes */
      if (ichr.eq.UPARR) then
         irow = max(1, irow - 1)
      elseif (ichr.eq.DNARR) then
         irow = irow + 1
      elseif (ichr.eq.RTARR) then
         icol = icol + 1
      elseif (ichr.eq.LTARR) then
         icol = icol - 1
      elseif ((ichr.eq.ESC).or.(ichr.eq.PGUP).or.(ichr.eq.PGDN)) then
 
c        /* Verify consistancy: */

c        /* Global constraints & bounds */
         do 750 i = 1, igp(2,iglo)
            if ((kong(i,iglo).eq.ij2kon(i,iglo)).and.
     &         (pglb(i,iglo).gt.pgub(i,iglo))) then
               call errmsg('Lower bound greater than upper bound!')
               icol = 4
               irow = i
               goto 600
            elseif (kong(i,iglo).lt.0) then
               call errmsg('Bad constraint to global parameter!')
               icol = 3
               irow = i
               goto 600
            elseif ((kong(i,iglo).eq.ij2kon(i,iglo)).and. 
     &         ((pg0(i,iglo).lt.pglb(i,iglo)).or.
     &          (pg0(i,iglo).gt.pgub(i,iglo)))) then
               call errmsg('Variable not started within bounds!')
               icol = 2
               irow = i
               goto 600
            endif
  750    continue

c        /* Check integer global parameters */
         if ((nsubs.le.0).or.(nsubs.gt.MLOC)) then
            call errmsg('Invalid number of subspectra!')
            irow = igp(2,iglo) + 1
            icol = 3
            goto 600
         endif
 
         if (ichr.eq.PGUP) THEN
            edtgl2 = -1
         elseif (ichr.eq.PGDN) then
            edtgl2 = 1
         else
            edtgl2 = 0
         endif
         goto 1000
      endif
      goto 600

1000  return
      end
