*-----------------------------------------------------------------------
      INTEGER FUNCTION EDTGLO(IGLO)
*-----------------------------------------------------------------------
      INTEGER IGLO
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*      mru 15Jul93 cs
*
*     Editing routine for the global nonlinear and integer parameters
*     stored in the pg0 and igp arrays, respectively.
*
*     Generic Version
*
*     iglo   : Number of the global parameter set to edit (1).
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'keycom.inc'
      INCLUDE 'varcom.inc'
 
      INTEGER ICOL,IROW,ICHR,IX,IY,I,J,IPAR,IGLO2,IPAR2
      CHARACTER*10 HEADER(5)
 
      INTEGER TOPPG,TOPIGP,INTMOD,INTWID
      PARAMETER (TOPPG=5,TOPIGP=TOPPG+MGPAR+2)
      PARAMETER (INTWID=5,INTMOD=7-INTWID)
 
      INTEGER COLAT,IJ2KON,KON2I,KON2J
 
      SAVE HEADER
      DATA HEADER/'Name',' Value','Constr.','Lower B','Upper B'/
*-----------------------------------------------------------------------
      COLAT(I) = 3 + 10*I
      IJ2KON(I,J) = I + 100*J
      KON2I(I) = 1 + MOD(I-1,100)
      KON2J(I) = I/100
*-----------------------------------------------------------------------
 
      CALL NORMAL
      CALL FRAME1(5,1,65,30,'C',
     &            'Page 3            GLOBAL PARAMETERS            ')
 
      CALL BRIGHT
      CALL OUTSXY(COLAT(1)-5,5,'#')
      DO 100 I = 1,5
        CALL OUTSXY(COLAT(I),5,HEADER(I))
 100  CONTINUE
 
      CALL NORMAL
 
c     /* Display Global Nonlinear parameters */
      DO 200 I = 1,IGP(2,IGLO)
        CALL OUTIXY(COLAT(1)-6,TOPPG+I,IJ2KON(I,IGLO),4)
        CALL OUTSTR(')')
        CALL OUTSXY(COLAT(1),TOPPG+I,PGNAM(I,IGLO))
        CALL PUTR(COLAT(2),TOPPG+I,PG0(I,IGLO))
        CALL OUTIXY(COLAT(3)+INTMOD,TOPPG+I,KONG(I,IGLO),INTWID)
        CALL PUTR(COLAT(4),TOPPG+I,PGLB(I,IGLO))
        CALL PUTR(COLAT(5),TOPPG+I,PGUB(I,IGLO))
 200  CONTINUE
 
c     /* Display Nontrivial Global Integer parameters */
      DO 300 I = 3,IGP(1,IGLO)
        CALL OUTSXY(COLAT(1),TOPIGP-2+I,IGPNAM(I,IGLO))
        CALL OUTIXY(COLAT(2)+INTMOD,TOPIGP-2+I,IGP(I,IGLO),INTWID)
 300  CONTINUE
 
c     /* Check for the case in which there's nothing global to edit */
      IF ( (IGP(1,IGLO).EQ.2) .AND. (IGP(2,IGLO).EQ.0) ) THEN
 350    CALL INKEY(ICHR)
        IF ( ICHR.EQ.PGUP ) THEN
          EDTGLO = -1
        ELSEIF ( ICHR.EQ.PGDN ) THEN
          EDTGLO = 1
        ELSEIF ( ICHR.EQ.ESC ) THEN
          EDTGLO = 0
        ELSE
          GOTO 350
        ENDIF
        GOTO 500
      ENDIF
 
      ICOL = 2
      IROW = 1
 
c     /* Check bounds and determine new screen coordinates (ix,iy) */
 400  IF ( IROW.LE.IGP(2,IGLO) ) THEN
        IF ( ICOL.LT.2 ) THEN
          ICOL = 2
        ELSEIF ( ICOL.GT.5 ) THEN
          ICOL = 5
        ELSEIF ( IROW.LT.1 ) THEN
          IROW = 1
        ENDIF
        IY = IROW + TOPPG
      ELSEIF ( IROW.GT.IGP(2,IGLO) ) THEN
        IF ( IGP(1,IGLO).LE.2 ) THEN
          IROW = IGP(2,IGLO)
          GOTO 400
        ELSE
          ICOL = 2
          IROW = MIN(IROW,IGP(2,IGLO)+IGP(1,IGLO)-2)
          IY = (IROW-IGP(2,IGLO)) + TOPIGP
        ENDIF
      ENDIF
      IX = COLAT(ICOL)
 
      IF ( IROW.GT.IGP(2,IGLO) ) THEN
        IPAR = IROW - IGP(2,IGLO) + 2
        CALL GETI(IX+INTMOD,IY,IGP(IPAR,IGLO),ICHR,.TRUE.)
      ELSEIF ( ICOL.EQ.2 ) THEN
        CALL GETR(IX,IY,PG0(IROW,IGLO),ICHR,.TRUE.)
      ELSEIF ( ICOL.EQ.3 ) THEN
        CALL GETI(IX+INTMOD,IY,KONG(IROW,IGLO),ICHR,.TRUE.)
      ELSEIF ( ICOL.EQ.4 ) THEN
        CALL GETR(IX,IY,PGLB(IROW,IGLO),ICHR,.TRUE.)
      ELSEIF ( ICOL.EQ.5 ) THEN
        CALL GETR(IX,IY,PGUB(IROW,IGLO),ICHR,.TRUE.)
      ENDIF
 
c     /* Check Keystrokes */
      IF ( ICHR.EQ.UPARR ) THEN
        IROW = MAX(1,IROW-1)
      ELSEIF ( ICHR.EQ.DNARR ) THEN
        IROW = IROW + 1
      ELSEIF ( ICHR.EQ.RTARR ) THEN
        ICOL = ICOL + 1
      ELSEIF ( ICHR.EQ.LTARR ) THEN
        ICOL = ICOL - 1
      ELSEIF ( (ICHR.EQ.ESC) .OR. (ICHR.EQ.PGUP) .OR. (ICHR.EQ.PGDN) )
     &         THEN
 
c        /* Verify consistancy: */
 
c        /* Global constraints & bounds */
        DO 450 I = 1,IGP(2,IGLO)
          IF ( KONG(I,IGLO).NE.0 ) THEN
            IF ( KONG(I,IGLO).NE.IJ2KON(I,IGLO) ) THEN
              IGLO2 = KON2J(KONG(I,IGLO))
              IF ( (IGLO2.LT.1) .OR. (IGLO2.GT.NGLO) ) THEN
                CALL ERRMSG('Error in constraint (bad global site)!')
                ICOL = 3
                IROW = I
                GOTO 400
              ENDIF
              IPAR2 = KON2I(KONG(I,IGLO))
              IF ( (IPAR2.LT.1) .OR. (IPAR2.GT.ILP(2,IGLO2)) ) THEN
                CALL ERRMSG('Error in constraint (bad parameter)!')
                ICOL = 3
                IROW = I
                GOTO 400
              ENDIF
            ELSEIF ( PGLB(I,IGLO).GT.PGUB(I,IGLO) ) THEN
              CALL ERRMSG('Lower bound greater than upper bound!')
              ICOL = 4
              IROW = I
              GOTO 400
            ELSEIF ( (PG0(I,IGLO).LT.PGLB(I,IGLO)) .OR. 
     &               (PG0(I,IGLO).GT.PGUB(I,IGLO)) ) THEN
              CALL ERRMSG('Variable not started within bounds!')
              ICOL = 2
              IROW = I
              GOTO 400
            ENDIF
          ENDIF
 450    CONTINUE
 
c        /* Check integer global parameters */
        IF ( (NSUBS.LE.0) .OR. (NSUBS.GT.MLOC) ) THEN
          CALL ERRMSG('Invalid number of subspectra!')
          IROW = IGP(2,IGLO) + 1
          ICOL = 3
          GOTO 400
        ENDIF
 
        IF ( ICHR.EQ.PGUP ) THEN
          EDTGLO = -1
        ELSEIF ( ICHR.EQ.PGDN ) THEN
          EDTGLO = 1
        ELSE
          EDTGLO = 0
        ENDIF
        GOTO 500
      ENDIF
      GOTO 400
 
 500  RETURN
      END
