*----------------------------------------------------------------------
*---EUL2MAT   GIVEN EULER ANGLES, CONSTRUCT ROTATION MATRIX
*----------------------------------------------------------------------
      SUBROUTINE EUL2MAT(PHI,THE,PSI,R)
*---REF.  GOLDSTEIN, CLASSICAL MECHANICS, 1950, PG. 107-109.
*---THE MATRIX R DEFINED HERE IS THE SAME AS TRANSPOSE A OF GOLDSTEIN.
 
      REAL PHI,THE,PSI,R(3,3)
 
      REAL CPHI,SPHI,CTHE,STHE,CPSI,SPSI
 
      CPHI = COS(PHI)
      SPHI = SIN(PHI)
      CTHE = COS(THE)
      STHE = SIN(THE)
      CPSI = COS(PSI)
      SPSI = SIN(PSI)
 
      R(1,1) = CPSI*CPHI - CTHE*SPHI*SPSI
      R(1,2) = -SPSI*CPHI - CTHE*SPHI*CPSI
      R(1,3) = STHE*SPHI
      R(2,1) = CPSI*SPHI + CTHE*CPHI*SPSI
      R(2,2) = -SPSI*SPHI + CTHE*CPHI*CPSI
      R(2,3) = -STHE*CPHI
      R(3,1) = STHE*SPSI
      R(3,2) = STHE*CPSI
      R(3,3) = CTHE
 
      RETURN
      END
