**==FALT.FOR
      SUBROUTINE falt(fname,nchan,y,nf,yf,foldpt,v0,dv,ierr)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*        mru 12Aug93 cs
*---930129 tk -- Remove "halves" arguement and restrict FALT to unfolded
*---             triangluar waveform spectra.  See new routine FIXSAWTH
*---960112 tk -- add "No Fold" option: ----> call fixsawth
*---971230 tk -- correct 'N' bug in Remove baseline? logic.
*---971231 tk -- Add option to interchange 1st & 2nd halves of spectrum
*---110620 PION -- fix the yTitle for IronCal residuals
*-----------------------------------------------------------------------
*     RETYPED 5/1/81
*     THIS ROUTINE FOLDS THE SPECTRUM Y AND RETURNS THE FOLDED
*     SPECTRUM YF
*---externals
*     fname  : Spectrum name
*     nchan  : Number of points in unfolded data
*     y      : Unfolded data
*     nf     : Number of points in folded data
*     yf     : Folded data
*     foldpt : Folding point
*     v0     : Zero velocity from calibration file (if loaded)
*     dv     : Step from calibration file (if loaded)
*     ierr   : Error code (-999 = ESC)
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INTEGER nchan , nf , ifun , ierr
      REAL y(nchan) , yf(nchan) , dv , v0 , foldpt
      CHARACTER*(*) fname
*-----------------------------------------------------------------------
      INCLUDE 'togcom.inc'
      INCLUDE 'keycom.inc'
c
	integer piona
c
      INTEGER tmpk , i , ichr , ilines , nc2 , ift , ngcf , j , jmin
      INTEGER halves
      LOGICAL tmpnng
      REAL v01 , dv1 , dlr , bsm , vm , ai , sm , df , wt , vt , bs1
      REAL ssmin , diff , gfdp , ytemp
      REAL ys(2*lspec) , yl(lspec) , yr(lspec) , fpt(20) , ss(20)
 
      REAL rlpos(12)
      REAL nonoys(2*lspec) , xpos(2*lspec) , nocal(mcal)
      INTEGER inocal(mcal)
      LOGICAL nomask(2*lspec)
      CHARACTER nocmt(6)*72
      SAVE nocal , nocmt
      DATA nocal/0. , 0. , 100. , 1. , 0. , 0. , 1. , 0. , 0. , 0./
      DATA inocal/0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0/
      DATA nocmt/6*' '/
*-----------------------------------------------------------------------
*---define spectrum to be unfolded
      inocal(1) = nchan
      halves = 2
*---initialize folding point
*---no info from raw data file, so set foldpt to midpoint
*---leave foldpt set to value read from data file
      IF ( foldpt.LT.1 ) foldpt = nchan/2
 
      tmpnng = nnegar
      nnegar = .FALSE.
 
      tmpk = kxplot
      kxplot = 1
      nocmt(1) = 'Unfolded data.'
 
      DO 100 i = 1 , nchan
         xpos(i) = float(i)
         nomask(i) = .TRUE.
         nonoys(i) = 0.
 100  CONTINUE
 
 
 200  CALL shodat(.TRUE.,nchan,xpos,y,nonoys,inocal,nocal,nomask,1.0,0,
     &            0,fname,nocmt,.FALSE.)
 
*---begin 971230 tk
 300  CALL message('Interchange 1st & 2nd halves of spectrum?'//
     &             ' (~Y~/~N~) ?')
      CALL inkey(ichr)
      CALL message(' ')
 
      IF ( (ichr.EQ.ichar('Y')) .OR. (ichr.EQ.ichar('y')) ) THEN
         DO 350 i = 1 , nchan/2
            ytemp = y(i)
            y(i) = y(nchan/2+i)
            y(nchan/2+i) = ytemp
 350     CONTINUE
 
         CALL shodat(.TRUE.,nchan,xpos,y,nonoys,inocal,nocal,nomask,1.0,
     &               0,0,fname,nocmt,.FALSE.)
      ELSEIF ( ichr.EQ.esc ) THEN
         ierr = -999
         GOTO 1100
      ELSEIF ( (ichr.NE.ichar('N')) .AND. (ichr.NE.ichar('n')) ) THEN
         GOTO 300
      ENDIF
*----end 971230 tk
 
 400  CALL message('Use previous calibration (~Y~/~N~) ?')
      CALL inkey(ichr)
      CALL message(' ')
      IF ( (ichr.EQ.ichar('Y')) .OR. (ichr.EQ.ichar('y')) ) THEN
         CALL selcal(foldpt,v01,dv1,rlpos,ierr)
 
         IF ( ierr.EQ.-999 ) THEN
            ierr = 0
            GOTO 400
         ELSEIF ( ierr.NE.0 ) THEN
            GOTO 1100
         ENDIF
 
         v0 = v01
         dv = dv1
 
         CALL shodat(.TRUE.,nchan,xpos,y,nonoys,inocal,nocal,nomask,1.0,
     &               0,0,fname,nocmt,.FALSE.)
 
 450     CALL message('Remove linear or parabolic baseline'//
     &                ' (~Y~/~N~) ?')
         CALL inkey(ichr)
         CALL message(' ')
 
         IF ( (ichr.EQ.ichar('Y')) .OR. (ichr.EQ.ichar('y')) ) THEN
            CALL fixbl(fname,halves,nchan,y,nonoys,xpos,ierr)
            IF ( ierr.EQ.-999 ) THEN
               ierr = 0
               GOTO 450
            ENDIF
            CALL shodat(.TRUE.,nchan,xpos,y,nonoys,inocal,nocal,nomask,
     &                  1.0,0,0,fname,nocmt,.FALSE.)
         ELSEIF ( ichr.EQ.esc ) THEN
            ierr = -999
            GOTO 1100
         ELSEIF ( (ichr.NE.ichar('N')) .AND. (ichr.NE.ichar('n')) ) THEN
            GOTO 450
         ENDIF
 
 500     CALL message('Apply correction for nonlinear scale'//
     &                ' (~Y~/~N~) ?')
         CALL inkey(ichr)
         CALL message(' ')

         IF ( (ichr.EQ.ichar('Y')) .OR. (ichr.EQ.ichar('y')) ) THEN
            IF ( (rlpos(5).EQ.0) .AND. (rlpos(6).EQ.0) ) THEN
               ilines = 4
            ELSE
               ilines = 6
            ENDIF

            CALL nlapp(halves,nchan,y,ilines,rlpos,foldpt,v0,dv,.FALSE.)
      
	      CALL shodat(.TRUE.,nchan,xpos,y,nonoys,inocal,nocal,nomask,
     &                  1.0,0,0,fname,nocmt,.FALSE.)
            ifun = 5
            GOTO 700
 
         ELSEIF ( ichr.EQ.CTRLP .AND. .NOT.zcrip ) THEN
            CALL intprn
            CALL shodat(.TRUE.,nchan,xpos,y,nonoys,inocal,nocal,nomask,
     &                  1.0,0,0,fname,nocmt,.TRUE.)
            CALL clsprn
            CALL clrall
            CALL shodat(.TRUE.,nchan,xpos,y,nonoys,inocal,nocal,nomask,
     &                  1.0,0,0,fname,nocmt,.FALSE.)
            GOTO 500
         ELSEIF ( ichr.EQ.esc ) THEN
            ierr = -999
            GOTO 1100
         ELSEIF ( (ichr.NE.ichar('n')) .AND. (ichr.NE.ichar('N')) ) THEN
            GOTO 500
         ENDIF
      ELSEIF ( ichr.EQ.CTRLP .AND. .NOT.zcrip ) THEN
         CALL intprn
         CALL shodat(.TRUE.,nchan,xpos,y,nonoys,inocal,nocal,nomask,1.0,
     &               0,0,fname,nocmt,.FALSE.)
         CALL clsprn
         CALL clrall
         GOTO 200
      ELSEIF ( ichr.EQ.esc ) THEN
         ierr = -999
         GOTO 1100
      ELSEIF ( (ichr.NE.ichar('n')) .AND. (ichr.NE.ichar('N')) ) THEN
         GOTO 400
      ELSE
 550     CALL message('Remove linear or parabolic baseline'//
     &                ' (~Y~/~N~) ?')
         CALL inkey(ichr)
         CALL message(' ')
 
         IF ( (ichr.EQ.ichar('Y')) .OR. (ichr.EQ.ichar('y')) ) THEN
            CALL fixbl(fname,halves,nchan,y,nonoys,xpos,ierr)
            IF ( ierr.EQ.-999 ) THEN
               ierr = 0
               GOTO 550
            ENDIF
            CALL shodat(.TRUE.,nchan,xpos,y,nonoys,inocal,nocal,nomask,
     &                  1.0,0,0,fname,nocmt,.FALSE.)
         ELSEIF ( ichr.EQ.esc ) THEN
            ierr = -999
            GOTO 1100
         ELSEIF ( (ichr.NE.ichar('N')) .AND. (ichr.NE.ichar('n')) ) THEN
            GOTO 550
         ENDIF
      ENDIF
 
*---let user choose method for folding spectrum.
 600  CALL shodat(.TRUE.,nchan,xpos,y,nonoys,inocal,nocal,nomask,1.0,0,
     &            0,fname,nocmt,.FALSE.)
 
      CALL foldop(ifun)
 
 
      IF ( ifun.EQ.5 ) THEN
         kxplot = tmpk
         CALL fixspc(fname,halves,nchan,y,foldpt,v01,dv1,ierr)
         nocmt(1) = 'Spectrum corrected for nonlinear scale.'
         kxplot = 1
         IF ( ierr.NE.0 ) GOTO 600
      ENDIF
 
 700  IF ( ifun.EQ.1 .OR. ifun.EQ.2 .OR. ifun.EQ.5 ) THEN
C***    THE DATA are FOLDED.
         IF ( ifun.EQ.1 ) THEN
*---manual fold
            CALL message('Folding point [channels] ? ')
            CALL getr(0,0,foldpt,ichr,.FALSE.)
*---auto fold
         ENDIF
 
         CALL folder(y,foldpt,nchan,yf,yl,yr,dlr,nc2)
         nf = nchan/2
 
         ift = 0
 750     bsm = 0.0
         vm = float(nc2/2) + .5
         DO 800 i = 1 , nc2
            ai = float(i)
            sm = yl(i) + yr(i)
            df = yl(i) - yr(i)
            wt = df/(2.0*sm)
            vt = ai**2 - 2.0*ai*vm
            bsm = bsm + wt/vt
 800     CONTINUE
         ngcf = nc2
         bs1 = bsm/float(ngcf)
         ssmin = dlr
         IF ( (ifun.EQ.1) .OR. (ifun.GE.5) ) THEN
 
            gfdp = ssmin/float(ngcf)
         ELSE
            DO 820 i = 1 , nchan
               ys(i) = y(i)
 820        CONTINUE
            DO 840 i = 1 , nc2
               j = nchan + 1 - i
               ai = float(i)
               vt = ai**2 - 2.0*ai*vm
               wt = bs1*vt
               ys(i) = ys(i)/(1.0+2.0*wt)
               ys(j) = ys(j)/(1.0-2.0*wt)
 840        CONTINUE
            CALL folder(ys,foldpt,nchan,yf,yl,yr,dlr,nc2)
            ssmin = dlr
            DO 880 i = 1 , 2
               ai = 5.0*float(i)*(.1**i)
               DO 850 j = 1 , 11
                  fpt(j) = foldpt + ai*float(j-6)
                  CALL folder(ys,fpt(j),nchan,yf,yl,yr,dlr,nc2)
                  ss(j) = dlr
                  IF ( ss(j).LE.ssmin ) THEN
                     ssmin = ss(j)
                     jmin = j
                  ENDIF
 850           CONTINUE
               DO 860 j = 1 , 10
                  diff = ss(j) - ss(j+1)
                  IF ( ((diff.LT.0.0) .AND. (j.LT.jmin)) .OR. 
     &                 ((diff.GT.0.0) .AND. (j.GT.jmin)) )
     &                  CALL message('*** Chi Square not smooth ***')
 860           CONTINUE
*              WRITE(10,556) (SS(K),K=1,10)
*556           FORMAT(1H0,"CHI SQUARED "/,1X,5F14.0/,1X,5F14.0)
               foldpt = fpt(jmin)
 880        CONTINUE
            CALL folder(y,foldpt,nchan,yf,yl,yr,dlr,nc2)
            ift = ift + 1
            IF ( ift.EQ.1 ) GOTO 750
            gfdp = ssmin/float(ngcf)
*        WRITE(10,1007) FOLDPT
*1007    FORMAT(1H-,5X,"THE CALCULATED FOLDING POINT IS ",F10.5)
 
         ENDIF
 
*        WRITE(10,1011) GFDP
*1011    FORMAT(1H-,5X,"THE GOODNESS  OF FIT PARAMETER IS ",F10.5)
*        IF(BS1.LT.0.0) GO TO 638
*        WRITE(10,1012)
*1012    FORMAT(1H-,5X,"------ VELOCITY SCALE ++++++")
*        GO TO 639
*638     WRITE(10,1013)
*1013    FORMAT(1H-,5X,"++++++ VELOCITY SCALE ------")
*639     CONTINUE
 
      ELSEIF ( ifun.EQ.3 ) THEN
*save first half only
         DO 900 i = 1 , nchan/2
            yf(i) = y(i)
 900     CONTINUE
         foldpt = -1.0
         nf = nchan/2
 
      ELSEIF ( ifun.EQ.4 ) THEN
*save second half only
         DO 950 i = 1 , nchan/2
            yf(i) = y(i+nchan/2)
 950     CONTINUE
         foldpt = -2.0
         nf = nchan/2
 
      ELSEIF ( ifun.EQ.6 ) THEN
*save unfolded spectrum with no baseline correction
         DO 1000 i = 1 , nchan
            yf(i) = y(i)
 1000    CONTINUE
         foldpt = -6.0
         nf = nchan
 
      ELSEIF ( ifun.EQ.0 ) THEN
         ierr = -999
      ENDIF
 
 1100 CALL message(' ')
      kxplot = tmpk
      nnegar = tmpnng
 
      RETURN
      END
