 
      SUBROUTINE FILLST(FMASK,FCHOSE,NCHOSE,STD)
*----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     mru 920513 tk
*----------------------------------------------------------------------
* Given a file mask, displays a menu of matching filenames and returns
* the one the user picked, overwriting the mask.
* fmask  : The file mask used to search for files
* fchose : A list containing the full filenames of the spectra
*          which the used picked.
* nchose : On input, the maximum number of files the user may choose.
*          On output, the number of files the user did choose.
* std    : If true, then the *.SPI files in the PGMDIR directory are
*          added to the end of the list.
*----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'keycom.inc'
      INCLUDE 'constcom.inc'
      INCLUDE 'togcom.inc'
*----------------------------------------------------------------------
      CHARACTER*(*) FMASK
      CHARACTER*(MFLLEN) FCHOSE(NCHOSE)
      INTEGER NCHOSE,I,LEN2
      LOGICAL STD
*----------------------------------------------------------------------
 
*---Maximum number of *.SPI files to display
      INTEGER MXSPI
      PARAMETER (MXSPI=10)
*---Column width
      INTEGER ICOLWD
      PARAMETER (ICOLWD=15)
*---Number of spectra per column
      INTEGER MROWS
      PARAMETER (MROWS=20)
*---Maximum number of filenames to display
      INTEGER MXFILE
      PARAMETER (MXFILE=(75/ICOLWD)*MROWS)
 
*---Storage for the filenames found
      CHARACTER*(MFLLEN) DIRLST(0:MXFILE-1),SPILST(10)
*---Markers for chosen spectra
      CHARACTER*1 MARKS(0:MXFILE-1),MYES,MNO
 
*---Directory path extracted from the given file mask
      CHARACTER*(MFLLEN) INPATH
 
*---Array of booleans: if chosen(i) is true, then file #i has been picked.
      LOGICAL CHOSEN(0:MXFILE-1)
 
*---Number of files chosen by the user so far
      INTEGER COUNT
 
      INTEGER LEN,LEN1,PLEN,IFILE,ICHR
 
*----------------------------------------------------------------------
* Executable statements begin here
*----------------------------------------------------------------------
      CALL OSDIRT('FD')
 
*--- define yes and no marker symbols
      IF ( UNIX ) THEN
        MYES = '>'
      ELSE
        MYES = CHAR(16)
      ENDIF
      MNO = ' '
 
*---Display instructions
      IF ( NCHOSE.GT.1 ) THEN
        CALL MESSAGE('~ENTER~ to select/deselect files,'//
     &               ' ~ESC~ when done.')
      ELSE
        CALL MESSAGE('~ENTER~ to select the file.')
      ENDIF
 
*---Mark all files as not picked
      DO 100 I = 0,MXFILE - 1
        CHOSEN(I) = .FALSE.
        MARKS(I) = MNO
 100  CONTINUE
 
*---Optionally load Standard files immediately following the last
*---normal file found.
      IF ( STD ) THEN
        LEN2 = MXSPI
        CALL OSDIRL(PGMDIR(1:PGMLEN),'*.spi',SPILST,LEN2)
      ELSE
        LEN2 = 0
      ENDIF
 
*---Get the file names into the dirlst array; leave room for the *.SPI
*---files if they will be included.
      IF ( STD ) THEN
        LEN1 = MXFILE - LEN2
      ELSE
        LEN1 = MXFILE
      ENDIF
      CALL OSDIRL(' ',FMASK,DIRLST(0),LEN1)
 
*---Copy *.spi files into the dirlst array
      DO 200 I = 1,LEN2
        DIRLST(LEN1+I-1) = SPILST(I)
 200  CONTINUE
 
*---Calculate the total number of files loaded.
 
      LEN = LEN1 + LEN2
 
      IF ( LEN.GT.0 ) THEN
        IFILE = 0
        COUNT = 0
 
*---Open a window, preserving the underlying graphics
        CALL NORMAL
        CALL WNACTN('FP')
        CALL WNOPNT(5,5,ICOLWD*(1+INT((LEN-1)/MROWS)),MIN(MROWS,LEN),
     &              FMASK)
 
*---Display all the files in columns of mrows
        CALL WNCLR
        DO 250 I = 0,LEN - 1
          CALL WNOUSX(1+ICOLWD*INT(I/MROWS),1+MOD(I,MROWS),MARKS(I)
     &                //DIRLST(I)(:12))
 250    CONTINUE
 
*---Display the file beneath the cursor
 300    IF ( CHOSEN(IFILE) ) THEN
          CALL INEMPH
          MARKS(IFILE) = MYES
        ELSE
          CALL INVERT
        ENDIF
        CALL WNOUSX(1+ICOLWD*INT(IFILE/MROWS),1+MOD(IFILE,MROWS),
     &              MARKS(IFILE)//DIRLST(IFILE)(:12))
 
*---Get a keystroke from the user
 350    CALL INKEY(ICHR)
 
C ESC: Exit main loop
        IF ( ICHR.EQ.ESC ) THEN
 
C ENTER: Toggle current file
        ELSEIF ( ICHR.EQ.ENTER ) THEN
          CHOSEN(IFILE) = .NOT.CHOSEN(IFILE)
          IF ( CHOSEN(IFILE) ) THEN
            MARKS(IFILE) = MYES
            COUNT = COUNT + 1
            CALL INEMPH
            CALL WNOUSX(1+ICOLWD*INT(IFILE/MROWS),1+MOD(IFILE,MROWS),
     &                  MARKS(IFILE)//DIRLST(IFILE)(:12))
          ELSE
            MARKS(IFILE) = MNO
            COUNT = COUNT - 1
            CALL INVERT
            CALL WNOUSX(1+ICOLWD*INT(IFILE/MROWS),1+MOD(IFILE,MROWS),
     &                  MARKS(IFILE)//DIRLST(IFILE)(:12))
          ENDIF
          IF ( COUNT.LT.NCHOSE ) GOTO 350
 
* CURSOR KEYS: move highlight.
        ELSEIF ( ICHR.EQ.RTARR ) THEN
          IF ( IFILE.GT.LEN-21 ) GOTO 350
          IF ( CHOSEN(IFILE) ) THEN
            CALL EMPHSZ
          ELSE
            CALL NORMAL
          ENDIF
          CALL WNOUSX(1+ICOLWD*INT(IFILE/MROWS),1+MOD(IFILE,MROWS),
     &                MARKS(IFILE)//DIRLST(IFILE)(:12))
          IFILE = IFILE + MROWS
          GOTO 300
        ELSEIF ( ICHR.EQ.LTARR ) THEN
          IF ( IFILE.LT.MROWS ) GOTO 350
          IF ( CHOSEN(IFILE) ) THEN
            CALL EMPHSZ
          ELSE
            CALL NORMAL
          ENDIF
          CALL WNOUSX(1+ICOLWD*INT(IFILE/MROWS),1+MOD(IFILE,MROWS),
     &                MARKS(IFILE)//DIRLST(IFILE)(:12))
          IFILE = IFILE - MROWS
          GOTO 300
        ELSEIF ( ICHR.EQ.DNARR ) THEN
          IF ( IFILE.GE.LEN-1 ) GOTO 350
          IF ( CHOSEN(IFILE) ) THEN
            CALL EMPHSZ
          ELSE
            CALL NORMAL
          ENDIF
          CALL WNOUSX(1+ICOLWD*INT(IFILE/MROWS),1+MOD(IFILE,MROWS),
     &                MARKS(IFILE)//DIRLST(IFILE)(:12))
          IFILE = IFILE + 1
          GOTO 300
        ELSEIF ( ICHR.EQ.UPARR ) THEN
          IF ( IFILE.LE.0 ) GOTO 350
          IF ( CHOSEN(IFILE) ) THEN
            CALL EMPHSZ
          ELSE
            CALL NORMAL
          ENDIF
          CALL WNOUSX(1+ICOLWD*INT(IFILE/MROWS),1+MOD(IFILE,MROWS),
     &                MARKS(IFILE)//DIRLST(IFILE)(:12))
          IFILE = IFILE - 1
          GOTO 300
        ELSE
          GOTO 350
        ENDIF
 
 
*---Extract filepath from the given filemask
        CALL FIPATH(FMASK,INPATH,PLEN)
 
        NCHOSE = COUNT
*---Append the correct path to the files.
        DO 400 IFILE = LEN - 1,0, - 1
          IF ( CHOSEN(IFILE) ) THEN
            IF ( IFILE.GE.LEN1 ) THEN
              FCHOSE(COUNT) = PGMDIR(1:PGMLEN)//DIRLST(IFILE)
            ELSEIF ( PLEN.GT.0 ) THEN
              FCHOSE(COUNT) = INPATH(1:PLEN)//DIRLST(IFILE)
            ELSE
              FCHOSE(COUNT) = DIRLST(IFILE)
            ENDIF
            COUNT = COUNT - 1
          ENDIF
 400    CONTINUE
      ELSE
        CALL ERRMSG('No matching files!')
        NCHOSE = 0
      ENDIF
 
      CALL WNCLOS(1)
      RETURN
      END
