      subroutine fixbl(fname, halves, npts, spc, noi, xpos, ierr)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig 22Sep92 CS: added halves parameter
*---mru  02nov93 cs
*------------------------------------------------------------------------
      character*(*) fname
      integer halves, npts, ierr
      real spc(npts), noi(npts), xpos(npts)
*------------------------------------------------------------------------
      INCLUDE 'limits.inc'
      include 'parcom.inc'
      include 'keycom.inc'
      include 'togcom.inc'

      integer i, nhalf, degree, ivec, ibase, ichr, okxplt
      logical mask(2*lspec)
      real bases(lspec,3), vecs(lspec), ch1val
      real bl(2*lspec), adj, a1

      integer lwork, irank
      parameter (lwork=5*mbasis)
      real work(lwork)
      real sngval(mbasis)

      logical inyno
      external inyno

      logical nomask(2*lspec)
      real nocal(mcal)
      integer inocal(mcal)
      character nocmt(6)*72
      save nocal, nocmt
      data nocal/0.,0.,100.,1.,0.,0.,1.,0.,0.,0./
      data nocmt/6*' '/ 
*------------------------------------------------------------------------

      okxplt = kxplot
      kxplot = 0

      nhalf = npts / halves
      a1 = (nhalf+1)/2.0

      ch1val = spc(1)

      do 25 i = 1, npts
         nomask(i) = .true.
         spc(i) = spc(i) - ch1val
   25 continue

*---MAIN LOOP
      do 300 ibase = 1, 1+(halves-1)*nhalf, nhalf

*---Clear mask
      do 50 i = 1, npts
         mask(i) = .true.
   50 continue

*---Display first half
         if ((halves.gt.1).and.(ibase.eq.1)) then
            nocmt(1) = 'First half'
         elseif (halves.gt.1) then
            nocmt(1) = 'Second half'
         else
            nocmt(1) = 'Raw data'
         endif
         call shodat(.true., nhalf, xpos(ibase), spc(ibase), noi(ibase),
     &      inocal, nocal, mask, 1.0, 0, 0, fname, nocmt, .false.)

*---Ask about type of baseline correction
         call message('~L~inear or ~P~arabolic baseline?')

   75    call inkey(ichr)
         if ((ichr.eq.ichar('L')).or.(ichr.eq.ichar('l'))) then
            degree = 2
         elseif ((ichr.eq.ichar('P')).or.(ichr.eq.ichar('p'))) then
            degree = 3
         elseif (ichr.eq.ESC) then
            ierr = -999
            goto 1100
         else
            goto 75
         endif

*---Mark spectrum
         call message('Masked points will be ignored when'//
     &      ' fitting baseline.')
         call oswait(100)
         inocal(1) = nhalf
         call mark(spc(ibase), noi(ibase), xpos(ibase), 
     &       nocal, inocal, mask(ibase), fname, nocmt)
         
*----Set up bases vectors
         ivec = 0
         do 100 i = 1, nhalf
            if (mask(i+ibase-1)) then
               ivec = ivec + 1
               bases(ivec,1) = 1.0 
               bases(ivec,2) = i-a1
               bases(ivec,3) = (i-a1)**2 
               vecs(ivec) = spc(i+ibase-1) 
            endif
  100    continue

*---Do linear fit
         call sgelss(ivec, degree, 1, bases, lspec, vecs, lspec,
     &      sngval, 1.0e-9, irank, work, lwork, ierr)

         if (ierr.ne.0) goto 1100

*---Calculate baseline fit
         do 200 i = 1, nhalf
            bl(ibase+i-1) = vecs(1)+vecs(2)*(i-a1)
            if (degree.eq.3) bl(ibase+i-1) = bl(ibase+i-1) + 
     &         vecs(3)*(i-a1)**2
  200    continue

*---Plot baseline fit
         call shodat(.false., nhalf, xpos(ibase), bl(ibase), noi(ibase),
     &    inocal, nocal, mask(ibase), 1.0, 0, 1, fname, nocmt, .false.)

         call message('~ESC~ aborts; any other key to continue...')
         call inkey(ichr)
         if (ichr.eq.ESC) then
            ierr = -999
            goto 1100
         endif

  300 continue

      call shodat(.true., npts, xpos, spc, noi,
     &   inocal, nocal, nomask, 1.0, 0, 0, fname, nocmt, .false.)
      call shodat(.false., npts, xpos, bl, noi,
     &   inocal, nocal, nomask, 1.0, 0, 1, fname, nocmt, .false.)

      call message('Subtract baseline correction (~Y~/~N~) ?')
      if (inyno(0)) then
         adj = ch1val - (spc(1)-bl(1))
         do 400 i = 1, npts
            spc(i) = spc(i) - bl(i) + adj
  400    continue
      else
         do 450 i = 1, npts
            spc(i) = spc(i) + ch1val
  450    continue
      endif
      ierr = 0

      call message(' ')
      return

*---Return for after ESC
 1100 do 1125 i = 1, npts
         spc(i) = spc(i) + ch1val
 1125 continue
      call message(' ')
      kxplot = okxplt
      return

      end
