**==FIXSAWTH.FOR
      SUBROUTINE FIXSAWTH(FNAME,Y,YF,NCHAN,FLAG,V0,DV,IERR)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     orig 930129 tk             mru 920129 tk
*---Purpose: Accept raw sawtooth spectrum "y",
*---         allow user option of removing baseline and/or
*---         applying non-linear correction using prev. cal. info
*-----------------------------------------------------------------------
*---externals
*     fname  : Spectrum name
*     y      : raw data
*     yf     : conditioned data
*     nchan  : Number of points in data
*     flag   : Used to set foldpt in header to -3
*     v0     : Zero velocity from calibration file (if loaded)
*     dv     : Step from calibration file (if loaded)
*     ierr   : Error code (-999 = ESC)
 
      INTEGER NCHAN,IERR
      REAL Y(NCHAN),YF(NCHAN),DV,V0,FLAG
      CHARACTER*(*) FNAME
*---commone blocks, etc.
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'keycom.inc'
*---internals
      INTEGER TMPK,I,ICHR,ILINES,HALVES
      LOGICAL TMPNNG
      REAL V01,DV1,DUMMY
      REAL RLPOS(12)
      REAL NONOYS(2*LSPEC),XPOS(2*LSPEC),NOCAL(MCAL)
      INTEGER INOCAL(MCAL)
      LOGICAL NOMASK(2*LSPEC)
      CHARACTER NOCMT(6)*72
      save nocal, nocmt
      DATA NOCAL/0.,0.,100.,1.,0.,0.,1.,0.,0.,0./
      DATA NOCMT/6*' '/
*-----------------------------------------------------------------------
*---executable statements start here
      HALVES = 1
      TMPNNG = NNEGAR
      NNEGAR = .FALSE.
 
      TMPK = KXPLOT
      KXPLOT = 1
      NOCMT(1) = 'Sawtooth file'
 
      DO 100 I = 1,NCHAN
        XPOS(I) = FLOAT(I)
        NOMASK(I) = .TRUE.
        NONOYS(I) = 0.
 100  CONTINUE
 
 
 200  CALL SHODAT(.TRUE.,NCHAN,XPOS,Y,NONOYS,INOCAL,NOCAL,NOMASK,1.0,0,
     &            0,FNAME,NOCMT,.FALSE.)
 
 300  CALL MESSAGE('Use previous calibration (~Y~/~N~) ?')
      CALL INKEY(ICHR)
      CALL MESSAGE(' ')
      IF ( (ICHR.EQ.ICHAR('Y')) .OR. (ICHR.EQ.ICHAR('y')) ) THEN
        CALL SELCAL(DUMMY,V01,DV1,RLPOS,IERR)
 
        IF ( IERR.EQ.-999 ) THEN
          IERR = 0
          GOTO 300
        ELSEIF ( IERR.NE.0 ) THEN
          GOTO 600
        ENDIF
 
        V0 = V01
        DV = DV1
 
        CALL SHODAT(.TRUE.,NCHAN,XPOS,Y,NONOYS,INOCAL,NOCAL,NOMASK,1.0,
     &              0,0,FNAME,NOCMT,.FALSE.)
 
 350    CALL MESSAGE('Remove linear or parabolic baseline'//
     &               ' (~Y~/~N~) ?')
        CALL INKEY(ICHR)
        CALL MESSAGE(' ')
 
        IF ( (ICHR.EQ.ICHAR('Y')) .OR. (ICHR.EQ.ICHAR('y')) ) THEN
          CALL FIXBL(FNAME,HALVES,NCHAN,Y,NONOYS,XPOS,IERR)
          IF ( IERR.EQ.-999 ) THEN
            IERR = 0
            GOTO 350
          ENDIF
          CALL SHODAT(.TRUE.,NCHAN,XPOS,Y,NONOYS,INOCAL,NOCAL,NOMASK,
     &                1.0,0,0,FNAME,NOCMT,.FALSE.)
        ELSEIF ( ICHR.EQ.ESC ) THEN
          IERR = -999
          GOTO 600
        ELSEIF ( (ICHR.NE.ICHAR('N')) .AND. (ICHR.NE.ICHAR('n')) ) THEN
          GOTO 350
        ENDIF
 
 400    CALL MESSAGE('Apply correction for nonlinear scale'//
     &               ' (~Y~/~N~) ?')
        CALL INKEY(ICHR)
        CALL MESSAGE(' ')
 
        IF ( (ICHR.EQ.ICHAR('Y')) .OR. (ICHR.EQ.ICHAR('y')) ) THEN
          IF ( (RLPOS(5).EQ.0) .AND. (RLPOS(6).EQ.0) ) THEN
            ILINES = 4
          ELSE
            ILINES = 6
          ENDIF
          CALL NLAPP(HALVES,NCHAN,Y,ILINES,RLPOS,FLAG,V0,DV,.FALSE.)
          CALL SHODAT(.TRUE.,NCHAN,XPOS,Y,NONOYS,INOCAL,NOCAL,NOMASK,
     &                1.0,0,0,FNAME,NOCMT,.FALSE.)
 
        ELSEIF ( ICHR.EQ.CTRLP .and. .not. zcrip) THEN
          CALL INTPRN
          CALL SHODAT(.TRUE.,NCHAN,XPOS,Y,NONOYS,INOCAL,NOCAL,NOMASK,
     &                1.0,0,0,FNAME,NOCMT,.TRUE.)
          CALL CLSPRN
          call clrall
          CALL SHODAT(.TRUE.,NCHAN,XPOS,Y,NONOYS,INOCAL,NOCAL,NOMASK,
     &                1.0,0,0,FNAME,NOCMT,.FALSE.)
          GOTO 400
        ELSEIF ( ICHR.EQ.ESC ) THEN
          IERR = -999
        ELSEIF ( (ICHR.NE.ICHAR('n')) .AND. (ICHR.NE.ICHAR('N')) ) THEN
          GOTO 400
        ENDIF
      ELSEIF ( ICHR.EQ.CTRLP .and. .not. zcrip) THEN
        CALL INTPRN
        CALL SHODAT(.TRUE.,NCHAN,XPOS,Y,NONOYS,INOCAL,NOCAL,NOMASK,1.0,
     &              0,0,FNAME,NOCMT,.FALSE.)
        CALL CLSPRN
        call clrall
        GOTO 200
      ELSEIF ( ICHR.EQ.ESC ) THEN
        IERR = -999
      ELSEIF ( (ICHR.NE.ICHAR('n')) .AND. (ICHR.NE.ICHAR('N')) ) THEN
        GOTO 300
      ELSE
 450    CALL MESSAGE('Remove linear or parabolic baseline'//
     &               ' (~Y~/~N~) ?')
        CALL INKEY(ICHR)
        CALL MESSAGE(' ')
 
        IF ( (ICHR.EQ.ICHAR('Y')) .OR. (ICHR.EQ.ICHAR('y')) ) THEN
          CALL FIXBL(FNAME,HALVES,NCHAN,Y,NONOYS,XPOS,IERR)
          IF ( IERR.EQ.-999 ) THEN
            IERR = 0
            GOTO 450
          ENDIF
          CALL SHODAT(.TRUE.,NCHAN,XPOS,Y,NONOYS,INOCAL,NOCAL,NOMASK,
     &                1.0,0,0,FNAME,NOCMT,.FALSE.)
        ELSEIF ( ICHR.EQ.ESC ) THEN
          IERR = -999
          GOTO 600
        ELSEIF ( (ICHR.NE.ICHAR('Y')) .AND. (ICHR.NE.ICHAR('n')) ) THEN
          GOTO 450
        ENDIF
 
*---Do iron cal fit?
 500    CALL SHODAT(.TRUE.,NCHAN,XPOS,Y,NONOYS,INOCAL,NOCAL,NOMASK,1.0,
     &              0,0,FNAME,NOCMT,.FALSE.)
 
        CALL MESSAGE('Is this an Iron calibration spectrum?'//
     &               ' (~Y~/~N~) ?')
        CALL INKEY(ICHR)
        CALL MESSAGE(' ')
        IF ( (ICHR.EQ.ICHAR('Y')) .OR. (ICHR.EQ.ICHAR('y')) ) THEN
          KXPLOT = TMPK
          CALL FIXSPC(FNAME,HALVES,NCHAN,Y,FLAG,V01,DV1,IERR)
          KXPLOT = 1
          IF ( IERR.EQ.-999 ) THEN
            IERR = 0
            GOTO 500
          ENDIF
          NOCMT(1) = 'Sawtooth spec. corrected for nonlinear scale.'
          V0 = V01
          DV = DV1
          CALL SHODAT(.TRUE.,NCHAN,XPOS,Y,NONOYS,INOCAL,NOCAL,NOMASK,
     &                1.0,0,0,FNAME,NOCMT,.FALSE.)
        ELSEIF ( ICHR.EQ.ESC ) THEN
          IERR = -999
        ELSEIF ( (ICHR.NE.ICHAR('Y')) .AND. (ICHR.NE.ICHAR('n')) ) THEN
          GOTO 500
        ENDIF
      ENDIF
 
*---copy data to yf
 600  DO 700 I = 1,NCHAN
        YF(I) = Y(I)
 700  CONTINUE
*---Set sawtooth flag in data header to indicate sawtooth file
      FLAG = -3.0
*---Clear top line
      CALL MESSAGE(' ')
*---Reset plot and fit options
      KXPLOT = TMPK
      NNEGAR = TMPNNG
 
      RETURN
      END
