      subroutine fixspc(fname, halves, npts, spc, fpoint, v0, dv, ierr)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig 1992 cs
*---mru 02nov93 cs
*---PION: 110620
*
*     Automated Iron metal fit and storage of cal info to disk.
*
*-----------------------------------------------------------------------
      character*(*) fname
      integer halves, npts, ierr
      real spc(npts), fpoint, v0, dv
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'parcom.inc'
      include 'speccom.inc'
      include 'constcom.inc'
      include 'togcom.inc'
      include 'keycom.inc'
      include 'iocom.inc'

      real width, area, rlpos(12)
      real cwcal
      logical tmpyfl
      integer i, ichr, izero, plen, linpos(6), nhalf, iptbas, ibase
      integer ilines, iyr, imonth, iday, npt(1), olkplt, j
      character*6 datstr
      character*(mfllen) tmpfil
      character*2 scale

      real nonoys(2*lspec), xpos(2*lspec), nocal(mcal)
      logical nomask(2*lspec)
      character nocmt(6)*72

      integer infocu, lenact
      logical inyno
      external infocu, lenact, inyno

      integer ij2kon

      save nocal, nocmt
      data nocal/0.,0.,100.,1.,0.,0.,1.,0.,0.,0./
      data nocmt/6*' '/
*-----------------------------------------------------------------------
      ij2kon(i,j) = i + 100 * j
*-----------------------------------------------------------------------

      ierr = 0
      tmpyfl = yflip
      yflip = .true.
      olkplt = kxplot
      kxplot = 1

      do 25 i = 1, npts
         spc(i) = -spc(i)
         xpos(i) = float(i)
         nonoys(i) = 1.0
         nomask(i) = .true.
   25 continue

*---Clear rlpos
      do 30 i = 1, 12
         rlpos(i) = 0.
   30 continue

      if (parlod) then
         call message('WARNING:  Save current parameters first'//
     &      ' (~Y~/~N~) ? ')
   50    call inkey(ichr)
         if ((ichr.eq.ichar('Y')).or.(ichr.eq.ichar('y'))) then
            call files(7)
         elseif (ichr.eq.ESC) then
            ierr = -999
            goto 1000
         elseif ((ichr.ne.ichar('N')).and.(ichr.ne.ichar('n'))) then
            goto 50
         endif
      endif

*---FIND MAX/MIN VALUES
      nhalf = npts / halves

      iptbas = 1
      do 900 ibase = 1, 1 + (halves-1)*nhalf, nhalf

         if (halves.eq.1) then
            call callin(1, npts, spc, nonoys, xpos, ilines, linpos,
     &         ierr)
         elseif (ibase.eq.1) then
            call callin(1, nhalf, spc, nonoys, xpos, ilines, linpos,
     &         ierr)
         else
            call callin(2, nhalf, spc(ibase), nonoys(ibase),
     &         xpos(ibase), ilines, linpos, ierr)
         endif
         if (ierr.ne.0) goto 1000

         if (ilines.eq.4) then
            filnam(1) = pgmdir(1:pgmlen)//'femetl4.spi'
         else
            filnam(1) = pgmdir(1:pgmlen)//'femetl6.spi'
         endif

         open (jdisk, file=filnam(1))
         call getpar(ierr)
         close (jdisk)
      
         if (ierr.ne.0) then
            call errmsg('Cannot read initial calibration parameters!')
            goto 1000
         else
            parlod = .true.
         endif

*---Insert spectrum into fit table
         call intbla

         sname(1) = fname
         if (halves.eq.1) then
            scomnt(1,1) = 'Fit to determine calibration'
         elseif (ibase.eq.1) then
            scomnt(1,1) = 'Fit to determine calibration for first half'
         else
            scomnt(1,1) = 'Fit to determine calibration for second half'
         endif
         do 420 i = 2, 6
            scomnt(i,1) = nocmt(i)
  420    continue
         
         call vcopy(mcal,nocal,cal)
         call vcopy(nhalf,spc(ibase),spec)
         call vcopy(nhalf,spc(ibase),spec0)
         call vcopy(nhalf,xpos,specx)
         call vcopy(nhalf,nonoys(ibase),snoys)
 
         cal(6,1) = 1 - ibase

         ical(1,1) = nhalf
         do 240 i = 2, mcal
            ical(i,1) = 0.
  240    continue

         do 245 i = 1, nhalf
            smask(i,1) = nomask(ibase+i-1)
  245    continue
         
         call message('Add mask to this half (~Y~/~N~) ?')
         if (inyno(0)) then
            call mark(spec, snoys, specx, cal, ical, 
     &         smask, sname, scomnt)
         endif

         datchu = .true.
         nspec = 1

         npt(1) = nhalf
         call mskapp(npt, snoys(1,1,1), smask(1,1), nvec, nfrpt)

         call makbas

*---Insert positions into parameters
         do 500 i = 1, ilines
            pl0(1,i) = linpos(i)
            width = 4.0
            cwcal = 5.
            call calwa(float(linpos(i)-ibase+1), nhalf, spc(ibase), 
     &         cwcal, width, area)
            pl0(2,i) = width
  500    continue

*---Float baseline
         konbl(1,1) = ij2kon(1,1)

*---Do fit
         call dofit(2)
         datchu = .false.
         do 540 i = 1, spctot
            picked(i) = .false.
  540    continue
         if (abort.ge.AbortFit) then
            ierr = -1
            goto 1000
         endif

         do 550 i = 1, ilines
            rlpos(iptbas+i-1) = pl0(1,i)
  550    continue
         iptbas = iptbas + 6
  900 continue
c	
	piona = kyplot
	kyplot = 3
c

      call nlapp(halves, npts, spc, ilines, rlpos, fpoint, v0, dv,
     &   .true.)

      open (jdisk,file=pgmdir(1:pgmlen)//'cal.log', access='append',
     &   status='Unknown',iostat=ierr)
      if (ierr.eq.0) then
         izero = ichar('0')
         call osdate(iyr, imonth, iday)
         datstr = char(izero+(mod(iyr,100)/10)) //
     &      char(izero+mod(iyr,10)) // char(izero+imonth/10) //
     &      char(izero+mod(imonth,10)) // char(izero+iday/10) //
     &      char(izero+mod(iday,10))
         call fipath(fname,tmpfil,plen)
         
         scale = '  '
         call message('Scale to save as? ')
         call gets(infocu(1),infocu(2),scale,2,ichr,.false.)
         call upperc(scale)

         if ((lenact(scale).ne.0).and.(ichr.ne.ESC)) then
*---Write to file
            write(jdisk,9900) datstr, fname(plen+1:), scale, v0, dv,
     &         fpoint
            write(jdisk,9910) (rlpos(i), i = 1, 6)
            write(jdisk,9910) (rlpos(i), i = 7, 12)
         else
            call message('Nothing written to file...')
            call oswait(200)
         endif
         close(jdisk)
      else
         call errmsg('ERROR:  Cannot open calibration file ~CAL.LOG~!')
      endif

      open (jdisk, file=pgmdir(1:pgmlen)//'cal.hst', status='unknown',
     &   access='append', iostat = ierr)
      if (ierr.eq.0) then
         write(jdisk,9900) datstr, fname(plen+1:), scale, v0, dv,
     &      fpoint
         close(jdisk)
      else
         call errmsg('ERROR:  Cannot open calibration file ~CAL.HST~!')
      endif

*---Display report
      call shocbr(halves, ilines, rlpos, fpoint, npts)     
      
*---Restore spectrum
 1000 continue
      yflip = tmpyfl
      kxplot = olkplt
	kyplot = piona
      do 1025 i = 1, npts
         spc(i) = -spc(i)
 1025 continue

      call message(' ')
      return

 9900 format (A6,1X,A12,1X,A2,1X,F6.2,1X,F7.5,1X,F6.2)
 9910 format (5X,6(F8.3,1X))
      end
