      SUBROUTINE FLASHER
*---WEB Research Co.
*---orig: tk & cs 1991            
*---mru 19Jul93 cs 960527 tk; 980320 tk
*---Purpose:  provide convenient manual inspection of spectral response
*---          to changes in parameters. 
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'keycom.inc'
      INCLUDE 'mancom.inc'
      INCLUDE 'togcom.inc'
      include 'scrncom.inc'
 
      LOGICAL GETYN
 
      INTEGER COUNT,DELAY
      PARAMETER (DELAY=800)
 
*---Number in the last series calculated
      INTEGER LSTSER
 
*---Variable column(1-3)
      INTEGER VARCOL
 
*---Window Positions
      INTEGER PWINX,PWINY,PWINWD,PWINHT
      INTEGER SWINX,SWINY,SWINWD,SWINHT

*---Highest-level changed variable
      integer minchg
      real oldval

      integer i, botpar, ichr
*---error flag
      integer ierr

      LOGICAL NOMSK(LSPEC)

      real ytoys, ystoy
      external ytoys, ystoy

      save nomsk
      data nomsk/lspec*.true./
 
*---Initialize
     
      pwinx = 1
      pwinwd = 16
      PWINHT = MIN(NPTOT,iscrow-3)
      PWINY = MAX(2,iscrow-PWINHT)
      
      swinwd = 20
      swinht = nint(7./30.*iscrow)

      swinx = isccol - swinwd + 1
      swiny = iscrow - swinht + 1

      CURPAR = 1
      TOPPAR = 1
      VARCOL = 1
      CURSTK = 1
      STKTOT = SPCTOT
      TOPSTK = SPCTOT

      minchg = CALTYP

*---Convert baseline values from Raw data to scaled y-values
      do 75 i = 1, nptot
         if (partyp(i).eq.bltyp) then
            parvec(i) = ytoys(parvec(i),cal(1,1))
            parub(i) = ytoys(parub(i),cal(1,1))
            parlb(i) = ytoys(parlb(i),cal(1,1))
         endif
   75 continue

*---Calculate the initial theory
      CALL MESSAGE('Calculating, please wait...')
 
      LSTSER = 1
*---initialize all level of theoretical model
      call intfun(0,ierr)
      if (ierr.ne.0) goto 1000
*---now calc. spectrum for current parameter values
      CALL CALSER(1, PARNAM(CURPAR), PARVEC(CURPAR), PARLB(CURPAR), 
     &   PARUB(CURPAR), PARTYP(CURPAR), PARIDX(CURPAR), CURPAR, MINCHG,
     &   ierr)
      minchg = 99999
      if (ierr.ne.0) goto 1000
      CURSTK = STKTOT
      TOPSTK = CURSTK
      PARVEC(STKLST(CURSTK)) = STKVAL(CURSTK)
 
*---Open the windows
      CALL CLSCRN
C Parameters(1)
      CALL WNACTN('C')
      call flshbx
      CALL WNOPEN(PWINX,PWINY,PWINWD,PWINHT)
C Stack(2)
      CALL WNACTN('C')
      call flshbx
      CALL WNOPEN(SWINX,SWINY,SWINWD,SWINHT)

*---Display the data
 100  CALL CORDAT(ACTSPC,SWINY-1)
      CALL CORPLT(ACTSPC,CURSTK)
 
*---Display stack window
      CALL WINSTK
 
*---Prompt
      CALL MESSAGE('[Grey ~+~/~-~]=change spec, ~Spc~=1, ~S~eries=11,'//
     &             ' ~K~eep, ~C~lear, ~P~rint, ~O~ptions, ~ESC~ape.')
 
*---Display Parameters window
 200  CALL WNSEL(1)
      call flshbx
      CALL WNCLR
      DO 300 I = TOPPAR,MIN(TOPPAR+PWINHT-1,NPTOT)
         IF ( I.EQ.CURPAR ) THEN
            call invert
         ELSE
            call flshbx
         ENDIF
         if (partyp(i).ne.EMPTY) then
            CALL WNOUST(PARNAM(I)(:7)//' ')
            CALL PUTR(PWINX-1+9,PWINY+I-TOPPAR,PARVEC(I))
            CALL WNOUCR(1)
         else
            call wnoust(parnam(i)//'     ')
         endif
  300 CONTINUE
 
*---Highlight current parameter
 400  CALL WNSEL(1)
      BOTPAR = MIN(TOPPAR+PWINHT-1,NPTOT)
 
      IF ( CURPAR.GT.TOPPAR ) THEN
         I = CURPAR - 1
         call flshbx
         if (partyp(i).ne.EMPTY) then
            CALL WNOUSX(1,CURPAR-TOPPAR,PARNAM(I)(:7)//' ')
            CALL PUTR(PWINX-1+9,PWINY+I-TOPPAR,PARVEC(I))
         else
            call wnousx(1, curpar-toppar, parnam(i)//'      ')
         endif
      ENDIF
 
      call invert
      if (partyp(curpar).ne.EMPTY) then
         CALL WNOUSX(1,CURPAR-TOPPAR+1,PARNAM(CURPAR)(:7)//' ')
         CALL PUTR(PWINX-1+9,PWINY+CURPAR-TOPPAR,PARVEC(CURPAR))
      else
         call wnousx(1, curpar-toppar+1, parnam(curpar)//'      ')
      endif
 
      IF ( CURPAR.LT.BOTPAR ) THEN
         I = CURPAR + 1
         call flshbx
         if (partyp(i).ne.EMPTY) then
            CALL WNOUSX(1,CURPAR-TOPPAR+2,PARNAM(I)(:7)//' ')
            CALL PUTR(PWINX-1+9,PWINY+I-TOPPAR,PARVEC(I))
         else
            call wnousx(1,CURPAR-TOPPAR+2,PARNAM(I)//'      ')
         endif
      ENDIF
 
*---Display current parameter, value, & bounds
 500  call bright
      CALL CLFIEL(1,iscrow,60)
      CALL OUTSTR(PARNAM(CURPAR))
      CALL PUTR(15,iscrow,PARVEC(CURPAR))
      CALL PUTR(30,iscrow,PARLB(CURPAR))
      CALL PUTR(45,iscrow,PARUB(CURPAR))
 
  600 IF ( VARCOL.EQ.1 ) THEN
         oldval = parvec(curpar)
         CALL GETR(15,iscrow,PARVEC(CURPAR),ICHR,.TRUE.)
         if (oldval.ne.parvec(curpar)) then
            minchg = min(minchg, partyp(curpar))
         endif
      ELSEIF ( VARCOL.EQ.2 ) THEN
        CALL GETR(30,iscrow,PARLB(CURPAR),ICHR,.TRUE.)
      ELSE
        CALL GETR(45,iscrow,PARUB(CURPAR),ICHR,.TRUE.)
      ENDIF
 
      IF ( ICHR.EQ.ENTER ) THEN
        IF ( VARCOL.EQ.1 ) GOTO 400
      ELSEIF ( ICHR.EQ.ESC ) THEN
         IF (GETYN('Exit Flasher?')) goto 1000
      ELSEIF ( ICHR.EQ.RTARR ) THEN
        IF ( VARCOL.LT.3 ) THEN
          VARCOL = VARCOL + 1
          GOTO 500
        ENDIF
      ELSEIF ( ICHR.EQ.LTARR ) THEN
        IF ( VARCOL.GT.1 ) THEN
          VARCOL = VARCOL - 1
          GOTO 500
        ENDIF
      ELSEIF ( ICHR.EQ.DNARR ) THEN
        IF ( CURPAR.LT.NPTOT ) THEN
          CURPAR = CURPAR + 1
          IF ( LSTSER.GT.1 ) THEN
             if (spctot+1.ne.curstk) CALL AD2LST(SPCTOT+1,
     &          SPCNAM(CURSTK), SPCCMT(1,CURSTK), SPCTRA(1,CURSTK),
     &          SPCNOI(1,CURSTK), xspc(1,curstk),  NOMSK,
     &          SPCCAL(1,actspc), ICALSP(1,actspc))
            STKTOT = min(SPCTOT + 1, mmain)
            LSTSER = 1
            CURSTK = STKTOT
            TOPSTK = CURSTK
            CALL WINSTK
          ENDIF
          IF ( CURPAR.EQ.TOPPAR+PWINHT ) THEN
            TOPPAR = CURPAR
            GOTO 200
          ENDIF
        ENDIF
        GOTO 400
      ELSEIF ( ICHR.EQ.UPARR ) THEN
        IF ( CURPAR.GT.1 ) THEN
          CURPAR = CURPAR - 1
          IF ( LSTSER.GT.1 ) THEN
            CALL AD2LST(SPCTOT+1,SPCNAM(CURSTK),SPCCMT(1,CURSTK),
     &         SPCTRA(1,CURSTK),SPCNOI(1,CURSTK),xspc(1,curstk),
     &         NOMSK,SPCCAL(1,actspc),ICALSP(1,actspc))
            STKTOT = min(SPCTOT + 1, mmain)
            LSTSER = 1
            CURSTK = STKTOT
            TOPSTK = CURSTK
            CALL WINSTK
          ENDIF
          IF ( CURPAR.LT.TOPPAR ) THEN
            TOPPAR = MAX(TOPPAR-PWINHT+1,1)
            GOTO 200
          ENDIF
        ENDIF
        GOTO 400
      ELSEIF ( ICHR.EQ.PGDN ) THEN
        IF ( CURPAR.LE.NPTOT-PWINHT ) THEN
          CURPAR = CURPAR + PWINHT
          TOPPAR = TOPPAR + PWINHT
        ELSEIF ( TOPPAR.LE.NPTOT-PWINHT ) THEN
          TOPPAR = TOPPAR + PWINHT
          CURPAR = NPTOT
        ELSEIF ( CURPAR.LT.NPTOT ) THEN
          CURPAR = NPTOT
        ELSE
          GOTO 500
        ENDIF
        GOTO 200
      ELSEIF ( ICHR.EQ.PGUP ) THEN
        IF ( TOPPAR.GT.PWINHT ) THEN
          CURPAR = CURPAR - PWINHT
          TOPPAR = TOPPAR - PWINHT
        ELSEIF ( CURPAR.GT.PWINHT ) THEN
          CURPAR = CURPAR - PWINHT
          TOPPAR = 1
        ELSEIF ( CURPAR.GT.1 ) THEN
          CURPAR = 1
          TOPPAR = 1
        ELSE
          GOTO 500
        ENDIF
        GOTO 200
 
      ELSEIF ((ICHR.EQ.ICHAR(' ')).or.(ichr.eq.ichar('s')).or.
     &        (ichr.eq.ichar('S'))) THEN
        CALL MESSAGE('Calculating, please wait...')
        if (ichr.eq.ichar(' ')) then
           LSTSER = 1
        else
           LSTSER = min(11, mmain-spctot)
        endif
        CALL CALSER(LSTSER, PARNAM(CURPAR), PARVEC(CURPAR),
     &     PARLB(CURPAR), PARUB(CURPAR), PARTYP(CURPAR), PARIDX(CURPAR),
     &     CURPAR, minchg, ierr)
        if (lstser.eq.1) then
           minchg = 99999
        else
           minchg = partyp(curpar)
        endif
        if (ierr.eq.0) then
           CURSTK = min(SPCTOT + 1, mmain)
           TOPSTK = CURSTK
           PARVEC(STKLST(CURSTK)) = STKVAL(CURSTK)
        else
           curstk = spctot
           topstk = curstk
        endif
*---Prompt
        CALL MESSAGE('[Grey ~+~/~-~]=change spec, ~Spc~=1,'//
     &     ' ~S~eries=11, ~K~eep, ~C~lear, ~L~ist,'//
     &     ' ~O~ptions, ~ESC~ape.')
        CALL WINSTK
        CALL CORPLT(ACTSPC,CURSTK)
        GOTO 400
      ELSEIF ( ICHR.EQ.GRPLUS ) THEN
 650    IF ( CURSTK.LT.STKTOT ) THEN
          CURSTK = min(CURSTK + 1, mmain)
          IF ( CURSTK.EQ.TOPSTK+SWINHT ) TOPSTK = TOPSTK + 1
        ELSE
          CURSTK = min(SPCTOT + 1, mmain)
          TOPSTK = CURSTK
        ENDIF
        CALL WINSTK
        COUNT = 1
 700    CALL INKEYI(ICHR)
        IF ( ICHR.LT.0 ) THEN
          COUNT = COUNT + 1
          IF ( MOD(COUNT,DELAY).NE.0 ) GOTO 700
          CALL CORPLT(ACTSPC,CURSTK)
          IF ( (CURSTK.GT.SPCTOT) .AND. (LSTSER.GT.1) )
     &         PARVEC(STKLST(CURSTK)) = STKVAL(CURSTK)
          GOTO 400
        ELSEIF ( ICHR.EQ.GRPLUS ) THEN
          GOTO 650
        ELSE
          GOTO 700
        ENDIF
      ELSEIF ( ICHR.EQ.GRMIN ) THEN
 750    IF ( CURSTK.GT.1 ) THEN
          CURSTK = CURSTK - 1
          IF ( CURSTK.LT.TOPSTK ) TOPSTK = CURSTK
          CALL WINSTK
        ENDIF
        COUNT = 1
 800    CALL INKEYI(ICHR)
        IF ( ICHR.LT.0 ) THEN
          COUNT = COUNT + 1
          IF ( MOD(COUNT,DELAY).NE.0 ) GOTO 800
          CALL WINSTK
          CALL CORPLT(ACTSPC,CURSTK)
          IF ( (CURSTK.GT.SPCTOT) .AND. (LSTSER.GT.1) )
     &         PARVEC(STKLST(CURSTK)) = STKVAL(CURSTK)
          GOTO 400
        ELSEIF ( ICHR.EQ.GRMIN ) THEN
          GOTO 750
        ELSE
          GOTO 800
       ENDIF
*---------------------------------------------------------------------------
      ELSEIF ( (ICHR.EQ.ICHAR('K')) .OR. (ICHR.EQ.ICHAR('k')) ) THEN
*---copy currently shown simulation to LIST so that it wiil be available
*---after FLASHER is exited.
*---Move simulations down LIST one slot to make roome for "kept" simulation.
         DO 820 I = min(STKTOT,mmain-1),SPCTOT + 1, -1
            CALL AD2LST(I+1,SPCNAM(I),SPCCMT(1,I),SPCTRA(1,I),
     &         SPCNOI(1,I),xspc(1,I),NOMSK,SPCCAL(1,I),
     &         ICALSP(1,I))
            STKVAL(I+1) = STKVAL(I)
            STKLST(I+1) = STKLST(I)
  820    CONTINUE
*---increment slot pointers occupied
         SPCTOT = min(SPCTOT + 1, mmain)
         STKTOT = min(STKTOT + 1, mmain)
         CURSTK = min(CURSTK + 1, mmain)
         IF ( CURSTK.EQ.TOPSTK+SWINHT ) TOPSTK = TOPSTK + 1
*---copy simulation to LIST
         if (spctot.ne.curstk) CALL AD2LST(SPCTOT, SPCNAM(CURSTK),
     &      SPCCMT(1,CURSTK), SPCTRA(1,CURSTK), SPCNOI(1,CURSTK),
     &      xspc(1,curstk), NOMSK, SPCCAL(1,curstk), ICALSP(1,curstk))
         CALL WINSTK
*---Ring bell and display confirmation
         call errmsg('Theoretical spectrum copied to LIST.')
*---refresh top line prompts
      CALL MESSAGE('[Grey ~+~/~-~]=change spec, ~Spc~=1, ~S~eries=11,'//
     &             ' ~K~eep, ~C~lear, ~P~rint, ~O~ptions, ~ESC~ape.')
*----------------------------------------------------------------------------
      ELSEIF ( (ICHR.EQ.ICHAR('C')) .OR. (ICHR.EQ.ICHAR('c')) ) THEN
        CURSTK = SPCTOT
        STKTOT = SPCTOT
        TOPSTK = SPCTOT
        LSTSER = 1
        CALL WINSTK
        CALL CORPLT(ACTSPC,SPCTOT)
      ELSEIF ( (ICHR.EQ.ICHAR('P')) .OR. (ICHR.EQ.ICHAR('p')) ) THEN
        CALL GETVEC
        CALL LSTPAR
        GOTO 100
      elseif ( (ichr.eq.ichar('o')) .or. (ichr.eq.ichar('O'))) then
         call options
         call cordat(actspc,swiny-1)
         call corplt(actspc,curstk)
         goto 200
      ELSEIF ( ICHR.EQ.CTRLP .and. .not. zcrip) THEN
        CALL INTPRN
        call normal
        call garea(0.,0.,1.,1.)
        call gclear
        CALL SHOACT(.TRUE.)
        call corplt(actspc,curstk)
        call clsprn
        call garea(0.,0.,1.,1.)
        call gclear
        GOTO 100
c	PION Refresh SCRN
	ELSEIF ( ICHR.EQ.ALTR ) THEN
        call garea(0.,0.,1.,1.)
        call gclear
        GOTO 100
c

      elseif (ichr.eq.F8) then
         if (zscale) then
            call zoom
         else
            zscale = .true.
         endif
         call cordat(actspc,swiny-1)
         call corplt(actspc,curstk)
         goto 200
      ENDIF
      GOTO 600

*---Convert baseline values from scaled y-values to raw data
 1000 do 625 i = 1, nptot
         if (partyp(i).eq.BLTYP) then
            parvec(i) = ystoy(parvec(i),cal(1,1))
            parub(i) = ystoy(parub(i),cal(1,1))
            parlb(i) = ystoy(parlb(i),cal(1,1))
         endif
  625 continue

      CALL GETVEC
 
      CALL WNCLOS(0)
      CALL WNCLOS(0)
 
      call normal
      call garea(0.,0.,1.,1.)
      call gclear
      CALL CLSCRN
      CALL SHOLST
      CALL SHOACT(.FALSE.)

      return
      END

