      SUBROUTINE FORCIN(NFREE,VFREE,VUB,VLB,IEXPT,DIST)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     930109 CS          mru 19May94 CS
*-----------------------------------------------------------------------
*     Forces a set of variables to be between the upper and lower
*     bounds, and calculates a measure of how far outside the bounds
*     the variables initially were.
*
*     nfree  : [input]  number of variables;
*     vfree  : [input]  initial variables;
*            : [output] variables forced within bounds;
*     vub    : [input]  upper bounds;
*     vlb    : [input]  lower bounds;
*     iexpt  : [input]  exponent by which to raise differences;
*     dist   : [output] distance of initial variables outside bounds,
*            : scaled by the distance between the upper & lower bounds.
*-----------------------------------------------------------------------
      INTEGER NFREE, iexpt
      REAL VFREE(NFREE),VUB(NFREE),VLB(NFREE)
      REAL DIST
*-----------------------------------------------------------------------
      INTEGER I
      REAL VF
*-----------------------------------------------------------------------
      DIST = 0.
 
      DO 100 I = 1,NFREE
        VF = MIN(MAX(VFREE(I),VLB(I)),VUB(I))
 
        IF ( VF.GT.VFREE(I) ) THEN
          DIST = DIST + ((VF-VFREE(I))/(VUB(I)-VLB(I)))**IEXPT
          VFREE(I) = VF
        ELSEIF ( VF.LT.VFREE(I) ) THEN
          DIST = DIST - ((VF-VFREE(I))/(VUB(I)-VLB(I)))**IEXPT
          VFREE(I) = VF
        ENDIF
 100  CONTINUE
 
      RETURN
      END
