*-----------------------------------------------------------------------
      SUBROUTINE GETPAR(IERR)
*-----------------------------------------------------------------------
      INTEGER IERR
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     mru 09jun93 CS
*     Reads a parameter file into the common blocks in PARCOM.INC
*
*     ierr   : [Output] Returned error code
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'constcom.inc'
      INCLUDE 'iocom.inc'
      INCLUDE 'parcom.inc'
 
      INTEGER ATTMPT,I,K,ISUB
      INTEGER NSITES,NLINES
 
      CHARACTER*40 DUMMY
*-----------------------------------------------------------------------
      ATTMPT = 2
 
C READ TITLE AND COMMENT
      READ (JDISK,'(A1)',ERR=900,IOSTAT=IERR) DUMMY
      READ (JDISK,*,ERR=900,IOSTAT=IERR) DUMMY
      READ (JDISK,*,ERR=900,IOSTAT=IERR) PARCMT(1)
      READ (JDISK,*,ERR=900,IOSTAT=IERR) PARCMT(2)
      READ (JDISK,*,ERR=900,IOSTAT=IERR) PARCMT(3)
      READ (JDISK,*,ERR=900,IOSTAT=IERR) PARCMT(4)
      READ (JDISK,'(a1)',ERR=900,IOSTAT=IERR) DUMMY
 
c     /* Integer Fitting Parameters */
      READ (JDISK,*,ERR=900,IOSTAT=IERR)
      READ (JDISK,*,ERR=900,IOSTAT=IERR)
      READ (JDISK,*,ERR=900,IOSTAT=IERR) K,FITNAM(1),NFIPAR
      DO 100 I = 2,NFIPAR
        READ (JDISK,*,ERR=900,IOSTAT=IERR) K,FITNAM(I),IFP(I)
 100  CONTINUE
 
c     /* Parameter filenames */
      READ (JDISK,*,ERR=900,IOSTAT=IERR)
      READ (JDISK,*,ERR=900,IOSTAT=IERR)
      READ (JDISK,*,ERR=900,IOSTAT=IERR) FILNAM(2)
 
c     /* Integer Global Parameters */
      NGLO = 1
      READ (JDISK,*,ERR=900,IOSTAT=IERR)
      READ (JDISK,*,ERR=900,IOSTAT=IERR)
      READ (JDISK,*,ERR=900,IOSTAT=IERR)
      READ (JDISK,*,ERR=900,IOSTAT=IERR) K,IGPNAM(1,NGLO),IGP(1,NGLO)
      DO 200 I = 2,IGP(1,NGLO)
        READ (JDISK,*,ERR=900,IOSTAT=IERR) K,IGPNAM(I,NGLO),IGP(I,NGLO)
 200  CONTINUE
      DO 300 I = IGP(1,NGLO) + 1,MIGPAR
        IGPNAM(I,NGLO) = 'Error'
        IGP(I,NGLO) = 0
 300  CONTINUE
 
c     /* Global Nonlinear Parameters */
      READ (JDISK,*,ERR=900,IOSTAT=IERR)
      READ (JDISK,*,ERR=900,IOSTAT=IERR)
      READ (JDISK,*,ERR=900,IOSTAT=IERR)
      DO 400 I = 1,IGP(2,NGLO)
        READ (JDISK,*,ERR=900,IOSTAT=IERR) K,PGNAM(I,NGLO),PG0(I,NGLO),
     &        KONG(I,NGLO),PGLB(I,NGLO),PGUB(I,NGLO)
        WEIG(I,NGLO) = 1.0
 400  CONTINUE
      DO 500 I = IGP(2,NGLO) + 1,MGPAR
        PGNAM(I,NGLO) = 'Error'
        PG0(I,NGLO) = 0.
        KONG(I,NGLO) = 0
        PGLB(I,NGLO) = 0.
        PGUB(I,NGLO) = 0.
        WEIG(I,NGLO) = 0.
 500  CONTINUE
 
*------------------------------
*---Read local parameters
*------------------------------
 
      IF ( FILVER.GE.0 ) THEN
        NSITES = IFP(3)
      ELSE
        NSITES = NSUBS
      ENDIF
 
      DO 800 ISUB = 1,MIN(NSITES,MLOC)
        IF ( (ATTMPT.GT.1) .OR. (ISUB.EQ.1) ) THEN
 
c           /* Local Integer Parameters */
          READ (JDISK,*,ERR=900,IOSTAT=IERR)
          READ (JDISK,*,ERR=900,IOSTAT=IERR)
          READ (JDISK,*,ERR=900,IOSTAT=IERR)
          READ (JDISK,*,ERR=900,IOSTAT=IERR) K,ILPNAM(1,ISUB),
     &          ILP(1,ISUB)
          DO 520 I = 2,ILP(1,ISUB)
            READ (JDISK,*,ERR=900,IOSTAT=IERR) K,ILPNAM(I,ISUB),
     &            ILP(I,ISUB)
 520      CONTINUE
          DO 540 I = ILP(1,ISUB) + 1,MILPAR
            ILPNAM(I,ISUB) = 'Error'
            ILP(I,ISUB) = 0
 540      CONTINUE
        ELSEIF ( ATTMPT.EQ.1 ) THEN
c           /* Copy ilp for each local site from first site */
          DO 560 I = 1,MILPAR
            ILP(I,ISUB) = ILP(I,1)
            ILPNAM(I,ISUB) = ILPNAM(I,1)
 560      CONTINUE
        ENDIF
 
c        /* Linear Parameters */
        READ (JDISK,*,ERR=900,IOSTAT=IERR)
        READ (JDISK,*,ERR=900,IOSTAT=IERR)
        READ (JDISK,*,ERR=900,IOSTAT=IERR)
        IF ( FILVER.GT.-5 ) THEN
c           /* Read a fixed number of linear lines: */
c           /* 2 for WMRS, 1 otherwise. */
          CALL UPPERC(PROG)
          IF ( PROG.EQ.'WMRS' ) THEN
            NLINES = 2
          ELSE
            NLINES = 1
          ENDIF
          DO 580 I = 1,NLINES
            IF ( FILVER.GT.-2 ) THEN
              READ (JDISK,*,ERR=900,IOSTAT=IERR) K,PLNNAM(I,ISUB),
     &              PLN0(I,ISUB),KONLN(I,ISUB)
              WEILN(I,ISUB) = 1.0
            ELSE
              READ (JDISK,*,ERR=900,IOSTAT=IERR) K,PLNNAM(I,ISUB),
     &              PLN0(I,ISUB),KONLN(I,ISUB),WEILN(I,ISUB)
            ENDIF
            PLNUB(I,ISUB) = 1.0
            PLNLB(I,ISUB) = 0.0
 580      CONTINUE
          DO 600 I = NLINES + 1,MLLPAR
            PLNNAM(I,NGLO) = 'Error'
            PLN0(I,NGLO) = 0.
            KONLN(I,NGLO) = 0
            WEILN(I,NGLO) = 0.
 600      CONTINUE
        ELSE
          DO 620 I = 1,ILP(3,ISUB)
            READ (JDISK,*,ERR=900,IOSTAT=IERR) K,PLNNAM(I,ISUB),
     &            PLN0(I,ISUB),KONLN(I,ISUB),WEILN(I,ISUB)
            PLNUB(I,ISUB) = 1.0
            PLNLB(I,ISUB) = 0.0
 620      CONTINUE
          DO 640 I = ILP(3,ISUB) + 1,MLLPAR
            PLNNAM(I,ISUB) = 'Error'
            PLN0(I,ISUB) = 0.
            KONLN(I,ISUB) = 0
            WEILN(I,ISUB) = 0.
 640      CONTINUE
        ENDIF
 
c        /* Local Nonlinear Parameters */
        READ (JDISK,*,ERR=900,IOSTAT=IERR)
        READ (JDISK,*,ERR=900,IOSTAT=IERR)
        READ (JDISK,*,ERR=900,IOSTAT=IERR)
        DO 650 I = 1,ILP(2,ISUB)
          READ (JDISK,*,ERR=900,IOSTAT=IERR) K,PLNAM(I,ISUB),PL0(I,ISUB)
     &          ,KONL(I,ISUB),PLLB(I,ISUB),PLUB(I,ISUB)
          WEIL(I,ISUB) = 1.0
 650    CONTINUE
        DO 700 I = ILP(2,ISUB) + 1,MLPAR
          PLNAM(I,ISUB) = 'Error'
          PL0(I,ISUB) = 0.
          KONL(I,ISUB) = 0
          PLLB(I,ISUB) = 0.
          PLUB(I,ISUB) = 0.
          WEIL(I,ISUB) = 0.
 700    CONTINUE
 800  CONTINUE
 
*------------------------
*---Error Handler
*------------------------
 
 900  IF ( IERR.NE.0 ) THEN
        CALL ERRMSG('Error: BAD PARAMETER FILE')
      ELSE
        CALL PARADJ
        IF ( NSUBS.GT.MLOC ) THEN
          CALL ERRMSG('Warning: Not all subsites could be loaded!')
          NSUBS = MLOC
        ENDIF
      ENDIF
 
      RETURN
      END
