*-----------------------------------------------------------------------
      SUBROUTINE GETR(IX1,IY1,PARAM,ICHR,ARRESC)
*-----------------------------------------------------------------------
* Gets a real value from the user at a specific point on the screen,
* returning the user's last keypress.  The flag ARRESC specifies whether
* a key other than ENTER or ESC will exit the routine.
*
* ix1    : x-position of the input field
* iy1    : y-position of the input field
* param  : default value; returns the user's input
* ichr   : keycode of the key pressed which caused GETR to return
* arresc : can keys other than ENTER and ESC cause GETR to return?
*-----------------------------------------------------------------------
      INCLUDE 'keycom.inc'
*-----------------------------------------------------------------------
      REAL PARAM
      LOGICAL ARRESC
      INTEGER IX1,IY1,ICHR
*-----------------------------------------------------------------------
      REAL DUMMY
      INTEGER LENSTR,EXPNT,IX,IY
      LOGICAL POINT
      CHARACTER*8 INSTR,INSTR1
      CHARACTER*9 INSTR2
 
      INTEGER LOCCHR,INFOER,INFOCU
      EXTERNAL LOCCHR,INFOER,INFOCU
*-----------------------------------------------------------------------
 
*---Display highlighted default value left-justified
      IF ( IX1.LE.0 ) THEN
        IX = INFOCU(1)
      ELSE
        IX = IX1
      ENDIF
      IF ( IY1.LE.0 ) THEN
        IY = INFOCU(2)
      ELSE
        IY = IY1
      ENDIF
      CALL CONVRT(PARAM,INSTR1,.TRUE.)
 
      INSTR = INSTR1(LOCCHR(INSTR1):)
 
      CALL SAVCOL
      CALL INVERT
      CALL OUTSXY(IX,IY,INSTR)
 
*---Get the first keypress
      CALL INKEY(ICHR)
 
      IF ( .NOT.(((ICHR.LT.ICHAR('0')) .OR. (ICHR.GT.ICHAR('9'))) .AND. 
     &     (ICHR.NE.ICHAR('-')) .AND. (ICHR.NE.ICHAR('.')) .AND. 
     &     (ICHR.NE.ICHAR('E')) .AND. (ICHR.NE.ICHAR('e'))) ) THEN
 
        POINT = (ICHR.EQ.ICHAR('.'))
        IF ( (ICHR.EQ.ICHAR('e')) .OR. (ICHR.EQ.ICHAR('E')) ) THEN
          EXPNT = 1
        ELSE
          EXPNT = 0
        ENDIF
 
        INSTR = CHAR(ICHR)
        LENSTR = 1
        CALL OUTSXY(IX,IY,INSTR)
 
*---Clear interacter error flag
        DUMMY = INFOER(1)
 
 
 50     IF ( LENSTR.GT.0 ) THEN
          CALL OUTSXY(IX-1+LENSTR,IY,INSTR(LENSTR:LENSTR))
        ELSE
          CALL CURXY(IX,IY)
        ENDIF
        IF ( LENSTR.LE.7 ) CALL OUTSTR('_')
        IF ( LENSTR.LE.6 ) CALL OUTSTR(' ')
 
        CALL INKEY(ICHR)
 
        IF ( (ICHR.GE.ICHAR('0')) .AND. (ICHR.LE.ICHAR('9')) .AND. 
     &       (LENSTR.LT.8) .AND. ((EXPNT.EQ.0) .OR. (LENSTR-EXPNT.LE.2))
     &       ) THEN
          INSTR1 = INSTR
          IF ( LENSTR.GT.0 ) THEN
            INSTR = INSTR1(:LENSTR)//CHAR(ICHR)
          ELSE
            INSTR = CHAR(ICHR)
          ENDIF
          LENSTR = LENSTR + 1
        ELSEIF ( (ICHR.EQ.ICHAR('-')) .AND. (LENSTR.EQ.0) ) THEN
          INSTR = '-'
          LENSTR = 1
        ELSEIF ( (ICHR.EQ.ICHAR('-')) .AND. (EXPNT.EQ.LENSTR) .AND. 
     &           (LENSTR.LT.8) ) THEN
          INSTR1 = INSTR
          INSTR = INSTR1(:LENSTR)//CHAR(ICHR)
          LENSTR = LENSTR + 1
        ELSEIF ( ((ICHR.EQ.ICHAR('e')) .OR. (ICHR.EQ.ICHAR('E'))) .AND. 
     &           (EXPNT.EQ.0) .AND. (LENSTR.LT.8) ) THEN
          INSTR1 = INSTR
          IF ( LENSTR.GT.0 ) THEN
            INSTR = INSTR1(:LENSTR)//CHAR(ICHR)
          ELSE
            INSTR = CHAR(ICHR)
          ENDIF
          LENSTR = LENSTR + 1
          EXPNT = LENSTR
        ELSEIF ( (ICHR.EQ.ICHAR('.')) .AND. (EXPNT.EQ.0) .AND. 
     &           .NOT.POINT .AND. (LENSTR.LT.8) ) THEN
          POINT = .TRUE.
          INSTR1 = INSTR
          IF ( LENSTR.GT.0 ) THEN
            INSTR = INSTR1(:LENSTR)//'.'
          ELSE
            INSTR = '.'
          ENDIF
          LENSTR = LENSTR + 1
        ELSEIF ( ((ICHR.EQ.127) .OR. (ICHR.EQ.8)) .AND. (LENSTR.GT.0) )
     &           THEN
          IF ( INSTR(LENSTR:LENSTR).EQ.'.' ) THEN
            POINT = .FALSE.
          ELSEIF ( INSTR(LENSTR:LENSTR).EQ.'E' ) THEN
            EXPNT = 0
          ELSEIF ( INSTR(LENSTR:LENSTR).EQ.'e' ) THEN
            EXPNT = 0
          ENDIF
          LENSTR = LENSTR - 1
        ELSEIF ( (ICHR.EQ.ENTER) .OR. (ICHR.EQ.ESC) .OR. (ICHR.EQ.TAB)
     &           .OR. ((ICHR.GE.UPARR) .AND. (ICHR.LE.PGDN) .AND. 
     &           ARRESC) ) THEN
          IF ( LENSTR.GT.0 ) THEN
            IF ( (INSTR(1:1).EQ.'e') .OR. (INSTR(1:1).EQ.'E') ) THEN
              INSTR2 = '1'//INSTR(:LENSTR)
            ELSEIF ( (INSTR(1:2).EQ.'-e') .OR. (INSTR(1:2).EQ.'-E') )
     &               THEN
              INSTR2 = '-1'//INSTR(2:LENSTR)
            ELSE
              INSTR2 = INSTR(:LENSTR)
            ENDIF
            CALL STRREA(INSTR2,PARAM)
            IF ( INFOER(1).NE.0 ) GOTO 50
          ENDIF
          GOTO 100
        ENDIF
        GOTO 50
      ENDIF
 
 100  CALL RSTCOL
      CALL PUTR(IX,IY,PARAM)
      RETURN
      END
