      SUBROUTINE GETSCR
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:  1992 cs
*---mru :  930315 tk
*---Purpose:
*     Reads the screen definition file specified in the configuration
*     file.
*-----------------------------------------------------------------------
*---parameters and common blocks
      INCLUDE 'iocom.inc'
      INCLUDE 'constcom.inc'
      INCLUDE 'scrncom.inc'
      INCLUDE 'plotcom.inc'
*---internals
      CHARACTER*60 FNAME
      CHARACTER*80 INLINE
      CHARACTER*20 KEY
      CHARACTER*60 VAL1
      REAL VALUE
      INTEGER ISTAT,EQSIGN,EXMARK,IERR
      LOGICAL ISNUM
*---external functions
      INTEGER LENACT,INFOER
      EXTERNAL LENACT,INFOER
*-----------------------------------------------------------------------
*---executables
*---Initialize default values
      BOXLLX = 0.0
      BOXLLY = 0.106
      BOXURX = 0.83
      BOXURY = 0.96667
      ISCX = 640
      ISCY = 480
 
      VXTLSZ = 0.04
      UYTLSZ = 0.03
 
      FNAME = SCRFIL
*---look for screen file as defined in configuration file
      OPEN (JDISK,FILE=FNAME,STATUS='OLD',IOSTAT=ISTAT)
      IF ( ISTAT.NE.0 ) THEN
        WRITE (*,*) 'Could not open screen file '//SCRFIL
     &              (1:LENACT(SCRFIL))
        WRITE (*,*) 'Check "screenfile" entry in configuraton file.'
        WRITE (*,*) 'Press ENTER to continue ...'
        READ (*,*)
        GOTO 300
      ENDIF
 100  READ (JDISK,'(A80)',END=200) INLINE
      EQSIGN = INDEX(INLINE,'=')
      EXMARK = INDEX(INLINE,'!')
      IF ( EXMARK.EQ.0 ) EXMARK = LEN(INLINE) + 1
*---Ignore a line starting with an exclamation point
      IF ( EXMARK.EQ.1 ) THEN
*---Skip keyless lines
      ELSEIF ( LENACT(INLINE(1:EXMARK-1)).NE.0 ) THEN
        KEY = INLINE(1:EQSIGN-1)
        VAL1 = INLINE(EQSIGN+1:EXMARK-1)
        CALL JUSTIF(KEY,'L')
        CALL JUSTIF(VAL1,'L')
        CALL UPPERC(KEY)
        IERR = INFOER(1)
        CALL STRREA(VAL1,VALUE)
        ISNUM = (INFOER(1).EQ.0)
 
        IF ( (KEY.EQ.'BOX-LLX') .AND. ISNUM ) THEN
          BOXLLX = VALUE
        ELSEIF ( (KEY.EQ.'BOX-LLY') .AND. ISNUM ) THEN
          BOXLLY = VALUE
        ELSEIF ( (KEY.EQ.'BOX-URX') .AND. ISNUM ) THEN
          BOXURX = VALUE
        ELSEIF ( (KEY.EQ.'BOX-URY') .AND. ISNUM ) THEN
          BOXURY = VALUE
        ELSEIF ( (KEY.EQ.'XPIXELS') .AND. ISNUM ) THEN
          ISCX = INT(VALUE)
        ELSEIF ( (KEY.EQ.'YPIXELS') .AND. ISNUM ) THEN
          ISCY = INT(VALUE)
        ELSEIF ( (KEY.EQ.'XBORDER') .AND. ISNUM ) THEN
          XBORDR = VALUE
        ELSEIF ( (KEY.EQ.'YBORDER') .AND. ISNUM ) THEN
          YBORDR = VALUE
        ELSEIF ( KEY.EQ.'XTITLE' ) THEN
          IF ( VAL1(1:2).EQ.'ON' ) THEN
            VXTLSZ = 0.04
          ELSE
            VXTLSZ = 0.00
          ENDIF
        ELSEIF ( KEY.EQ.'YTITLE' ) THEN
          IF ( VAL1(1:2).EQ.'ON' ) THEN
            UYTLSZ = 0.03
          ELSE
            UYTLSZ = 0.00
          ENDIF
        ELSEIF ( LENACT(KEY).EQ.0 ) THEN
          WRITE (*,*) 'Missing keyword in SCR file.'
        ELSE
          WRITE (*,*) 'Unrecognized keyword in SCR file.'
        ENDIF
      ENDIF
      GOTO 100
 
 200  CLOSE (JDISK)
 
 300  RETURN
      END
