      SUBROUTINE hfdplt
*---Given current parameter value for HFD/VBF model (model #6),
*---generate probability distributions for each subsite and for total.
*---Plot on screen. Prompt for options.
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 19980304 tk
*--- mru: 19980316 tk
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'iocom.inc'
      INCLUDE 'constcom.inc'
      INCLUDE 'keycom.inc'
      INCLUDE 'scrncom.inc'
      INCLUDE 'parcom.inc'
      include 'speccom.inc'
      include 'togcom.inc'

*---internals
      logical zbar0, zline0, zpt0, zsmbl0
      integer npts, ipt, isub, i
      parameter (npts = 256)
      REAL z(npts),Pz(npts,mloc)
      real Ptot(npts)
      real sum
*---storage for plot info
      integer ichr
      real x1, x2
      real step, z0, dz
      integer INOCAL(mcal)
      logical nomask(npts)
      real NOCAL(mcal)
      real NONOYS(npts)
      character*(mfllen) nam(2)
      character*72 cmt(mcommt)
 
*---external functions
      real gaussn
      external gaussn
*-----------------------------------------------------------------------
*---executables

*---store plot switches and set switches for data line plot
      zbar0 = zbar
      zline0 = zline
      zpt0 = zpoint
      zsmbl0 = zsymbl
      zbar = .false.
      zline = .true.
      zpoint = .false.
      zsymbl = .false.

      if( model .ne. 7 ) then
         call errmsg('Loaded Parameter Set is not a HFD model.')
         return
      endif
*---initialize fake cal info
      
      cmt(1) = 'Hyperfine Field Distribution ( z [mm/s] )'
      do 5 i=2,mcommt
      cmt(i) = ' '
5     continue

      do 10 i=1,mcal
      inocal(i)=0
      nocal(i) = 0.0
10    continue
      inocal(1) = npts
*---define data type for SHODAT
      inocal(10) = 203

*---Set X-range to include +/- 2*FWHM
        z0 = pl0(2,1)
        dz = pl0(3,1)
      x1 =  z0 - 1.0
      x2 =  z0 + 1.0
      do 12 isub=1,nsubs
        z0 = pl0(2,isub)
        dz = pl0(3,isub)
          if(dz.lt. 0.02) then
      call errmsg('Distribution width too small in HFD Plot.')
      return
          endif
        x1 = amin1(x1,z0-2.0*dz)
        x2 = amax1(x2,z0+2.0*dz)
12    continue
      step = (X2-X1) /(npts-1)
      nocal(7) = step
      do 20 i=1,npts
         nonoys(i) = 0
         nomask(i) = .true.
         z(i) = X1 + (i-1)*step
         Ptot(i) = 0.0
20    continue


*---Loop over local sites
      do 100 isub=1,nsubs
        z0 = pl0(2,isub)
        dz = pl0(3,isub)
        sum = 0
        do 50 ipt=1,npts
            Pz(ipt,isub) = gaussn(z(ipt)-z0, dz)
            sum = sum + Pz(ipt,isub)
50      continue
*---normalize Pz [per mm/s] for this local site.
*---apply area fractions
*---add to total
        do 60 ipt=1,npts
           Pz(ipt,isub) = pln0(1,isub)*Pz(ipt,isub)/(sum*step)
           Ptot(ipt) = Ptot(ipt) + Pz(ipt,isub)
60      continue

100   continue

*---menu loop
700   continue

      nam(1) = 'HFD'
      nam(2) = ' '
      CALL CLSCRN
*---Prompt
        CALL MESSAGE('~K~eep,  ~P~rint Params,  Print P~l~ot,'//
     &   '  ~Z~oom,  ~O~ptions,  ~ESC~ape.')

*---plot total distribution on screen
       CALL SHODAT(.true.,Npts,z,Ptot,NONOYS,INOCAL,NOCAL,
     &   NOMASK,1.0,0,0,NAM,CMT,.FALSE.)
      if(shosub)then
*---plot contribution on each local site
      do 200 isub=1,nsubs
       CALL SHODAT(.false.,Npts,z,Pz(1,isub),NONOYS,INOCAL,
     &   NOCAL,NOMASK,1.0,0,0,NAM,CMT,.FALSE.)
200   continue
      endif
*---wait for key stroke
      CALL INKEY(ICHR)

      IF ( (ICHR.EQ.ICHAR('K')) .OR. (ICHR.EQ.ICHAR('k')) ) THEN
*---copy currently shown simulation to LIST so that it wiil be available
*---after hfdPLT is exited.
*---increment slot pointers occupied
         if(spctot.eq.mmain)then
            call errmsg('List is full!')
         else
           SPCTOT = SPCTOT + 1
           CALL AD2LST(SPCTOT, NAM,CMT, Ptot, nonoys,
     &      z, NOMASK, noCAL, inocal)
         endif
*---copy sub distributioins to list?
        if(stosub)then
          do 250 isub=1,nsubs
           if(spctot.eq.mmain)then
            call errmsg('List is full!')
           else
            SPCTOT = SPCTOT + 1
            nam(1) = 'HFD '//char(48+isub)
            CALL AD2LST(SPCTOT, NAM,CMT, Pz(1,isub), nonoys,
     &       z, NOMASK, noCAL, inocal)
           endif
250       continue
         endif
      ELSEIF ( (ICHR.EQ.ICHAR('P') .OR. ICHR.EQ.ICHAR('p'))
     &          .and. .not. zcrip) THEN
        CALL GETVEC
        CALL LSTPAR
      elseif ( (ichr.eq.ichar('o')) .or. (ichr.eq.ichar('O'))) then
         call options
      ELSEIF ( (ichr.eq.ichar('l') .or. ichr.eq.ichar('L')
     &          .or. ICHR.EQ.CTRLP) .and. .not. zcrip) THEN
        CALL INTPRN
        call normal
        call garea(0.,0.,1.,1.)
        call gclear
*---plot total distribution on screen
       CALL SHODAT(.true.,Npts,z,Ptot,NONOYS,INOCAL,NOCAL,
     &   NOMASK,1.0,0,0,NAM,CMT,.FALSE.)
      if(shosub)then
*---plot contribution on each local site
      do 300 isub=1,nsubs
       CALL SHODAT(.false.,Npts,z,Pz(1,isub),NONOYS,INOCAL,
     &   NOCAL,NOMASK,1.0,0,0,NAM,CMT,.FALSE.)
300   continue
      endif
        call clsprn
        call garea(0.,0.,1.,1.)
        call gclear
      elseif (ichr.eq.ichar('z') .or. ichr.eq.ichar('Z')
     &        .or. ichr.eq.F8) then
         if (zscale) then
            call zoom
         else
            zscale = .true.
         endif
      elseif (ichr.eq.esc) then
*---Update screen with new plot of active spectrum and numerical info.
*---restore plot switches
*      logical zbar0, zline0, zpt0, zsmbl0
      zbar = zbar0
      zline = zline0
      zpoint = zpt0
      zsymbl = zsmbl0
*---Update List.
*---Then return to topmnu.
        CALL SHOACT(.FALSE.)
        call sholst
        RETURN
      ENDIF

      GOTO 700

 
      END

