*-----------------------------------------------------------------------
      SUBROUTINE INSSUB(ISUBIN,IZSITE,IERR)
*-----------------------------------------------------------------------
      INTEGER ISUBIN,IZSITE,IERR
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     03Aug93 cs
*
*     Inserts a subsite by duplicating subsite #ISUB and moving all
*     other subsites down by one.
*
*     isubin : [Input]  Subsite number to delete;
*     izsite : [Input]  1: zero constraints for 1st site of new pair,
*                       2: zero constraints for 2nd site of new pair.
*     ierr   : [Output] Error code.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'errcodes.inc'
 
      INTEGER I,J,ISUB,IPAR
*-----------------------------------------------------------------------
      INTEGER IJ2KON,KON2I,KON2J
 
      IJ2KON(I,J) = I + 100*J
      KON2I(I) = 1 + MOD(I-1,100)
      KON2J(I) = I/100
*-----------------------------------------------------------------------
 
      IF ( NSUBS.GE.MLOC ) THEN
        IERR = ERRTOOMANYSITES
      ELSEIF ( (IZSITE.LT.1) .OR. (IZSITE.GT.2) ) THEN
        IERR = ERRBADARGUMENT
      ELSE
        IERR = 0
 
c        ;; Move other subsites out of the way
        DO 50 ISUB = NSUBS,ISUBIN, - 1
          CALL CPYLOC(ISUB,ISUB+1,.FALSE.)
 50     CONTINUE
        NSUBS = NSUBS + 1
 
c        ;; Zero constraints for one subsite of the new pair
        DO 100 IPAR = 1,ILP(3,ISUBIN+IZSITE-1)
          KONLN(IPAR,ISUBIN+IZSITE-1) = 0
 100    CONTINUE
        DO 150 IPAR = 1,ILP(2,ISUBIN+IZSITE-1)
          KONL(IPAR,ISUBIN+IZSITE-1) = 0
 150    CONTINUE
 
c        ;; Adjust constraints that pointed past a subsite that moved
        DO 200 ISUB = 1,NSUBS
          DO 160 IPAR = 1,ILP(2,ISUB)
            I = KON2I(KONL(IPAR,ISUB))
            J = KON2J(KONL(IPAR,ISUB))
            IF ( J.GE.ISUBIN+IZSITE-1 ) KONL(IPAR,ISUB) = IJ2KON(I,J+1)
 160      CONTINUE
          DO 180 IPAR = 1,ILP(3,ISUB)
            I = KON2I(KONLN(IPAR,ISUB))
            J = KON2J(KONLN(IPAR,ISUB))
            IF ( J.GE.ISUBIN+IZSITE-1 ) KONLN(IPAR,ISUB) = IJ2KON(I,J+1)
 180      CONTINUE
 200    CONTINUE
      ENDIF
 
      RETURN
      END
