      subroutine interp(mcal, ioldcl, oldcal, oldspc, oldnoi, inewcl,
     &   newcal, newspc, newnoi)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 
*---mru : tk 930501; tk 19971216 ' 19980215 tk
*---Purpose:
*     Does interpolation to create a MOSS spectrum which has a
*     new zero velocity channel and new scale but the % effect.
*---arguements
*     ioldcl : Old integer calibration array
*     oldcal : Old real calibration array
*     oldspc : Old spectrum
*     oldnoi : Old noise array
*     inewcl : New integer calibration array
*     newcal : New real calibration array
*     newspc : New interpolated spectrum
*     newnoi : New noise array
*----------------------------------------------------------------------
      integer mcal, ioldcl(mcal), inewcl(mcal)
      real newcal(mcal), oldcal(mcal)
      real oldspc(*), oldnoi(*)
      real newspc(*), newnoi(*)
*---internals
      real ric, f, oldv0, oldstp, newv0, newstp, oldar, bln, arn, vn
      integer i, oldpts, newpts, icn, ic, icr, itype
*---external functions
      real addvec
      external addvec
*----------------------------------------------------------------------
*---executables
      itype  = ioldcl(10)

      oldpts = ioldcl(1)
      oldv0  = oldcal(6)
      oldstp = oldcal(7)

      newpts = inewcl(1)
      newv0  = newcal(6)
      newstp = newcal(7)

      if ((oldv0.eq.newv0).and.(oldstp.eq.newstp).and.
     &   (oldpts.eq.newpts)) then
         call vcopy(oldpts, oldspc, newspc)
         call vcopy(oldpts, oldnoi, newnoi)
         goto 1000
      endif

      DO 200 ICN = 1, newpts
C        Compute velocity of channel I in the new spectrum
         VN = (FLOAT(ICN)-newv0)*newstp

C        Compute corresponding channel in the old spectrum
         RIC = (VN/oldstp) + oldv0
         IC = INT(RIC)

         if (ric.lt.1) then
            newspc(icn) = oldspc(1)
            newnoi(icn) = oldnoi(1)
         elseif (ric.ge.oldpts) then
            newspc(icn) = oldspc(oldpts)
            newnoi(icn) = oldnoi(oldpts)
         else
C           Interpolate
            F = RIC - FLOAT(IC)
            ICR = IC + 1
            newspc(ICN) = (1.-F)*oldspc(IC) + F*oldspc(ICR)
            newnoi(icn) = sqrt(((1.-f)*oldnoi(ic))**2 +
     &         (f*oldnoi(icr))**2)
         ENDIF
  200 CONTINUE
 
*---Recalc & remove baseline and renormalize area
      oldar = abs(addvec(oldpts,oldspc))
      CALL mbnorm(newpts,newspc,mcal,inewcl,newcal)
      bln= newcal(3)
      arn= newcal(4)
      do 300 i = 1, newpts
         newspc(i) = newspc(i)*oldar
  300 continue
*---adjust raw baseline 
      newcal(3)=oldcal(3)*newstp/oldstp
 
1000  return
      end
