      SUBROUTINE INTFN4(ilevel,ierr)
*-----------------------------------------------------------------------
      integer ilevel, ierr
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 930523 TK
*---mru : 931115 tk
*     WMOSS user-supplied routine, for two-spin hamiltonian.
*
*     ilevel  : [Input]  Which level of physical model to initialize;
*     ierr    : [Output] Error flag.
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'iocom.inc'
      include 'parcom.inc'
      include 'gridcom.inc'
      include 'mancom.inc'

      integer i, j, ksym, ntheta, n1st, n2st
*-----------------------------------------------------------------------

      ierr=0

      if (ilevel.lt.GNLTYP) then 
c        /* Initialize global level:  electronic system */

c        /* Construct grid for powder average. */
         ksym = igp(4,1)
         ntheta = igp(5,1)
*---Define powder grid with uniform weights specified.
         call defgrd(ksym, ntheta, 1, 1.0, ierr)
         if (ierr.ne.0) goto 1000

c        /* Construct single spin operators */
         n1st = igp(6,1)
         n2st = igp(7,1)
         call sop2(n1st, n2st)
      endif

      if (ilevel.lt.LNLTYP) then
c        /* Initialize the local level because the Global has changed */
         do 200 j = 1, MLOC
            do 100 i = 1, MLPAR
               plcopy(i,j) = -9876543.21
  100       continue
  200    continue
      endif

 1000 return
      end
