*-----------------------------------------------------------------------
      SUBROUTINE INTVAR(SETRAN,ROWS,COLS,P0,MVAR,V0,VLB,VUB,KON,IND)
*-----------------------------------------------------------------------
      LOGICAL SETRAN
      INTEGER ROWS,COLS,MVAR,KON(ROWS,COLS),IND(ROWS,COLS)
      REAL P0(ROWS,COLS),V0(MVAR),VLB(MVAR),VUB(MVAR)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     mru 16Jul93 cs
*
*     Initializes variable array to either the initial value specified
*     by the parameter list or to a random point in the center 80%
*     of the variable space defined by the variable upper and lower
*     bounds.
*
*     setran : [Input]  Choose random point instead of parameter values?
*     rows   : [Input]  Leading dimension of p0/kon/ind arrays;
*     cols   : [Input]  Second dimension of p0/kon/ind arrays;
*     mvar   : [Input]  Maximum number of variables;
*     v0     : [Output] Variable values chosen;
*     vlb    : [Input]  Lower bounds of variables;
*     vub    : [Input]  Upper bounds of variables;
*     kon    : [Input]  Parameter constraints;
*     ind    : [Input]  Parameter->variable pointers;
*-----------------------------------------------------------------------
      INTEGER I,J,IND1
 
      REAL RANMAR
      EXTERNAL RANMAR
*-----------------------------------------------------------------------
      INTEGER IJ2KON
      IJ2KON(I,J) = I + 100*J
*-----------------------------------------------------------------------
 
c     /* Initialize free variables */
      DO 100 J = 1,COLS
        DO 50 I = 1,ROWS
          IF ( KON(I,J).EQ.IJ2KON(I,J) ) THEN
            IND1 = IND(I,J)
            IF ( SETRAN ) THEN
c                 /* Choose random pt */
              V0(IND1) = VLB(IND1) + (0.1+0.8*RANMAR())
     &                   *(VUB(IND1)-VLB(IND1))
            ELSE
c                 /* Value supplied by calling routine */
              V0(IND1) = P0(I,J)
            ENDIF
          ENDIF
 50     CONTINUE
 100  CONTINUE
 
      RETURN
      END
