      subroutine kevasc(FILNAM,md,SPEC,NTX,TEXT,ICAL,RCAL,IERR)
C
C     1. READ sawtooth SPECTRUM AND ITS HEADER from ASCII file.
*        THIS FORMAT COMPATIBLE WITH FILES created by
*        Prof. K. Spartalian at Univ. of Vermont
*     2. Store number of points in ICAL(1). 
*     3. Store V=0 chan and step in Rcal(6) and Rcal(7).
 
C       HEADER IS FOLLOWED BY A REAL ARRAY CONTAINING THE
C       SPECTRAL DATA.  LOWER BOUND SUBSCRIPT OF THE ARRAY
C       IS 1.   UPPER BOUND SUBSCRIPT IS NCHANS=ical(1).
C
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     920921 MRU 920921 TK
C --------------------------------------------------
      include 'limits.inc'
      INCLUDE 'iocom.inc'
*---externals
      integer md 
      CHARACTER FILNAM*(*),TEXT(6)*72
      REAL SPEC(md),RCAL(*)
      INTEGER I,ICAL(*),IERR
      INTEGER NTX
*---internals
      integer ispec(lspec)
      integer ieight,nrc,nic
      real dummy, tmpspc(lspec)
      integer iover, nrow, irow, megs
 
C OPEN FILE
      IERR=0
      OPEN (JDISK,FILE=FILNAM,IOSTAT=IERR)
      IF ( IERR.NE.0 ) RETURN
 
*---Initial Comment lines 
      do 45 i=1,6
         text(i)=' '
45    continue
      Text(2)= 'Sawtooth ASCII file.'
 
C READ IN THE HEADER
        DO 50 I = 1,MIN(6,NTX)
          READ (JDISK,'(a)',IOSTAT=IERR,ERR=999) TEXT(I)
 50     CONTINUE
        DO 100 I = 7,NTX
          READ (JDISK,'(a)',IOSTAT=IERR,ERR=999) DUMMY
  100  CONTINUE
*---READ INTEGER VALUED CALIBRATION PARAMETERS
        nic=0
        IF ( NIC.GT.0 ) READ (JDISK,*,IOSTAT=IERR,ERR=999)
     &                        (ICAL(I),I=1,NIC)
*---READ REAL VALUED CALIBRATION PARAMETERS
        nrc=3
        IF ( NRC.GT.0 ) READ (JDISK,*,IOSTAT=IERR,ERR=999)
     &                        (RCAL(I),I=1,NRC)
*---Convert to WEB standard calibration info storage.
        rcal(6)=rcal(1)
        rcal(7)=rcal(2)/1000.0
        rcal(1)=0.0
        rcal(2)=0.0
*---3rd number on 3rd line is number of overflows
        iover = int(rcal(3))
 
C READ IN THE SPECTRUM
*---number of channel in spectrum
        ical(1)=256

*---predefined format ascii file
         nrow=ical(1)/8
         DO 140 IROW=0,NROW-1
          READ (JDISK,9001,IOSTAT=IERR) ieight,(iSPEC(I+8*IROW),I=1,8)
         if(irow.eq.0 .and. ieight.ne.0)ierr=-882
         if(ierr.ne.0)goto 999
 9001 format(i6,8i7)
  140  continue

        close(jdisk, iostat=ierr)
         if(ierr.ne.0)goto 999
   
*---Calc. overflows from information found in header
         megs  = iover*1000000

*---Convert to floating point storage and scan for MCA memory overflows

*---assume that channel 2 had overflowed IOVER times.
         spec(2)=float(ispec(2) + megs)
*---Repair first channel
            spec(1)=spec(2)
*---Repair first and last channels of ispec
         ispec(1)=ispec(2)
         ispec(ical(1))=ispec(ical(1)-1)
         do 300 i=3,ical(1)
             spec(i)=float(ispec(i) + megs)
             if( (spec(i)-spec(i-1)) .gt. 0.5e6 )spec(i)=spec(i)-1.e6
             if( (spec(i)-spec(i-1)) .lt.-0.5e6 )spec(i)=spec(i)+1.e6
  300    continue

*---Do nonlinear correction, etc. 
         do 400 i = 1, ical(1)
            tmpspc(i) = spec(i)
  400    continue
         CALL fixsawth(filnam,TMPSPC,SPEC,ical(1),RCAL(5),RCAL(6),
     &      RCAL(7), ierr)
*---set file type (see readsp.for)
         ical(5)=8

  999 continue
      RETURN
 
      END
