*     LIMITS.INC
*     MOSS Version
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:
*---mru: 960220 tk
*-----------------*
*  Demo switch    *
*-----------------*----------------------------------------------------
      logical zcrip
* zcrip : .false. for full program
*         .true.  for "crippled" demonstration version of program
      parameter (zcrip=.false.)
c      parameter (zcrip=.true.)

*-----------------*
* FROM PARCOM.INC *
*-----------------*-----------------------------------------------------
      integer MFPAR, MFIL, MFLLEN, LT1, LSPEC, MAXPTS, MCAL
      integer MIGPAR, MGLPAR, MBLPAR, MIBPAR, MGPAR, MGLO
      integer MLOC, MILPAR, MLLPAR, MLPAR, MLTOT
      integer MAPAR, MBASIS, PARMAX, MCALVC
*---------------------------------------------------------------------
*---Define storage size for LIST and Fit Table and Response matrix
*---debug
c      parameter (LT1    = 1)
c      parameter (LSPEC  = 2048)
c      parameter (MLOC   = 5)
*---lite
c       parameter (LT1    = 4)
c       parameter (LSPEC  = 512)
c       parameter (MLOC   = 4)
*---normal
       parameter (LT1    = 4)
       parameter (LSPEC  = 1024)
       parameter (MLOC   = 10)
*---CMU special -- WMOSSXL
c       parameter (LT1    = 4)
c       parameter (LSPEC  = 256)
c       parameter (MLOC   = 8)
*---WEB special 
*       parameter (LT1    = 1)
*       parameter (LSPEC  = 2048)
*       parameter (MLOC   = 8)
*-----------------------------------------------------------------------

      parameter (MFPAR  = 12)
      parameter (MFIL   = 2)
      parameter (MFLLEN = 40)
      parameter (MAXPTS = LT1 * LSPEC)

      parameter (MCAL   = 10)
      parameter (MIGPAR = 10)
      parameter (MBLPAR = 1)
      parameter (MGLPAR = LT1 * MBLPAR)
      parameter (MGPAR  = 16)
      parameter (MIBPAR = 2)
      parameter (MGLO   = 1)
      parameter (MILPAR = 10)
      parameter (MLLPAR = 1)
      parameter (MLPAR  = 13)
      parameter (MLTOT  = MLOC * MLPAR)
      parameter (MAPAR  = 1)
      parameter (MBASIS = LT1 * MBLPAR + MLOC * MLLPAR)
      parameter (MCALVC = 2)
      parameter (PARMAX = MCAL + MGPAR + MLTOT + MAPAR + MBASIS + 
     &   LT1 + MLOC)
*-----------------------------------------------------------------------
* mfpar  : Maximum number of integer fitting parameters.
*
* mfil   : Maximum number of parameter filenames stored.
* mfllen : Maximum length of a filename.
*
* migpar : Maximum number of integer global parameters
* mgpar  : Maximum number of real global parameters
* mglpar : Maximum number of global linear parameters (i.e., baselines)
*
* mloc   : Maximum number of local sites.
* milpar : Maximum number of integer local parameters per subsite.
* mlpar  : Maximum number of real local parameters per subsite.
* mllpar : Maximum number of linear local parameters (i.e., area fracs) 
*        :    per subsite.
* mltot  : Maximum total number of local parameters.
*
* mapar  : Maximum number of global area parameters.
*
* mbasis : Maximum number of total linear parameters;
*        : (includes area fractions and baselines)
*
* lt1    : Maximum number of spectra which can be fit at once.
* lspec  : Maximum length of a spectrum (FOLDED!).
* maxpts : Maximum total number of points which can be fit at one time.
* mcal   : Maximum number of real & integer calibration constants.
*
* parmax : Maximum total number of parameters
* mcalvc : Number of cal constants to put in parameter vector
*-----------------------------------------------------------------------

*------------------*
* FROM SPECCOM.INC *
*------------------*----------------------------------------------------
      integer MMAIN, MCOMMT, MCMTLEN
      parameter (MCOMMT = 6)
      parameter (MCMTLEN = 72)
*---------------------------------------------------------------------
*---Define storage size for LIST
*---debug
c      parameter (MMAIN  = 10)
*---lite
c       parameter (MMAIN  = 16)
*---normal
      parameter (MMAIN  = 32)
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
* mmain  : Maximum number of spectra allowed on the list at once.
* mcommt : Number of comment lines in data header.
*-----------------------------------------------------------------------

*------------------*
* FROM GRIDCOM.INC *
*------------------*----------------------------------------------------
      integer MAXGRD
*---degug
c      parameter (MAXGRD = 55)
*---lite
c      parameter (MAXGRD = 256)
*---normal
       parameter (MAXGRD = 810)
*---CMU special -- WMOSSXL
c      parameter (MAXGRD = 1860)      
*-----------------------------------------------------------------------
* maxgrd : Maximum number of grid points for powder average.
*-----------------------------------------------------------------------

*-----------------*
* FROM VARCOM.INC *
*-----------------*-----------------------------------------------------
      integer MVAR
      parameter(MVAR = MLTOT)
*-----------------------------------------------------------------------
* mvar  : Maximum number of free variables at any one level.
*       : MVAR must be set at least equal to the largest of MGPAR, 
*       : MLTOT, MAPAR and (MLLPAR+MBLPAR)*NSUBS.
*-----------------------------------------------------------------------

*-----------------------------------------------------------------------
*---from SCAPLT.FOR for Monte Carlo Analysis
*-----------------------------------------------------------------------
      INTEGER MMONTE, MBINS
      parameter (MMONTE = 500)
      parameter (MBINS  = 50)
*---MMonte is the max. number of loops allowed for the Monte Carlo proc.
*---Mbins is the number of bins the results are partitioned into.
*------------------------------------------------------------------------

*-----------------*
* FROM SIMCOM.INC *
*-----------------*-----------------------------------------------------
      integer msim
      parameter (msim = 11)
*-----------------------------------------------------------------------

*-------------*
* FOR FFTPACK *
*-------------*---------------------------------------------------------
      integer MFFT
      parameter (MFFT = 32 * LSPEC + 15)
*-----------------------------------------------------------------------

*-------------*
*tk 930823 for pspm and mark
*--------------*
      integer mtop
      parameter (mtop=1)


