      SUBROUTINE LINFIT(NLNFR1,VLNFR,NBLFR,VBLFR,NSPPTS,DSPEC,LOSPC,SIG,
     &                  FUNC,CHISQ,TSPEC)
*----------------------------------------------------------------------
      INCLUDE 'limits.inc'
 
      INTEGER NLNFR1,NBLFR,NSPPTS(LT1)
      REAL VLNFR(NLNFR1),VBLFR(NBLFR)
      REAL CHISQ,LOSPC(LSPEC,LT1,MLOC)
      REAL TSPEC(LSPEC,LT1),DSPEC(LSPEC,LT1),SIG(LSPEC,LT1)
 
      EXTERNAL FUNC
*----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    mru 18Jul93 cs
*
*     Does linear fitting for a given set of subspectra, with a hack
*     to optionally force the answer to have all areas (but not
*     baselines) non-negative.
*
*     nfree1 : [Input]  Number of free linear variables;
*     vfree  : [Output] Returned free variables;
*     nsppts : [Input]  List of lengths of the DATA spectra;
*     dspec  : [Input]  Array of data spectra;
*     lospc  : [Input]  Array of subspectra;
*     sig    : [Input]  Array of data noise values;
*     func   : [Input]  Routine to call to set up the basis vectors;
*     chisq  : [Output] Best chi-squared;
*     tspec  : [Input]  Returned Array of theory spectra;
*----------------------------------------------------------------------
      INCLUDE 'parcom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'bestcom.inc'
 
      INTEGER IBASIS,IPOINT,IRANK,INFO,IFREE,NFREE,NEWNEG,I
      INTEGER NLNFR
      INTEGER NEWIDX(MBASIS)
      LOGICAL BL(MBASIS)
 
      REAL BASES(MAXPTS,MBASIS),BASES0(MAXPTS,MBASIS)
      REAL SUBSP(LSPEC,LT1,MBASIS)
      REAL ADJDAT(MAXPTS),ADJDA0(MAXPTS)
      REAL RHS(MAXPTS)
      REAL SNGVAL(MBASIS)
 
      INTEGER LWORK
      PARAMETER (LWORK=5*MAXPTS)
      REAL WORK(LWORK)
*----------------------------------------------------------------------
 
c     /* Initialize the basis vectors and data vector */
      CALL FUNC(NSPPTS,DSPEC,LOSPC,ADJDA0,SUBSP,BASES0,RHS,BL)
 
      NLNFR = NLNFR1
      DO 100 IBASIS = 1,NLNFR
        NEWIDX(IBASIS) = IBASIS
 100  CONTINUE
 
      IF ( NLNFR1+NBLFR.GT.0 ) THEN
c        /* Copy non-zeroed area basis vectors */
 150    DO 200 IFREE = 1,NLNFR1
          IF ( NEWIDX(IFREE).NE.0 )
     &         CALL VCOPY(NFRPT,BASES0(1,IFREE),BASES(1,NEWIDX(IFREE)))
 200    CONTINUE
c        /* Copy baseline basis vectors */
        DO 250 IFREE = 1,NBLFR
          CALL VCOPY(NFRPT,BASES0(1,NLNFR1+IFREE),BASES(1,NLNFR+IFREE))
 250    CONTINUE
c        /* Copy the data to which we want to fit */
        DO 300 IPOINT = 1,NFRPT
          ADJDAT(IPOINT) = ADJDA0(IPOINT)
 300    CONTINUE
 
c        /* Scale basis vectors with the global noise vector */
        NFREE = NLNFR + NBLFR
        DO 350 IBASIS = 1,NLNFR + NBLFR
          DO 320 IPOINT = 1,NFRPT
            IF ( NVEC(IPOINT).GT.0 ) BASES(IPOINT,IBASIS)
     &           = BASES(IPOINT,IBASIS)/NVEC(IPOINT)
 320      CONTINUE
 350    CONTINUE
 
        DO 400 IPOINT = 1,NFRPT
          IF ( NVEC(IPOINT).GT.0 ) ADJDAT(IPOINT) = ADJDAT(IPOINT)
     &         /NVEC(IPOINT)
 400    CONTINUE
 
*---do least-squares fit via lapack routine
        CALL SGELSS(NFRPT,NFREE,1,BASES,MAXPTS,ADJDAT,MAXPTS,SNGVAL,
     &              1.0E-4,IRANK,WORK,LWORK,INFO)
 
*---test whether any areas are negative
        IF ( NNEGAR ) THEN
          NEWNEG = 0
          DO 420 I = 1,NLNFR
            IF ( NEWIDX(I).GT.0 ) THEN
              IF ( ADJDAT(NEWIDX(I)).LT.0 ) THEN
                NEWNEG = NEWNEG + 1
                NEWIDX(I) = 0
              ELSE
                NEWIDX(I) = NEWIDX(I) - NEWNEG
              ENDIF
            ENDIF
 420      CONTINUE
          NLNFR = NLNFR - NEWNEG
 
          IF ( (NLNFR.NE.0) .AND. (NEWNEG.NE.0) ) GOTO 150
          DO 440 IFREE = 1,NLNFR1
            IF ( NEWIDX(IFREE).EQ.0 ) THEN
              VLNFR(IFREE) = 0
            ELSE
              VLNFR(IFREE) = ADJDAT(NEWIDX(IFREE))
            ENDIF
 440      CONTINUE
          DO 460 IFREE = 1,NBLFR
            VBLFR(IFREE) = ADJDAT(NLNFR+IFREE)
 460      CONTINUE
        ELSE
          CALL VCOPY(NLNFR1,ADJDAT,VLNFR)
          CALL VCOPY(NBLFR,ADJDAT(NLNFR1+1),VBLFR)
        ENDIF
      ENDIF
 
c     /* Calculate chi-squared and construct theory spectra */
      CALL CALXI2(NLNFR1,VLNFR,NBLFR,VBLFR,RHS,SUBSP,SIG,TSPEC,CHISQ)
 
c     /* Save the results */
      CALL STORE(LINLEV,NLNFR1,VLNFR)
      CALL STORE(BLLEV,NBLFR,VBLFR)
 
      RETURN
      END 

