*----------------------------------------------------------------------- 
      subroutine lnorm(nchan, spc, cpos, cwidth, cwcal, bl, normar)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     1991 cs, mru 13Aug93 cs
*
*     Creates a single Lorentian or Voigt line.
*-----------------------------------------------------------------------
      integer nchan
      real spc(nchan), cpos, cwidth, cwcal, bl, normar
*----------------------------------------------------------------------- 
      include 'limits.inc'

      integer MMULT
      parameter (MMULT = 4)

      real area, adjar, chan
      real stick(MMULT*LSPEC), spc2(MMULT*LSPEC), f
      integer i, nchan2
      integer il, ir
*----------------------------------------------------------------------- 
 
      if (nchan.gt.LSPEC) then
         call errmsg('~INTERNAL ERROR~: nchan too big in LNORM')
         goto 1000
      endif
 
      if (cwidth.gt.0) then
c        ;;;;;;;;;;;;;;;;;;;;;;;;;;
c        ;; Calculate Lorentzian ;;
c        ;;;;;;;;;;;;;;;;;;;;;;;;;;
         area = 0
         do 50 i = 1,nchan
            spc(i) = -1.0 / ((i-cpos)**2 + (cwidth/2)**2)
            area = area - spc(i)
   50    continue

         if (area.ne.0) then
            adjar = abs(normar / area)
         else
            adjar = 0.
         endif
 
c        ;; Normalize Lorentzian and adjust baseline
         do 100 i = 1, nchan
            spc(i) = spc(i)*adjar + bl
  100    continue
      else
c        ;;;;;;;;;;;;;;;;;;;;;
c        ;; Calculate Voigt ;;
c        ;;;;;;;;;;;;;;;;;;;;;
         nchan2 = MMULT * nchan
         do 150 i = 1, nchan2
            stick(i) = 0.0
  150    continue
 
c        ;; Approximate line at cpos with two lines centered at nearest
c        ;; two channels
         chan = 1. + MMULT * (cpos - 1.)
         il = int(chan)
         ir = il + 1
         f = chan - il
         if (il.ge.1 .and. il.le.nchan2) stick(il) = -normar*(1.0-f)
         if (ir.ge.1 .and. ir.le.nchan2) stick(ir) = -normar*f
 
c        ;; Convolute shape function and stick with area normar
         call shape(nchan2, stick, MMULT * cwidth / 2.0, 
     &      MMULT * cwcal / 2.0, spc2)

c        ;; Copy back to coarser grid
         area = 0.
         do 200 i = 1, nchan
            il = 1 + MMULT * (i-1)
            spc(i) = spc2(il)
            area = area + spc(i)
  200    continue
 
c        ;; Normalize line and adjust baseline
         if (area.ne.0) then
            adjar = abs(normar / area)
         else
            adjar = 0.
         endif
         do 300 i = 1, nchan
            spc(i) = spc(i) * adjar + bl
  300    continue
      endif
 
 1000 return
      end
