      SUBROUTINE LSUB
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig   tk/cs 1991
*---mru 930821 tk   reverse meaning of up and down arrows for area
*---    960108 tk   add data type switch: icalsp(mcal,spctot)=-1
*---    961218 tk   changes for Windows version.
*----------------------------------------------------------------------
*     Assumes the "data" [spectra(1..lspec,actspc)] has already been
*     plotted.
*----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      include 'constcom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'keycom.inc'
 
      INTEGER DELAY
      PARAMETER (DELAY=16)
      REAL TMPSPC(LSPEC), tmpsp2(lspec)
      REAL CWCAL,CZERO,STEP
      INTEGER I,ACTOPT,COUNT, npts
      INTEGER ICHR
      LOGICAL GETYN,PCHNGE
      REAL POSITION,WIDTH,BASELINE,AREA, range
      REAL DPOS,DWID,DBAS,DAREA
      CHARACTER INNAME*(mfllen),INCMNT*72

      integer j
      real chan, p, vel, c, chanw, w, velw

      real armax1, armin1
      integer infocu
      external armin1, infocu

      save dpos
      DATA DPOS/0.1/,DWID/0.1/,DBAS/0.001/,DAREA/0.005/
 
*---Conversion from velocity to channel
      CHAN(P) = P/STEP + CZERO
*---Conversion from channel to velocity
      VEL(C) = (C-CZERO)*STEP
*---Conversion from change in velocity to width in channels
      CHANW(W) = W/STEP
*---Conversion from channel width to change in velocity
      VELW(W) = W*STEP
 
*---Initialization
      COUNT = 0
      ACTOPT = 0
      CZERO = SPCCAL(6,ACTSPC)
      STEP = SPCCAL(7,ACTSPC)
      CWCAL = fwhml0/STEP
      npts = icalsp(1,actspc)
      range = armax1(spctra(1,actspc),npts) -
     &   armin1(spctra(1,actspc),npts) 
      DBAS = abs(0.0001*spccal(3,actspc)/spccal(4,actspc))
      BASELINE = 0.0
 
      IF (kxplot.eq.2) THEN
        POSITION = 0.
        WIDTH = 1.0
      ELSE
        POSITION = npts/2
        WIDTH = 1.0
      ENDIF
 
*---Get initial values
      CALL MESSAGE('Initial Position ')
      if (kxplot.eq.1) then
         call outstr(' [chan] ? ')
      else
         call outstr(' [mm/s] ? ')
      endif
      CALL GETR(INFOCU(1),INFOCU(2),POSITION,ICHR,.FALSE.)
      CALL MESSAGE(' ')
      IF ( ICHR.EQ.ESC ) GOTO 400
      IF (kxplot.eq.2) THEN
        POSITION = CHAN(POSITION)
        CALL CALWA(POSITION,npts,SPCTRA(1,ACTSPC),CWCAL,WIDTH,AREA)
        WIDTH = VELW(WIDTH)
      ELSE
        CALL CALWA(POSITION,npts,SPCTRA(1,ACTSPC),CWCAL,WIDTH,AREA)
      ENDIF
 
      CALL MESSAGE('Initial Width ')
      if (kxplot.eq.1) then
         call outstr(' [chan] ? ')
      else
         call outstr(' [mm/s] ? ')
      endif
      CALL GETR(INFOCU(1),INFOCU(2),WIDTH,ICHR,.FALSE.)
      CALL MESSAGE(' ')
      IF ( ICHR.EQ.ESC ) GOTO 400
 
      CALL MESSAGE('Initial Baseline [pct] ? ')
      CALL GETR(INFOCU(1),INFOCU(2),BASELINE,ICHR,.FALSE.)
      baseline = 0.01*baseline*abs(spccal(3,actspc)/spccal(4,actspc))
      CALL MESSAGE(' ')
      IF ( ICHR.EQ.ESC ) GOTO 400
      
      IF (kxplot.eq.2) WIDTH = CHANW(WIDTH)
*---From here on, WIDTH and POSITION are kept in channels
 
      CALL LNORM(npts,TMPSPC,POSITION,WIDTH,CWCAL,BASELINE,1.00)
      AREA = anint(10000 * SPCTRA(NINT(POSITION),ACTSPC) / 
     &   TMPSPC(NINT(POSITION))) / 10000.
 
      CALL MESSAGE('Initial Area Fraction?')
      CALL GETR(INFOCU(1)+1,INFOCU(2),AREA,ICHR,.FALSE.)
      CALL MESSAGE(' ')
      IF (ICHR.EQ.ESC) GOTO 400
 
      DO 100 I = 1,npts
        TMPSPC(I) = (TMPSPC(I)-baseline)*AREA + baseline
 100  CONTINUE
 
*---Display active Keys
 200  CALL MESSAGE('~Lft~/~Rt~=Position, ~Ctrl~-~Lft~/~Rt~='//
     &             'Width, ~Up~/~Dn~=Area, ~Ctrl~-~Up~/~Dn~='//
     &             'Baseline, ~ESC~=Exit.')
 
210      call shodat(.false.,npts,xspc(1,actspc),tmpspc,
     &   spcnoi(1,actspc), icalsp(1,actspc), spccal(1,actspc), 
     &   spcmsk(1,actspc),
     &   1.0, 0, 1,spcnam(actspc),spccmt(1,actspc),.false.)
      IF ( SHORES ) then
         do 250 i = 1, npts
            tmpsp2(i) = spctra(i,actspc) - tmpspc(i)
  250    continue
         call shodat(.false.,npts,xspc(1,actspc),tmpsp2,
     &      spcnoi(1,actspc), icalsp(1,actspc), spccal(1,actspc), 
     &      spcmsk(1,actspc),
     &      1.0, 0, 2, spcnam(actspc),spccmt(1,actspc),.false.)
      endif

      CALL WNACTN('C')
      call bright
      CALL WNOPEN(9,20,20,4)
 
      PCHNGE = .FALSE.
      COUNT = 1
 
 300  CALL WNHOME
      CALL WNOUST('  Position: ')
      IF (kxplot.eq.2) THEN
        CALL WNOURE(VEL(POSITION),'(F7.3)')
        CALL WNOUCR(1)
        CALL WNOUST('  Width   : ')
        CALL WNOURE(VELW(WIDTH),'(F7.3)')
      ELSE
        CALL WNOURE(POSITION,'(F6.2)')
        CALL WNOUCR(1)
        CALL WNOUST('  Width   : ')
        CALL WNOURE(WIDTH,'(F6.2)')
      ENDIF
      CALL WNOUCR(1)
      CALL WNOUST('  Area    : ')
      CALL WNOURE(AREA,'(F7.3)')
      CALL WNOUCR(1)
      CALL WNOUST('  Baseline: ')
      CALL WNOURE(100*BASELINE*abs(spccal(4,actspc)/spccal(3,actspc)),
     &   '(F7.3)')
 
      CALL INKEYI(ICHR)
      IF ( ICHR.LE.0 ) THEN
         COUNT = COUNT + 1
         IF ( MOD(COUNT,DELAY).EQ.0 ) THEN
            IF ( PCHNGE ) THEN
               CALL LNORM(npts,TMPSPC,POSITION,WIDTH,CWCAL,BASELINE,
     &            area) 
               call shodat(.false.,npts,xspc(1,actspc),tmpspc,
     &         spcnoi(1,actspc), icalsp(1,actspc), spccal(1,actspc),
     &         spcmsk(1,actspc),
     &         1.0, 0, 1, spcnam(actspc),spccmt(1,actspc),.false.)
               IF ( SHORES ) then
                  do 312 i = 1, npts
                     tmpsp2(i) = spctra(i,actspc) - tmpspc(i)
  312             continue
                  call shodat(.false.,npts,xspc(1,actspc),tmpsp2,
     &            spcnoi(1,actspc), icalsp(1,actspc), spccal(1,actspc), 
     &            spcmsk(1,actspc),1.0, 0, 2, spcnam(actspc),
     &            spccmt(1,actspc),.false.)
               endif
               PCHNGE = .FALSE.
            ENDIF
          COUNT = 1
        ENDIF
      ELSEIF ( ICHR.EQ.RTARR ) THEN
        POSITION = POSITION + DPOS
        IF ( POSITION.GT.npts ) POSITION = POSITION - npts
        COUNT = 1
        PCHNGE = .TRUE.
      ELSEIF ( ICHR.EQ.LTARR ) THEN
        POSITION = POSITION - DPOS
        IF ( POSITION.LT.1.0 ) POSITION = POSITION + npts
        COUNT = 1
        PCHNGE = .TRUE.
      ELSEIF ( ICHR.EQ.CRTARR ) THEN
        WIDTH = WIDTH + DWID
        COUNT = 1
        PCHNGE = .TRUE.
      ELSEIF ( ICHR.EQ.CLTARR ) THEN
        WIDTH = WIDTH - DWID
        COUNT = 1
        PCHNGE = .TRUE.
      ELSEIF ( ICHR.EQ.UPARR ) THEN
        AREA = AREA + DAREA
        COUNT = 1
        PCHNGE = .TRUE.
      ELSEIF ( ICHR.EQ.DNARR ) THEN
        AREA = AREA - DAREA
        COUNT = 1
        PCHNGE = .TRUE.
      ELSEIF ( ICHR.EQ.CUPARR ) THEN
        BASELINE = BASELINE + DBAS
        COUNT = 1
        PCHNGE = .TRUE.
      ELSEIF ( ICHR.EQ.CDNARR ) THEN
        BASELINE = BASELINE - DBAS
        COUNT = 1
        PCHNGE = .TRUE.
      ELSEIF ( ICHR.EQ.ESC ) THEN
        CALL MESSAGE(' ')
        IF ( GETYN('Store Difference? ') ) THEN
          CALL MESSAGE('Name: ')
          INNAME = ' '
          CALL GETS(7,INFOCU(2),INNAME,mfllen,ICHR,.FALSE.)
          CALL MESSAGE(' ')
          IF ( (INNAME.NE.' ') .AND. (ICHR.NE.ESC) ) THEN
 
            INCMNT = ' '
            CALL MESSAGE('Comment: ')
            CALL GETS(10,INFOCU(2),INCMNT,72,ICHR,.FALSE.)
            CALL MESSAGE(' ')
            IF ( ICHR.NE.ESC ) THEN
 
              IF ( SPCTOT.LT.MMAIN ) SPCTOT = SPCTOT + 1
              SPCNAM(SPCTOT) = INNAME
              SPCCMT(1,SPCTOT) = INCMNT
              DO 315 J = 2,6
                SPCCMT(J,SPCTOT) = ' '
 315          CONTINUE
 
C Difference spectrum has the same noise as the data, as the theory has
C no noise
              DO 320 I = 1, npts
                SPCTRA(I,SPCTOT) = SPCTRA(I,ACTSPC) - TMPSPC(I)
                SPCNOI(I,SPCTOT) = SPCNOI(I,ACTSPC)
                XSPC(I,SPCTOT) = XSPC(I,ACTSPC)
 320          CONTINUE
 
              DO 325 I = 1,10
                SPCCAL(I,SPCTOT) = SPCCAL(I,ACTSPC)
                ICALSP(I,SPCTOT) = ICALSP(I,ACTSPC)
 325          CONTINUE

              ACTSPC = SPCTOT
              CALL SHOLST
            ENDIF
          ENDIF
        ELSE
          CALL MESSAGE(' ')
        ENDIF
        GOTO 400
      ELSEIF ( ICHR.EQ.CTRLP .and. .not. zcrip) THEN
         CALL WNCLOS(1)
         CALL INTPRN
         CALL CLSCRN
         CALL SHOACT(.TRUE.)
         call shodat(.false.,npts,xspc(1,actspc),tmpspc,
     &      spcnoi(1,actspc), icalsp(1,actspc), spccal(1,actspc), 
     &      spcmsk(1,actspc),
     &      1.0, 0, 1, spcnam(actspc),spccmt(1,actspc),.false.)
         IF ( SHORES ) then
            do 350 i = 1, npts
               tmpsp2(i) = spctra(i,actspc) - tmpspc(i)
  350       continue
            call shodat(.false.,npts,xspc(1,actspc),tmpsp2,
     &         spcnoi(1,actspc), icalsp(1,actspc), spccal(1,actspc), 
     &         spcmsk(1,actspc),
     &         1.0, 0, 2, spcnam(actspc),spccmt(1,actspc),.false.)
         endif
        call clsprn
        call clrall
        CALL SHOACT(.FALSE.)
        GOTO 200
      elseif (ichr.eq.F8) then
         if (zscale) then
            call zoom
         else
            zscale = .true.
         endif
         goto 210
      ELSE
        COUNT = MOD(COUNT+1,DELAY)
      ENDIF
      GOTO 300
 
 400  CALL WNCLOS(1)
      CALL SHOACT(.FALSE.)
      RETURN
      END
