      SUBROUTINE MAKTAB(MAXSPC)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:  1992 cs
*---mru :  11Aug93 cs
*---Purpose:
*     Copies spectra from the list into the fitting tables.
*
*     maxspc : Controls how spectra are picked:
*               / maxspc < 0 => pick only spectrum #(-maxspc)
*               | maxspc = 0 => recopy currently picked spectra
*               \ maxspc > 0 => user may pick <= maxspc spectra
*-----------------------------------------------------------------------
*---externals
      INTEGER MAXSPC
*---parameters and common blocks
      INCLUDE 'limits.inc'
      INCLUDE 'iocom.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'togcom.inc'
*---inernals
      INTEGER I,I1,COUNT,ISPEC,NPTS,NSPPTS(LT1)
      LOGICAL SHOWN
*--extenal functions
      INTEGER GETSPC
      EXTERNAL GETSPC
*-----------------------------------------------------------------------
*---executables
*---clear old values
      CALL CLRTAB
 
*---setup baselines and global areas
      NFRPT = 0
      NSPEC = 0
 
      IF ( MAXSPC.NE.0 ) THEN
*---clear "picked" vector
        CALL INTBLA
        DO 50 I = 1,MMAIN
          PICKED(I) = .FALSE.
 50     CONTINUE
        IF ( MAXSPC.GT.0 ) CALL SHOLST
      ENDIF
 
*---Set those elements of the PICKED array to true corresponding
*---to the spectra to be copied into the list. (If maxspc=0,
*---nothing needs to be done.)
      COUNT = 0
      IF ( MAXSPC.GT.0 ) THEN
 100    I1 = GETSPC()
        IF ( I1.GT.0 ) THEN
          SELECT(I1) = .FALSE.
          PICKED(I1) = .NOT.PICKED(I1)
          SHOWN = (ACTSPC.EQ.I1)
          IF ( PICKED(I1) ) THEN
            ACTSPC = I1
            COUNT = COUNT + 1
          ELSE
            COUNT = COUNT - 1
          ENDIF
          CALL SHOLST
          IF ( .NOT.SHOWN ) CALL SHOACT(.FALSE.)
          IF ( COUNT.LT.MAXSPC ) GOTO 100
        ENDIF
      ELSEIF ( MAXSPC.LT.0 ) THEN
        PICKED(-MAXSPC) = .TRUE.
      ENDIF
 
*---Copy PICKED list spectra and associated data header into fit table
      DO 200 ISPEC = 1,SPCTOT
        IF ( PICKED(ISPEC) ) THEN
          NSPEC = NSPEC + 1
 
          NPTS = ICALSP(1,ISPEC)
 
          SNAME(NSPEC) = SPCNAM(ISPEC)
          DO 120 I = 1,MCOMMT
            SCOMNT(I,NSPEC) = SPCCMT(I,ISPEC)
 120      CONTINUE
 
          CALL VCOPY(MCAL,SPCCAL(1,ISPEC),CAL(1,NSPEC))
          CALL VCOPY(NPTS,SPCTRA(1,ISPEC),SPEC(1,NSPEC,1))
          CALL VCOPY(NPTS,SPCTRA(1,ISPEC),SPEC0(1,NSPEC,1))
          CALL VCOPY(NPTS,SPCNOI(1,ISPEC),SNOYS(1,NSPEC,1))
          CALL VCOPY(NPTS,XSPC(1,ISPEC),SPECX(1,NSPEC))
 
          DO 140 I = 1,MCAL
            ICAL(I,NSPEC) = ICALSP(I,ISPEC)
 140      CONTINUE
 
          DO 160 I = 1,NPTS
            SMASK(I,NSPEC) = SPCMSK(I,ISPEC)
            IF ( SMASK(I,NSPEC) ) NFRPT = NFRPT + 1
 160      CONTINUE
        ENDIF
 200  CONTINUE
 
*---patch
c      iap = nspec
c      ilnp = nlnpar
 
*---Setup baselines
      CALL MAKBAS
      DATCHU = (NSPEC.GT.0)
 
c  ;; Initialize compressed noise vector
      DO 300 ISPEC = 1,NSPEC
        NSPPTS(ISPEC) = ICAL(1,ISPEC)
 300  CONTINUE
      CALL MSKAPP(NSPPTS,SNOYS(1,1,1),SMASK(1,1),NVEC,NFRPT)
 
      IF ( MAXSPC.GT.0 ) CALL SHOLST
 
      RETURN
      END
