*-----------------------------------------------------------------------
      SUBROUTINE MAKVEC
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    1992 cs, mru 15Jul93 cs
*     Purpose: Copy parameters from all levels to one vector.
*     Also copies some cal info to same vector.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'mancom.inc'
      INCLUDE 'constcom.inc'
 
      INTEGER I,J,ISUB,ISPEC,IZERO
      CHARACTER SUB*4,SPC*4
 
      INTEGER LENACT
      EXTERNAL LENACT
*-----------------------------------------------------------------------
      INTEGER IJ2KON
      IJ2KON(I,J) = I + 100*J
*-----------------------------------------------------------------------
 
      IZERO = ICHAR('0')
      NPTOT = 0
 
c     /* Add global nonlinear parameters */
      DO 100 J = 1,NGLO
        DO 50 I = 1,MIN(IGP(2,J),MGPAR)
          NPTOT = NPTOT + 1
          PARNAM(NPTOT) = PGNAM(I,J)
          PARVEC(NPTOT) = PG0(I,J)
          PARUB(NPTOT) = PGUB(I,J)
          PARLB(NPTOT) = PGLB(I,J)
          PARTYP(NPTOT) = GNLTYP
          PARIDX(NPTOT) = IJ2KON(I,J)
 50     CONTINUE
 100  CONTINUE
 
*---------------------
*---Local Sites
*---------------------
 
      DO 300 ISUB = 1,NSUBS
c        /* Subsite Header */
        NPTOT = NPTOT + 1
        CALL INTSTR(ISUB,SUB,'(I4)')
        CALL JUSTIF(SUB,'Left')
        PARNAM(NPTOT) = '#'//SUB(1:LENACT(SUB))//'-------'
        PARVEC(NPTOT) = 0
        PARUB(NPTOT) = 0
        PARLB(NPTOT) = 0
        PARTYP(NPTOT) = EMPTY
        PARIDX(NPTOT) = 0
 
c        /* Local Nonlinear */
        DO 150 I = 1,MIN(ILP(2,ISUB),MLPAR)
          NPTOT = NPTOT + 1
          PARNAM(NPTOT) = PLNAM(I,ISUB)
          PARVEC(NPTOT) = PL0(I,ISUB)
          PARUB(NPTOT) = PLUB(I,ISUB)
          PARLB(NPTOT) = PLLB(I,ISUB)
          PARTYP(NPTOT) = LNLTYP
          PARIDX(NPTOT) = IJ2KON(I,ISUB)
 150    CONTINUE
 
c        /* Linear Area Fractions */
        DO 200 I = 1,MIN(ILP(3,ISUB),MLLPAR)
          NPTOT = NPTOT + 1
          PARNAM(NPTOT) = PLNNAM(I,ISUB)
          PARVEC(NPTOT) = PLN0(I,ISUB)
          PARUB(NPTOT) = PLNUB(I,ISUB)
          PARLB(NPTOT) = PLNLB(I,ISUB)
          PARTYP(NPTOT) = LINTYP
          PARIDX(NPTOT) = IJ2KON(I,ISUB)
 200    CONTINUE
 300  CONTINUE
 
*------------------------------------
*---Add data-related parameters
*------------------------------------
 
      DO 500 ISPEC = 1,NSPEC
c        /* Spectrum Header */
        NPTOT = NPTOT + 1
        CALL INTSTR(ISPEC,SPC,'(I4)')
        CALL JUSTIF(SPC,'L')
        PARNAM(NPTOT) = 'S'//SPC(1:LENACT(SPC))//'-------'
        PARVEC(NPTOT) = 0
        PARUB(NPTOT) = 0
        PARLB(NPTOT) = 0
        PARTYP(NPTOT) = EMPTY
        PARIDX(NPTOT) = 0
 
c        /* Add Global Areas */
        DO 350 I = 1,MIN(IAP(2,ISPEC),MAPAR)
          NPTOT = NPTOT + 1
          PARNAM(NPTOT) = PANAM(I,ISPEC)
          PARVEC(NPTOT) = PA0(I,ISPEC)
          PARUB(NPTOT) = PAUB(I,ISPEC)
          PARLB(NPTOT) = PALB(I,ISPEC)
          PARTYP(NPTOT) = GARTYP
          PARIDX(NPTOT) = IJ2KON(I,ISPEC)
 350    CONTINUE
 
c        /* Add Baseline */
        DO 400 I = 1,MIN(IBLP(2,ISPEC),MBLPAR)
          NPTOT = NPTOT + 1
          PARNAM(NPTOT) = PBLNAM(I,ISPEC)
          PARVEC(NPTOT) = PBL0(I,ISPEC)
          PARUB(NPTOT) = PBLUB(I,ISPEC)
          PARLB(NPTOT) = PBLLB(I,ISPEC)
          PARTYP(NPTOT) = BLTYP
          PARIDX(NPTOT) = IJ2KON(I,ISPEC)
 400    CONTINUE
 
c     /* Add a small amount of info from data header from fit table */
        IF ( MCALVC.GT.0 ) THEN
          NPTOT = NPTOT + 1
          PARNAM(NPTOT) = '=========='
          PARVEC(NPTOT) = 0
          PARUB(NPTOT) = 0
          PARLB(NPTOT) = 0
          PARTYP(NPTOT) = EMPTY
          PARIDX(NPTOT) = 0
        ENDIF
 
        DO 450 I = 1,MCALVC
          NPTOT = NPTOT + 1
          PARVEC(NPTOT) = CAL(I,ISPEC)
          PARNAM(NPTOT) = RCALNM(I)
          PARUB(NPTOT) = 1.2*PARVEC(NPTOT)
          PARLB(NPTOT) = 0.8*PARVEC(NPTOT)
          PARTYP(NPTOT) = CALTYP
          PARIDX(NPTOT) = IJ2KON(I,ISPEC)
 450    CONTINUE
 500  CONTINUE
 
      RETURN
      END
