*-----------------------------------------------------------------------
* MANCOM.INC : Used by the FLASHER routines.  [CS 20Aug93]
* Must follow both parcom.inc and speccom.inc
*-----------------------------------------------------------------------

*-----------------------------------------------------------------------
* Each variable in the parameter vector is given a type number
* to determine which parameter array it should be inserted into.
* Here the type numbers are defined.
*-----------------------------------------------------------------------
      integer EMPTY, GARTYP, LINTYP, GNLTYP, LNLTYP, CALTYP, BLTYP
      parameter (EMPTY  = 0, CALTYP = 1, GNLTYP = 2)
      parameter (LNLTYP = 3, GARTYP = 4, LINTYP = 5)
      parameter (BLTYP  = 6)

*-----------------------------------------------------------------------
* The flasher uses three Interacter text windows.  Here they are 
* numbered in order of creation.
*-----------------------------------------------------------------------
      integer PARWIN, STKWIN, TTLWIN
      parameter (PARWIN = 1, STKWIN = 2, TTLWIN = 3)

*-----------------------------------------------------------------------
* The flasher keeps track of the number of the parameter currently
* highlighted (curpar) and of the parameter at the top of the 
* displayed parameters (toppar).
*-----------------------------------------------------------------------
      integer curpar,toppar
      common /parvar/curpar,toppar

*-----------------------------------------------------------------------
* The flasher stores the names and the parameter flashed upon in its
* stack of calculated spectra, which sits at the end of the 
* spectrum list.
*-----------------------------------------------------------------------
      integer curstk, stktot, topstk, stklst(mmain)
      real stkval(mmain)
      common /stkvar/curstk,stktot,topstk,stkval,stklst
