      SUBROUTINE MARK(SPC,NOI,XSP,SCAL,ISCAL,MSK,NAM,CMT)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: cs 1992
*---mru 940307 tk; 971209 tk
*
*     Interactively adds a mask to a spectrum.
*
*     spc    : [Input]  Spectrum y-values;
*     noi    : [Input]  Spectrum noise values;
*     xsp    : [Input]  Spectrum x-values;
*     scal   : [Input]  Real calibration info;
*     iscal  : [Input]  Integer calibration info;
*     msk    : [Output] New mask;
*     nam    : [Input]  Spectrum name;
*     cmt    : [Input]  Spectrum comments.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'constcom.inc'
 
      REAL SPC(*),NOI(*),XSP(*),SCAL(MCAL)
      LOGICAL MSK(*)
      INTEGER ISCAL(MCAL)
      CHARACTER*(*) NAM
      CHARACTER*(MCMTLEN) CMT(MCOMMT)
*-----------------------------------------------------------------------
      INCLUDE 'keycom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'scrncom.inc'
 
      INTEGER CH1,CH2,I,NPTS,NTOP,ICHR
      LOGICAL CLEAR
      REAL XMIN,XMAX
      REAL XS(LSPEC),YS(LSPEC),YSNOI(LSPEC),TOPLST(2,MTOP)
      LOGICAL MARKS(LSPEC)
 
      INTEGER INFOCU
      REAL XSTOX
      EXTERNAL INFOCU,XSTOX
*-----------------------------------------------------------------------
 
*---FIND MAX/MIN VALUES
      NPTS = ISCAL(1)
*---note: scldat may change npts if data complex.  Therefore
*---      use iscal(1) as input to shodat.
      CALL SCLDAT(iscal(10),NPTS,XSP,SPC,NOI,MSK,SCAL,
     &            KXPLOT,KYPLOT,XS,YS,YSNOI,MARKS,NTOP,TOPLST)
 
*---INITIAL XPOS AT LEFT SIDE OF SPECTRUM
      CH1 = 1
 
*---Initially _adding_ mask
      CLEAR = .FALSE.
 
*---MARK FIRST SIDE OF SECTION TO IGNORE
      CALL SHODAT(.FALSE.,ISCAL(1),XSP,SPC,NOI,ISCAL,SCAL,MSK,1.0,0,0,
     &            NAM,CMT,.FALSE.)
 
 100  CALL MESSAGE('~ENTER~: first point, ~ESC~ exits.'//' Cursor at: ')
      CALL CURSAV
      IF ( CLEAR ) THEN
        CALL EMPHSZ
        CALL OUTSXY(ISCCOL-10,INFOCU(2),'A')
        CALL NORMAL
        CALL OUTSTR('DD/')
        CALL INVERT
        CALL OUTSTR('CLEAR')
      ELSE
        CALL INVERT
        CALL OUTSXY(ISCCOL-10,INFOCU(2),'ADD')
        CALL NORMAL
        CALL OUTSTR('/')
        CALL EMPHSZ
        CALL OUTSTR('C')
        CALL NORMAL
        CALL OUTSTR('LEAR')
      ENDIF
      CALL EMPHSZ
 
      CALL CURRES
      CALL GETPNT(NPTS,XS,YS,YSNOI,CH1,ICHR)
 
      IF ( ICHR.EQ.ESC ) GOTO 400
      IF ( (ICHR.EQ.ICHAR('A')) .OR. (ICHR.EQ.ICHAR('a')) ) THEN
        CLEAR = .FALSE.
      ELSEIF ( (ICHR.EQ.ICHAR('C')) .OR. (ICHR.EQ.ICHAR('c')) ) THEN
        CLEAR = .TRUE.
      ENDIF
      IF ( ICHR.NE.ENTER ) GOTO 100
 
      CALL ARROW(XS(CH1),YS(CH1),YSNOI(CH1))
 
*---MARK SECOND SIDE
      CH2 = CH1
 
 200  CALL MESSAGE('~ENTER~: second point, ~ESC~ exits.'//' Cursor at: '
     &             )
      CALL CURSAV
      IF ( CLEAR ) THEN
        CALL EMPHSZ
        CALL OUTSXY(ISCCOL-10,INFOCU(2),'A')
        CALL NORMAL
        CALL OUTSTR('DD/')
        CALL INVERT
        CALL OUTSTR('CLEAR')
      ELSE
        CALL INVERT
        CALL OUTSXY(ISCCOL-10,INFOCU(2),'ADD')
        CALL NORMAL
        CALL OUTSTR('/')
        CALL EMPHSZ
        CALL OUTSTR('C')
        CALL NORMAL
        CALL OUTSTR('LEAR')
      ENDIF
      CALL EMPHSZ
 
      CH2 = CH1
      CALL CURRES
      CALL GETPNT(NPTS,XS,YS,YSNOI,CH2,ICHR)
 
      IF ( ICHR.EQ.ESC ) THEN
        CALL ARROW(XS(CH1),YS(CH1),YSNOI(CH1))
        GOTO 400
      ELSEIF ( (ICHR.EQ.ICHAR('A')) .OR. (ICHR.EQ.ICHAR('a')) ) THEN
        CLEAR = .FALSE.
      ELSEIF ( (ICHR.EQ.ICHAR('C')) .OR. (ICHR.EQ.ICHAR('c')) ) THEN
        CLEAR = .TRUE.
      ENDIF
      IF ( ICHR.NE.ENTER ) GOTO 200
 
      CALL ARROW(XS(CH2),YS(CH2),YSNOI(CH2))
 
*---STORE (unscaled!) MARK
      XMIN = MIN(XSTOX(XS(CH1),SCAL),XSTOX(XS(CH2),SCAL))
      XMAX = MAX(XSTOX(XS(CH1),SCAL),XSTOX(XS(CH2),SCAL))
      DO 300 I = 1,ISCAL(1)
        IF ( (XMIN.LE.XSP(I)) .AND. (XMAX.GE.XSP(I)) ) MSK(I) = CLEAR
 300  CONTINUE
 
*---ERASE ARROWS
      CALL ARROW(XS(CH1),YS(CH1),YSNOI(CH1))
      CALL ARROW(XS(CH2),YS(CH2),YSNOI(CH2))
 
      CALL SHODAT(.FALSE.,ISCAL(1),XSP,SPC,NOI,ISCAL,SCAL,MSK,1.0,0,0,
     &            NAM,CMT,.FALSE.)
      CH1 = CH2
      GOTO 100
 
 400  CALL MESSAGE(' ')
      RETURN
      END
