**==MBNORM.FOR
      SUBROUTINE mbnorm(n,s,mcal,ical,rcal)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:
*---mru : 971216 tk
*-----------------------------------------------------------------------
*Input     N      : Number of points in spectrum
*Input     S      : Spectrum
*Input     mcal   : declared size of cal. storage
*Input     ical   : integer array of cal. constants
*Input     rcal   : real array of cal. constants
*
*Output    S      : Normalized Spectrum
*Output    rcal   : real array of cal. constants
*                 : rcal(3) = Baseline estimate is newly calculated.
*                 : rcal(4) = Area Estimate is newly calculated.
*
*     Normalize according to Data Type and Options.
*
*     For Mossbauer Experimental Spectrum (ICAL(10)=0):
*     Calculates estimate of baseline and area of spectrum and then
*     removes baseline and normalizes area to one.
*
*-----------------------------------------------------------------------
*---externals
      INTEGER n, mcal, ical(mcal)
      REAL s(n) , rcal(mcal)
*-----------------------------------------------------------------------
*---internals
      INTEGER i, itype
      real area, bl      
*-----------------------------------------------------------------------
*---executables
      itype = ical(10)

      IF ( itype.lt.1000 .and. itype.ne.60 ) THEN
*---type=Mossbauer absorption spectrum
C_ESTIMATE BASELINE
         bl = 0.0
         DO 50 i = 1 , 10
            bl = bl + s(i) + s(n-i+1)
 50      CONTINUE
         bl = bl/20.
C_REMOVE BASELINE AND CALCULATE AREA
         area = 0.0
         DO 100 i = 1 , n
            s(i) = s(i) - bl
            area = area + s(i)
 100     CONTINUE
         area = abs(area)
*---Save to cal. storage
         rcal(3) = bl
         rcal(4) = area
 
C_NORMALIZE SPECTRUM IF |AREA| > 0
         IF ( area.GT.0. ) THEN
            DO 120 i = 1 , n
               s(i) = s(i)/area
 120        CONTINUE
         ENDIF
 
      ELSEIF ( itype.eq.60 ) THEN
*---file format #6 was loaded [ Vel. , % abs.]  no baseline info
*---do nothing to data.
*---set area and baselin to nominal values
         rcal(4) =1.0
         rcal(3) = 0.0
      ELSEIF ( itype.ge.4000 .and. itype.lt.5000 ) THEN
*---type=pulse height spectrum

         bl = rcal(3)

C---CALCULATE AREA
         area = 0.0
         DO 150 i = 1 , n
            s(i) = s(i) - bl
            area = area + s(i)
 150     CONTINUE
         rcal(4) = area
      ENDIF

      RETURN
      END
