      SUBROUTINE MO57(VXX,VYY,VZZ,VXY,VXZ,VYZ,HEFX,HEFY,HEFZ,EX,EY,EZ,
     &                IPOL,ENUC,XINT)
c  mru 27Jul93 cs 
C***
C***    CALCULATION OF 57FE MOSSBAUER LINE POSITIONS AND INTENSITIES
C***    FROM A NONDIAGONAL EFG TENSOR AND AN EFFECTIVE
C***    MAGNETIC FIELD AT THE NUCLEUS.
C***
C***    INPUT PARAMETERS
C***    VXX,VYY,VZZ,VXY,VXZ,VYZ
C***    =COMPONENTS OF THE EFG TENSOR IN MM/S, VZZ ACTUALLY STANDS
C***     FOR 0.5*E*Q*VZZ
C***    HEFX,HEFY,HEFZ
C***    =COMPONENTS OF THE EFFECTIVE MAGNETIC FIELD IN KG.
C***    IPOL:  EXPERIMENTAL AND PROGRAM OPTIONS (SEE SUBROUTINE INT57)
C***    EX,EY,EZ
C***    =COMPONENTS OF THE VECTOR CHARACTERIZING THE ELECTROMAGETIC WAVE
C***      (SEE SUBROUTINE INT57)
C***
C***    OUTPUT PARAMETERS
      real ENUC(8)
C***    =ENERGIES IN MM/S.
      real XINT(8)
C***    =INTENSITIES, AS DEFINED IN SUBROUTINE INT57
C***
C***    SUBROUTINES CALLED
C***    N57G,N57E,INT57:  IN SINGLE PRECISION
C***     CH, from EISPAC,  IN  SINGLE PRECISION
C***
      real HMATR(4,4,2),UR(4,4),UI(4,4)
      REAL EIGV(4),FV1(4),FV2(4),FM1(2,4)
      real coef(10)      
      complex eigvec(4,4)
      
      integer ipol, ierr, i, j, k
      real ex, ey, ez, hefx, hefy, hefz, vxy, vxz, vyz, vxx, vyy, vzz
      real e, eg, c1, c2r, c2i

      include 'togcom.inc'

      ierr = 0
      call n57g(hefx, hefy, hefz, eg, c1, c2r, c2i)

      if (idiag4.eq.2) then
         call xn57e(hefx,hefy,hefz,vxx,vyy,vzz,vxy,vxz,vyz,coef)
         call eigval4(coef,eigv)
         call eigvec4(coef,eigv,eigvec,ierr)
      endif

      if (ierr.ne.0.or.idiag4.ne.2) then
         call n57e(hefx,hefy,hefz,vxx,vyy,vzz,vxy,vxz,vyz,hmatr)
         if (idiag4.ne.0) then
            call x4ch(hmatr(1,1,1), hmatr(1,1,2), eigv, 1, ur, ui, fv1,
     &         fv2, fm1, ierr)
         else
            call xch(4, 4, hmatr(1,1,1), hmatr(1,1,2), eigv, 1, ur, ui,
     &         fv1, fv2, fm1, ierr)
C	Patched above by PION to be solved later 
C	call ch(... to call xch(...
	   endif
         if (ierr.ne.0) then
            call errmsg ('WARNING: Nonzero error code from local CH!')
         endif
      else
         do 100 i=1,4
            do 105 j=1,4
               ur(j,i) = real(eigvec(j,i))
               ui(j,i) = aimag(eigvec(j,i))
  105       continue
  100    continue
      endif
   
      do 200 I = 1,4
*        print *, 'Eigenvalue(',i,') =',eigv(i)
        E = EIGV(I)
        ENUC(I) = E - EG
        K = I + 4
        ENUC(K) = E + EG
 200  CONTINUE
      CALL INT57(UR,UI,C1,C2R,C2I,EX,EY,EZ,IPOL,XINT)
 
      RETURN
      END
