      SUBROUTINE N57E(HEFX,HEFY,HEFZ,VXX,VYY,VZZ,VXY,VXZ,VYZ,HMATR)
 
C***
C***    THE SUBROUTINE N57H SETS UP THE MATRIX OF THE 3/2 57FE
C***    HYPERFINE HAMILTONIAN IN THE BASIS 3/2,1/2,-1/2,-3/2
C***
C***    INPUT PARAMETERS
C***    VXX,VYY,VZZ,VXY,VXZ,VYZ
C***    =COMPONENTS OF THE EFG IN MM/S
C***     HEFX,HEFY,HEFZ
C***    =COMPONENTS OF THE EFFECTIVE MAGNETIC FIELD IN KG
C***
C***    OUTPUT PARAMETERS
      REAL HMATR(4,4,2)
C***    HMATR(I,J,1) CONTAINS THE REAL PART, HMATR(I,J,2) THE
C***    IMAGINARY PART OF THE 3/2 57FE HYPERFINE HAMILTONIAN
C***    IN THE BASIS 3/2,1/2,-1/2,-3/2
C***
C***    SET UP THE HAMILTONIAN OF THE EXCITED STATE
      real vxx, vyy, vzz, vxy, vxz, vyz, hefx, hefy, hefz

      real sqrt3, h0, h1, h2
      integer i, j
   

      SQRT3 = 1.732050808
      DO 100 I = 1,4
        DO 50 J = 1,I
          HMATR(I,J,2) = 0.0
 50     CONTINUE
 100  CONTINUE
      H0 = -0.0101431*HEFZ
      H1 = H0/3.0
      H2 = VZZ/2.0
      HMATR(1,1,1) = H2 - H0
      HMATR(2,2,1) = -H2 - H1
      HMATR(3,3,1) = -H2 + H1
      HMATR(4,4,1) = H2 + H0
      H0 = VXZ/SQRT3
      H1 = -0.00585612
      H2 = -H1*HEFX
      HMATR(2,1,1) = H0 + H2
      HMATR(4,3,1) = -H0 + H2
      H0 = VYZ/SQRT3
      H2 = -H1*HEFY
      HMATR(2,1,2) = H0 + H2
      HMATR(4,3,2) = -H0 + H2
      H0 = (VXX-VYY)/3.464101616
      HMATR(3,1,1) = H0
      HMATR(4,2,1) = H0
      H0 = VXY/SQRT3
      HMATR(3,1,2) = H0
      HMATR(4,2,2) = H0
      HMATR(4,1,1) = 0.0
      H1 = -0.00676207
      HMATR(3,2,1) = -H1*HEFX
      HMATR(3,2,2) = -H1*HEFY
      RETURN
      END
