 
 
      SUBROUTINE N57G(HEFX,HEFY,HEFZ,EG,C1,C2R,C2I)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*   mru  930121 tk
*---------------------------------------------------------------------- 
C***
C***    PURPOSE
C***    DIAGONALISATION OF THE 57FE GROUND STATE HYPERFINE HAMILTONIAN
C***
C***    INPUT PARAMETERS
C***    HEFX,HEFY,HEFZ
C***    =COMPONENTS OF THE EFFECTIVE MAGNETIC FIELD IN KG
C***
C***    OUTPUT PARAMETERS
C***    C1,C2R,C2I
C***    =COEFFICIENTS OF THE EIGENSTATES
C***         !1)=C1 * !1/2) + (C2R+I*C2I) * !-1/2)
C***         !2) = -(C2R-I*C2I) * !1/2) + C1 * !-1/2)
C***       I=SQRT(-1) IN THE ABOVE FORMULA
C***    EG=ENERGY OF EIGENSTATE !1)
C***    ENERGY OF EIGENSTATE !2) IS -EG
C***

      real hefx, hefy, hefz, eg, c1, c2r, c2i

      real cost, c, hef, hefq

      if(hefx.eq.0.and.hefy.eq.0.and.hefz.eq.0)then
         eg = 0.0
         c1 = 1.0
         c2r= 0.0
         c2i= 0.0
      else
        HEFQ = HEFX*HEFX + HEFY*HEFY + HEFZ*HEFZ
        HEF = SQRT(HEFQ)
        IF ( HEFZ.LT.0.0 ) HEF = -HEF
        EG = -0.0059146*HEF
        COST = HEFZ/HEF
        C1 = SQRT(0.5*(1.0+COST))
        C = SQRT(0.5/(HEF*(HEF+HEFZ)))
        IF ( HEFZ.LT.0.0 ) C = -C
        C2R = C*HEFX
        C2I = C*HEFY
      endif

      RETURN
      END
