      subroutine nlapp(halves, npts, spc, ilines, rlpos, fpoint, v0, dv,
     &   shores)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: before 921220.tk
*---mru : 960527 tk
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'

      integer halves, npts, ilines
      real spc(npts), rlpos(12), fpoint, v0, dv
      logical shores
*-----------------------------------------------------------------------
      include 'keycom.inc'

      real v01, dv1, b1, v02, dv2, b2
      real sx, sy, sxx, sxy, delta, vn, y1, y2, x1, x2, ric, f
      real resdue(12), spc2(2*lspec)
      integer i, nhalf, iadd, ichr, iloop, ibase, itop
      integer ic, icn, icr
      real nonoys(lspec), nocal(mcal), truvel(12)
      integer inocal(mcal)
      logical nomask(lspec)
      character nocmt(6)*72
      save nonoys, nocal, nomask, nocmt, truvel
      data nonoys/lspec*0.01/
      data nocal/0.,0.,100.,1.,0.,0.,1.,0.,0.,0./
      data nomask/lspec*.true./
      data nocmt/6*' '/
      data truvel/-5.33, -3.085, -0.84, 0.84, 3.085, 5.33,
     &   5.33, 3.085, 0.84, -0.84, -3.085, -5.33/


*-----------------------------------------------------------------------

*---Make copy of distorted spectrum
      do 100 i = 1, npts
         spc2(i) = spc(i)
  100 continue

*---Divide spectrum into two halves
      nhalf = npts / halves

*---Fudge factor for 4 line vs 6 line spectra
      if (ilines.eq.4) then
         iadd = 1
      else
         iadd = 0
      endif

*---Calculate linear approx. for first half
      sx = 0.
      sxx = 0.
      sy = 0.
      sxy = 0.
      
      do 200 i = 1, ilines
         sx = sx + rlpos(i)
         sxx = sxx + rlpos(i)**2
         sy = sy + truvel(i+iadd)
         sxy = sxy + rlpos(i)*truvel(i+iadd)
  200 continue

      delta = ilines*sxx - sx*sx
      dv1 = (ilines*sxy - sx*sy)/delta
      b1 = (sxx*sy - sx*sxy)/delta
      v01 = -b1/dv1
      dv = abs(dv1)
               
*---Calculate linear approx. for second half
      if (halves.eq.2) then
         sx = 0.
         sxx = 0.
         sy = 0.
         sxy = 0.
      
         do 300 i = 7, 6+ilines
            sx = sx + rlpos(i)
            sxx = sxx + rlpos(i)**2
            sy = sy + truvel(i+iadd)
            sxy = sxy + rlpos(i)*truvel(i+iadd)
  300    continue

         delta = ilines*sxx - sx*sx
         dv2 = (ilines*sxy - sx*sy)/delta
         b2 = (sxx*sy - sx*sxy)/delta
         v02 = -b2/dv2

         dv = (abs(dv1) + abs(dv2)) / 2.0
      endif

      do 250 i = 1, ilines
         resdue(i) = truvel(i+iadd) - dv * (rlpos(i) - v01)
  250 continue
      fpoint = 0
               
      if (halves.eq.2) then
         do 350 i = 7, 6+ilines
            resdue(i) = truvel(i+iadd)  + dv * (rlpos(i) - v02)
  350    continue
         fpoint = (v01 + v02) / 2.0
      endif

*---Display residues
      if (shores) then
         nocmt(1) = 'Error in velocity at iron peaks for first half.'
         call shodat(.true., ilines, truvel, resdue, nonoys, 
     &      inocal, nocal, nomask, 1.0, 0, 1, 'First-Half', nocmt,
     &      .false.)
     
         call message('Press any key to continue...')
         call inkey(ichr)
         if (ichr.eq.CTRLP .and. .not. zcrip) then
            call intprn
            call shodat(.true., ilines, truvel, resdue, nonoys, 
     &         inocal, nocal,
     &         nomask, 1.0, 0, 1, 'First-Half', nocmt, .true.)
            call clsprn
            call clrall
         endif

         if (halves.eq.2) then
            nocmt(1) = 'Error in velocity at iron peaks'//
     &         ' for second half.'
            call shodat(.true., ilines, truvel(7), resdue(7), nonoys,
     &         inocal, nocal, 
     &         nomask, 1.0, 0, 1, 'Second-Half', nocmt, .false.)

            call message('Press any key to continue...')
            call inkey(ichr)
            if (ichr.eq.CTRLP .and. .not. zcrip) then
               call intprn
               call shodat(.true., ilines, truvel(7), resdue(7), nonoys,
     &            inocal, nocal, 
     &            nomask, 1.0, 0, 1, 'Second-Half', nocmt, .true.)
               call clsprn
               call clrall
            endif
         endif
      endif

*---Do interpolation 
      do 500 iloop = 1, halves
         if (iloop.eq.1) then
            ibase = 1
            if (halves.eq.1) then
               itop = npts
            else
               itop = int(fpoint)
            endif
            v0 = v01 
            dv = abs(dv)
         else
            ibase = int(fpoint)+1
            itop = npts
            v0 = v02
            dv = -abs(dv)
         endif


         DO 400 ICN = ibase, itop
*        Compute velocity of channel ICN in the linear scale
            vn = (icn - v0) * dv

*        Compute corresponding channel in the nonlinear scale
*        Bracket ICN between two line positions
            if (iloop.eq.1) then
               if (vn.gt.truvel(6-iadd)) then
                  y1 = truvel(5 - iadd)
                  y2 = truvel(6 - iadd)
                  x1 = rlpos(ilines - 1)
                  x2 = rlpos(ilines)
               elseif (vn.lt.truvel(1+iadd)) then
                  y1 = truvel(iadd + 1)
                  y2 = truvel(iadd + 2)
                  x1 = rlpos(1)
                  x2 = rlpos(2)
               else
                  do 450 i = 2+iadd, 6-iadd
                     if ((vn.ge.truvel(i-1)).and.(vn.lt.truvel(i))) then
                        y1 = truvel(i - 1)
                        y2 = truvel(i)
                        x1 = rlpos(i - 1 - iadd)
                        x2 = rlpos(i - iadd)
                     endif
  450             continue
               endif
            else
               if (vn.le.truvel(12-iadd)) then
                  y1 = truvel(11 - iadd)
                  y2 = truvel(12 - iadd)
                  x1 = rlpos(6 + ilines - 1)
                  x2 = rlpos(6 + ilines)
               elseif (vn.ge.truvel(7+iadd)) then
                  y1 = truvel(7 + iadd)
                  y2 = truvel(7 + iadd + 1)
                  x1 = rlpos(7)
                  x2 = rlpos(8)
               else
                  do 460 i = 8+iadd, 12-iadd
                     if ((vn.le.truvel(i-1)).and.(vn.gt.truvel(i))) then
                        y1 = truvel(i - 1)
                        y2 = truvel(i)
                        x1 = rlpos(i - iadd - 1)
                        x2 = rlpos(i - iadd)
                     endif
  460             continue
               endif
            endif

            ric = (vn-y1)*(x2-x1)/(y2-y1) + x1

*---Wrap around
            ric = mod(mod(ric-1, float(npts))+npts,float(npts)) + 1

            IC = INT(RIC)
            
C           Interpolate
            F = RIC - FLOAT(IC)
            if (ic.lt.npts) then
               ICR = IC + 1
            else
               ICR = 1
            endif
            spc(ICN) = (1.-F)*spc2(IC) + F*spc2(ICR)
  400    CONTINUE
  500 continue

*---Return step and zero channel
      dv = abs(dv)
      if (halves.eq.2) then
         v0 = v01 + (1 + npts)/2. - fpoint
      else
         v0 = v01
      endif

      return
      end
