*-------------------------------------------------------------------
      subroutine paradj
*-------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 11Aug93 cs
*    mru 22Jul93 cs
*     MOSS version
*     Adjusts the parameters (just read) to deal with changes
*     in format (for example, if an old model has some new 
*     parameters added)
*     Filver value: -2 as of 29Oct92
*                 : -3 as of 14Jul93
*                 : -6 as of 27Jul93
*-------------------------------------------------------------------
      INCLUDE 'limits.inc'
      include 'parcom.inc'

      integer iglo, isub, ipnum, ipar, i
      integer isubnm(mltot+mbasis), inm(mltot+mbasis)
*-------------------------------------------------------------------

*---Adjust for movement of NSUBS parameter from a fitting parameter
*---to its (old) proper place as an integer global parameter.
      if (filver.ge.0) then
*---Add nsites to integer globals
         do 300 ipar = igp(1,1), 3, -1
            igp(ipar+1,1) = igp(ipar,1)
            igpnam(ipar+1,1) = igpnam(ipar,1)
  300    continue
         igp(3,1) = ifp(3)
         igpnam(3,1) = fitnam(3)
         igp(1,1) = igp(1,1) + 1
         
*---Delete nsites, move jput from #2 -> #3, and add filver to ifp as #2.
         ifp(3) = ifp(2)
         fitnam(3) = fitnam(2)
         fitnam(2) = 'Version #'
      endif

*---Adjust for addition of "number of linear parameters" to the
*---integer local parameters array, the new ilp(3).  All old parameters
*---#'s 3 and above are shifted up by one.
      if (filver.gt.-5) then
         do 7 isub = 1, nsubs
            do 5 ipar = ilp(1,isub), 3, -1
               ilp(ipar+1,isub) = ilp(ipar,isub)
               ilpnam(ipar+1,isub) = ilpnam(ipar,isub)
    5       continue
            ilp(1,isub) = ilp(1,isub) + 1
            ilp(3,isub) = 1
            ilpnam(3,isub) = 'Nlnpar'
    7    continue
      endif

*---Adjust for change in which local parameters are numbered starting with
*---101, so that the parameter number is (100*subsite number) + 
*---(order number within subsite), as opposed to being viewed as one
*---long list/vector of parameters.
      if (filver.gt.-5) then

c        ;; Fix global nonlinear constraints
         do 20 iglo = 1, nglo
            do 15 ipar = 1, igp(2,iglo)
               if (kong(ipar,iglo).ne.0) then
                  kong(ipar,iglo) = 100 * iglo + kong(ipar,iglo)
               endif
   15       continue
   20    continue

*        /* Fix local nonlinear constraints */
         ipnum = 0
         do 28 isub = 1, nsubs
            do 25 ipar = 1, ilp(2,isub)
               ipnum = ipnum + 1
               isubnm(ipnum) = isub
               inm(ipnum) = ipar
   25       continue
   28    continue

         do 40 isub = 1, nsubs
            do 30 ipar = 1, ilp(2,isub)
               ipnum = konl(ipar,isub)
               if (ipnum.ne.0) konl(ipar,isub) = 100*isubnm(ipnum) +
     &            inm(ipnum)
   30       continue
   40    continue

*        /* Fix local linear constraints (known 1 per site) */
         do 60 isub = 1, nsubs
            ipnum = konln(1,isub)
            if ((ipnum.gt.0).and.(ipnum.le.nsubs)) then
               konln(1,isub) = 100 * ipnum + 1
            else
               konln(1,isub) = 0
            endif
   60    continue
      endif

*---Adjust for change which added 3 nonlinear local params (A-tensor Euler
*---angles).  Assume any parameter set having exactly 10 local nonlinear
*---parameters and a model=1 must have the 3 Euler angles added as 
*---params #9, 10, 11

      if ((ilp(2,1).eq.10).and.(model.eq.1).and.(filver.ge.0)) then

*---Change number of local params for each subsite from 10 -> 13
         do 100 isub = 1, nsubs
            ilp(2,isub) = 13
  100    continue

*        /* Move old #'s 9,10 to new #'s 12 & 13 */
         do 200 i = 12, 13
            pl0(i,isub) = pl0(i-3,isub)
            pllb(i,isub) = pllb(i-3,isub)
            plub(i,isub) = plub(i-3,isub)
            weil(i,isub) = weil(i-3,isub)
            plnam(i,isub) = plnam(i-3,isub)
            konl(i,isub) = konl(i-3,isub)
  200    continue

*        /* Make copies of angle values from (3,4,5) => (9,10,11) */       
         do 220 i = 9, 11
            pl0(i,isub) = pl0(i-6,isub)
            pllb(i,isub) = pllb(i-6,isub)
            plub(i,isub) = plub(i-6,isub)
            weil(i,isub) = 1.0
            konl(i,isub) = 0
  220    continue

*        /* Fix constraints that pointed to moved parameters*/
         do 240 i = 1, 13
            if (konl(i,isub).ne.0) then
               ipnum = 1 + mod(konl(i,isub)-1,100)
               if (ipnum.ge.9) konl(i,isub) = konl(i,isub) + 3
            endif
  240    continue

*        /* Fix names of angle parameters */
         plnam(3,isub) = 'AL efg'
         plnam(4,isub) = 'BE efg'
         plnam(5,isub) = 'GA efg'
         plnam(9,isub) = 'AL A'
         plnam(10,isub) = 'BE A'
         plnam(11,isub) = 'GA A'
      endif

      if (filver.gt.-6) then
         fitnam(10) = 'Perturb'
      endif

*---Update file version number: -5 as of 21Jul93
      filver = -6

      return
      end
