*-----------------------------------------------------------------------
      subroutine pltitl(kxplot,kyplot,mcal,rcal,ical,xttl,yttl,xtttl)
*-----------------------------------------------------------------------
*     Defines the titles for the bottom x-axis, y-axis, and top x-axis.
*     This routine is specifically for WMOSS.
*
*     kxplot : Scaling type for x-axes (both of them);
*     kyplot : Scaling type for y-axis;
*     mcal   : length of rcal and ical arrays;
*     rcal   : real calibration values for spectrum to be plotted;
*     ical   : integer calibration values for spectrum to be plotted;
*     xttl   : (output) Lower x-axis title;
*     yttl   : (output) Y-axis title;
*     xtttl  : (output) Top x-axis title.
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*_10Nov92 TK
*_mru 03Jan93 CS; 19980313 tk
*-----------------------------------------------------------------------
*---Externals
      integer kxplot, kyplot, mcal, ical(mcal)
      real rcal(mcal)
      character*(*) xttl, yttl, xtttl
*---Internals
      integer itype
*-----------------------------------------------------------------
*---Executables
*---initialize titles to blanks
      xttl = ' '
      yttl = ' '
      xtttl = ' '

*---Data type
      itype = ical(10)

      if(itype.lt.200)then
*---Mossbauer data type
      if (kxplot.eq.1) then
         xttl = 'Channel #'
      elseif (kxplot.eq.2) then
         xttl = 'Source Velocity [mm/s]'
      else
         xttl = ' '
      endif

      if(kyplot.eq.1) then
         yttl='Counts [Millions]'
      elseif (kyplot.eq.2) then
         yttl='Absorption [%]'
*---PION (for IronCal Residuals Plot)
      elseif (kyplot.eq.3) then
         yttl='Velocity error [mm/s]'
*---
      else
         yttl = ' '
      endif
      
      elseif(itype.eq.201)then
      if (kxplot.eq.1) then
         xttl = 'Channel #'
      elseif (kxplot.eq.2) then
         xttl = 'Shift [mm/s]'
      else
         xttl = ' '
      endif
*---Probability Distribution vs. Shift
        yttl = 'Probability [per mm/s]'
      elseif(itype.eq.202)then
*---Probability Distribution vs. Quadrupole Splitting
      if (kxplot.eq.1) then
         xttl = 'Channel #'
      elseif (kxplot.eq.2) then
        xttl = 'dEq [mm/s]'
      else
         xttl = ' '
      endif
        yttl = 'Probability [per mm/s]'
      elseif(itype.eq.203)then
*---Probability Distribution vs. Hinternal
      if (kxplot.eq.1) then
         xttl = 'Channel #'
      elseif (kxplot.eq.2) then
        xttl = 'z [mm/s]'
      else
         xttl = ' '
      endif
        yttl = 'Probability [per mm/s]'


      elseif(itype.ge.4000 .and. itype.lt.5000)then
*---pulse height spectrum
      if (kxplot.eq.1) then
         xttl = 'Channel #'
      elseif (kxplot.eq.2) then
         xttl = 'Energy [keV]'
      else
         xttl = ' '
      endif

      if(kyplot.eq.1) then
         yttl='Counts'
      elseif (kyplot.eq.2) then
         yttl='Count Rate [1/s]'
      else
         yttl = ' '
      endif
      else
         call errmsg('Invalid Data Type in Pltitl')
      endif

      return
      end
