*-----------------------------------------------------------------------
      subroutine prtpar(FinFF)
*-----------------------------------------------------------------------
      logical FinFF
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    mru 05Sep93 cs
*     Writes the current parameter set to the text output device.
*
*     FinFF  : [input]  Should the printout end with a final form feed?
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'iocom.inc'
      include 'parcom.inc'
      include 'constcom.inc'
 
      integer COLHT, HEADHT
      parameter (COLHT=parmax + mloc + 10, HEADHT=9)
 
      character*49 ltcol(COLHT)
      character*20 rtcol(COLHT)
      character*72 header(HEADHT)
      character inum*5, icon*5, ival*5, lbnd*8, ubnd*8, val*8
      integer imin, isec, iyr, imon, iday, izero, ihr

      integer lcount, rcount, i, j, ierr, isub
      logical opnd

      integer lenact
      external lenact
*-----------------------------------------------------------------------
      integer ij2kon
      ij2kon(i,j) = i + 100 * j
*-----------------------------------------------------------------------

      do 100 i = 1, COLHT
        ltcol(i) = ' '
        rtcol(I) = ' '
 100  continue
      do 200 i = 1, HEADHT
        header(i) = ' '
 200  continue

      call osdate(iyr,imon,iday)
      call ostime(ihr,imin,isec)
      izero = ichar('0')

c     /* Define a header for the printout */
      header(3) = filnam(1)//' (output to '//filnam(2)
     &            (1:lenact(filnam(2)))//')'
      header(4) = parcmt(1)
      header(5) = parcmt(2)
      header(6) = parcmt(3)
      header(7) = parcmt(4)
      header(8) = 'Printed at '// 
     &   char(izero+ihr/10)//char(izero+mod(ihr,10))//':'//
     &   char(izero+imin/10)//char(izero+mod(imin,10))//':'//
     &   char(izero+isec/10)//char(izero+mod(isec,10))//' on '//
     &   char(izero+imon/10)//char(izero+mod(imon,10))//'/'//
     &   char(izero+iday/10)//char(izero+mod(iday,10))//'/'//
     &   char(izero+mod(iyr,100)/10)//char(izero+mod(iyr,10))
      header(9) = '   #  name          value   kon    lbnd     ubnd'

c     /* Add integer fitting parameters to right-hand column */
      rcount = 0
      do 300 i = 2, ifp(1)
        rcount = rcount + 1
        call intstr(ifp(i),ival,'(i5)')
        rtcol(rcount) = fitnam(i)//' '//ival
 300  continue

c     /* Add integer global parameters to right-hand column */
      rcount = rcount + 1
      do 410 j = 1, nglo
         do 400 i = 3, igp(1,j)
            rcount = rcount + 1
            call intstr(igp(i,j),ival,'(i5)')
            rtcol(rcount) = igpnam(i,j)//' '//ival
  400    continue
  410 continue

c     /* Add global nonlinear parameters to left-hand column */ 
      lcount = 0
      do 510 j = 1, nglo
         do 500 i = 1, igp(2,j)
            lcount = lcount + 1
            call intstr(ij2kon(i,j), inum, '(I5)')
            call intstr(kong(i,j), icon,'(I5)')
            call convrt(pglb(i,j), lbnd, .false.)
            call convrt(pgub(i,j), ubnd, .false.)
            call convrt(pg0(i,j), val, .false.)
            ltcol(lcount) = inum // ' ' // pgnam(i,j) // ' ' // VAL //
     &         ' '//icon//' '//lbnd//' '//ubnd
  500    continue
  510 continue

c     /* Add local parameters to the left-hand column */
      do 650 isub = 1, nsubs
c        /* Local Nonlinear */
         lcount = lcount + 1
         do 600 i = 1, ilp(2,isub) 
            lcount = lcount + 1
            call intstr(ij2kon(i,isub), inum, '(I5)')
            call intstr(konl(i,isub), icon, '(I5)')
            call convrt(pllb(i,isub), lbnd, .false.)
            call convrt(plub(i,isub), ubnd, .false.)
            call convrt(pl0(i,isub), val, .false.)
            ltcol(lcount) = inum // ' ' // plnam(i,isub) // ' ' // 
     &         val // ' ' // icon // ' ' // lbnd // ' ' // ubnd
  600    continue

c        /* Local Integer */
         do 620 i = 4, ilp(1,isub)
            lcount = lcount + 1
            call intstr(ilp(i,isub),ival,'(I5)')
            ltcol(lcount) = '     ' // ilpnam(i,isub) // ' ' // ival
  620    continue

c        /* Local Linear */
         do 630 i = 1, ilp(3,isub)
            lcount = lcount + 1
            call intstr(ij2kon(i,isub), inum, '(I5)')
            call intstr(konln(i,isub), icon, '(I5)')
            call convrt(pln0(i,isub), val, .false.)
            ltcol(lcount) = inum // ' ' // plnnam(i,isub) // ' ' //
     &         val // ' ' // icon
  630    continue
  650 continue

c     /* Open the printer unit JPRN to the text output file */
      call opntxt(opnd, ierr)

      if (ierr.eq.0) then
c        /* Print the header */ 
         do 800 i = 1, HEADHT
            write (jprn,'(5X,A72)',ERR=950) header(i)
  800    continue

c        /* Print the 2 columns in parallel */ 
         do 900 i = 1, max(rcount,lcount)
            write (jprn,'(5X,A49,5X,A20)',ERR=950) ltcol(i), rtcol(i)
  900    continue
  
         if (FinFF) write(jprn,*) char(12)
  950    call clstxt(opnd)
      endif
 
      return
      end
