      subroutine readsp(name, islot, isnew, ierr)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:
*---mru 960805 tk;
*---    980213 major change, use FILIOP to define INFTYP. tk;
*---    980502 tk ;
*--- PION
      character*(*) name 
	integer islot, isnew, ierr
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    1992 cs&tk, mru 12Aug93 cs
*
*     Reads in a data file (which is assumed to exist) and puts the
*     spectrum into the list, in the given slot.
*
*     name   : [Input]  Filename to read;
*     islot  : [Input]  Place in list to put the new spectrum;
*     isnew  : [Output] Last FILLED slot after read (if ierr=0);
*     ierr   : [Output] Error code returned.
*------------------------------------------------------------------------
*---File type (ical(5)) Redefined 980212 tk. See file FILIOP.FOR
*Formats with full header and (folded) normalized data.  Do NOT call MBnorm.
*
*subroutine | #  File format
*           |
*binio      | 1. WEB Binary (4 byte floating point)',
*biniop     | 2. WEB Binary (2 byte integer)',
*ascin      | 3. WEB ASCII (10 line header)' ,
*
*Formats with partial or no header and raw data.  
*May need folding (call FALT) or not (call FIXSAWTH).  Do call MBnorm
*ascifr     | 4. Y  ASCII, (Y-values only, free format)',
*ascicc     | 5. XY ASCII, (channel, counts) (no header)',
*ascivp     | 6. XY ASCII, (Vel. [mm/s], Abs. [%]) (no header)',
*bioegg     | 7. EG&G MCS+ binary file, *.mcs',
*can1024    | 8. Canberra FMS card, ASCII 1024 channels' ,
*can512     | 9. Canberra FMS card, ASCII 512 channels',
*asc35p     |10. Canberra MCA 35+',
*rgrasc     |11. Ranger 1024 channels',
*ascsch     |12. Elscint (Schoonen) ASCII folded, 512 channels',
*asccmu     |13. CMU (Munck) unfolded',
*ascbhh     |14. Emory U. (Huynh) Folded',
*kevasc     |15. Vermont (Spartalian) unfolded',
*monasi     |16. Monash U. (Cashion)' ,
*ascmaa     |17. EG&G Maestro ASCII (Print to File) PHA'

*--------------------------------------------------------------------------
      include 'limits.inc'
      include 'iocom.inc'
      include 'speccom.inc'
      include 'togcom.inc'
      include 'keycom.inc'
      include 'errcodes.inc'

      character tmpcmt*72, query*74
      character*(mfllen) tmppth
      integer i, plen, ichr, npts, nread
      logical getyn, normb4

      integer lenact,infocu
      external getyn, lenact, infocu
*-----------------------------------------------------------------------
*---executables
      isnew = islot
      spcnam(islot) = name
      normb4 = .true.

*---clear cal. info
         do 250 i = 1, MCAL
            spccal(i,islot) = 0.0
            icalsp(i,islot) = 0
  250    continue

*---use format specified by INFTYP
*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      if(inftyp.eq.1)then 
c     ;;;;;;;;;;;;;;;;;;;;;;;;;
c-1-  ;; BINARY:  WEB format ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;
      call binio(spcnam(islot), JDISK, 0, MMAIN-islot,
     &   spccmt(1,islot), icalsp(1,islot), spccal(1,islot),
     &   spctra(1,islot), nread, ierr)
      if (ierr.eq.NoError) then
         isnew = isnew - 1 + nread
      elseif ((ierr.ne.NoError).and.(nread.gt.0)) then
         call errmsg('~Warning~:  Error detected in '//
     &      'multi-spectrum file!')
         ierr = NoError
         isnew = isnew - 1 + nread
      endif
      if ((ierr.eq.NoError) .and. (icalsp(5,islot).eq.0)) then
c        ;; Some very early binary files were created with the first
c        ;; two comment lines interchanged;  here we fix this.
         call fipath(spcnam(islot),tmppth,plen)
         query = 'Change ' // 
     &      spcnam(islot)(plen+1:lenact(spcnam(islot))) // 
     &      ' comment: ' // spccmt(1,islot)(:17) // '...to: ' //
     &      spccmt(2,islot)(:17) // '...?'
         if (getyn(query(1:lenact(query)))) then
            tmpcmt = spccmt(1,islot)
            spccmt(1,islot) = spccmt(2,islot)
            spccmt(2,islot) = tmpcmt
         endif
         call binio(spcnam(islot), JDISK, 1, 1, spccmt(1,islot),
     &      icalsp(1,islot), spccal(1,islot), spctra(1,islot),
     &      nread, ierr)
         if (ierr.ne.0) then
            call errmsg('Error: Disk file not changed')
            ierr = 0
         endif
      endif
         icalsp(5,islot) = inftyp

*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;      
      elseif(inftyp.eq.2)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;
c-2-  ;; BINARY:  packed WEB format ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;
        call biniop(spcnam(islot), JDISK, 0, MMAIN-islot,
     &   spccmt(1,islot), icalsp(1,islot), spccal(1,islot),
     &   spctra(1,islot), nread, ierr)
      if (ierr.eq.NoError) then
         isnew = isnew - 1 + nread
      elseif ((ierr.ne.NoError).and.(nread.gt.0)) then
         call errmsg('~Warning~:  Error detected in '//
     &      'multi-spectrum file!')
         ierr = NoError
         isnew = isnew - 1 + nread
      endif
      if ((ierr.eq.NoError) .and. (icalsp(5,islot).eq.0)) then
c        ;; Some very early binary files were created with the first
c        ;; two comment lines interchanged;  here we fix this.
         call fipath(spcnam(islot),tmppth,plen)
         query = 'Change ' // 
     &      spcnam(islot)(plen+1:lenact(spcnam(islot))) // 
     &      ' comment: ' // spccmt(1,islot)(:17) // '...to: ' //
     &      spccmt(2,islot)(:17) // '...?'
         if (getyn(query(1:lenact(query)))) then
            tmpcmt = spccmt(1,islot)
            spccmt(1,islot) = spccmt(2,islot)
            spccmt(2,islot) = tmpcmt
         endif
         call biniop(spcnam(islot), JDISK, 1, 1, spccmt(1,islot),
     &      icalsp(1,islot), spccal(1,islot), spctra(1,islot),
     &      nread, ierr)
         if (ierr.ne.0) then
            call errmsg('Error: Disk file not changed')
            ierr = 0
         endif
      endif
         icalsp(5,islot) = inftyp

*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.3)then
c     ;;;;;;;;;;;;;;;;;;;
c-3-  ;; ASCII: WEB 10 ;;
c     ;;;;;;;;;;;;;;;;;;;
         call ascin(spcnam(islot), 0, LSPEC, 0, spctra(1,islot), 6,
     &      spccmt(1,islot), 10, icalsp(1,islot), 10, spccal(1,islot),
     &      ierr)

         if (ierr.eq.0) then
*---set file type (see readsp.for)
            icalsp(5,islot) = inftyp
         endif

*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      endif

*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
*---Custom formats

      if(inftyp.eq.4)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c-4- ;; ASCII:  Y values only, free format ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c        ;; Get number of points from user.
         call message('How many points in spectrum?')
         npts = 256
         call geti(infocu(1), infocu(2), npts, ichr, .false.)
         if (ichr.eq.ESC) then
            ierr = 99
            return
         endif

         call ascifr(spcnam(islot), npts, spctra(1,islot), 6,
     &      spccmt(1,islot), 10, icalsp(1,islot), 10, spccal(1,islot),
     &      ierr)
         if (ierr.ne.0) then
            call errmsg('Error loading free format file. INFTYP = 4')
         else
            icalsp(5,islot) = inftyp
            normb4=.false.
         endif
*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.5)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c-5- ;; ASCII:  X,Y values [channel, counts], free format ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c        ;; Get number of points from user.
         call message('How many points in spectrum?')
         npts = 256
         call geti(infocu(1), infocu(2), npts, ichr, .false.)
         if (ichr.eq.ESC) then
            ierr = 99
            return
         endif

         call ascicc(spcnam(islot), npts, spctra(1,islot), 6,
     &      spccmt(1,islot), 10, icalsp(1,islot), 10, spccal(1,islot),
     &      ierr)
         if (ierr.ne.0) then
            call errmsg('Error loading free format file. INFTYP = 5')
         else
            icalsp(5,islot) = inftyp
            normb4=.false.
         endif
*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.6)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c-6- ;; ASCII:  X,Y values [Vel., % Abs.], free format ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c        ;; Get number of points from user.
         call message('How many points in spectrum?')
         npts = 256
         call geti(infocu(1), infocu(2), npts, ichr, .false.)
         if (ichr.eq.ESC) then
            ierr = 99
            return
         endif

         call ascivp(spcnam(islot), npts, xspc(1,islot),
     &      spctra(1,islot), 6,
     &      spccmt(1,islot), 10, icalsp(1,islot), 10, spccal(1,islot),
     &      ierr)
         if (ierr.ne.0) then
            call errmsg('Error loading free format file. INFTYP = 6')
         else
            icalsp(5,islot) = inftyp
            normb4=.false.
         endif


*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.7)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;
c-7- ;; BINARY:  EG&G MCS+ format ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;
      call bioegg(spcnam(islot), JDISK, 0, MMAIN-islot,
     &   spccmt(1,islot), icalsp(1,islot), spccal(1,islot),
     &   spctra(1,islot), nread, ierr)
         if (ierr.eq.NoError) then
            icalsp(5,islot) = inftyp
            normb4=.false.
         else
          call errmsg('Error loading EG&G MCS+ binary file. INFTYP=7')
         endif

*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.8)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c-8-  ;; ASCII:  Canberra FMS card: 1024 channels ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        call can1024(spcnam(islot), LSPEC, spctra(1,islot), 2,
     &     spccmt(1,islot), icalsp(1,islot), spccal(1,islot), ierr)
         if (ierr.eq.NoError) then
            icalsp(5,islot) = inftyp
            normb4=.false.
         else
          call errmsg('Error: Canberra FMS card 1024 file. INFTYP=8')
         endif
        
*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.9)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c-9-  ;; ASCII:  Canberra FMS card: 512 channels ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        call can512(spcnam(islot), LSPEC, spctra(1,islot), 2,
     &     spccmt(1,islot), icalsp(1,islot), spccal(1,islot), ierr)
         if (ierr.eq.NoError) then
            icalsp(5,islot) = inftyp         
            normb4=.false.
         else
          call errmsg('Error: Canberra FMS card 512 file. INFTYP=9')
         endif

*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.10)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c-10- ;; ASCII:  Canberra 35 Plus MCA ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         call asc35p(spcnam(islot), LSPEC, spctra(1,islot), 2,
     &      spccmt(1,islot), icalsp(1,islot), spccal(1,islot), ierr)
         if (ierr.eq.NoError) then
            icalsp(5,islot) = inftyp         
            normb4=.false.
         else
            call errmsg('Error: Canberra 35 Plus file. INFTYP=10')
         endif

*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.11)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c-11- ;; ASCII:  Ranger unfolded ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         call rgrasc(spcnam(islot), LSPEC, spctra(1,islot), 2,
     &      spccmt(1,islot), icalsp(1,islot), spccal(1,islot), ierr)
         if (ierr.eq.NoError) then
            icalsp(5,islot) = inftyp         
            normb4=.false.
         else
            call errmsg('Error loading Ranger ASCII file. INFTYP=11')
         endif

*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.12)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c-12- ;; ASCII:  Schoonen, SUNY Elscint ASCII Pulse Height Spectrum ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         call ascsch(spcnam(islot), LSPEC, spctra(1,islot), 6,
     &      spccmt(1,islot), icalsp(1,islot), spccal(1,islot), ierr)
         if (ierr.eq.NoError) then
            icalsp(5,islot) = inftyp         
            normb4=.false.
         else
            call errmsg('Error reading Elscint file. INFTYP=12')
         endif


*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.13)then
c     ;;;;;;;;;;;;;;;;;;;;;;;
c-13-  ;; ASCII: Munck 4 or 5 ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;
*---try reading spectrum as unfolded 512 point file. (4 line header)
         call asccmr(spcnam(islot), spctra(1,islot), 
     &      spccmt(1,islot), icalsp(1,islot), spccal(1,islot),
     &      ierr)

         if(ierr.ne.0)then
*---if error, try unpacked, folded 256 point file. (5 line header)
          call asccmp(spcnam(islot), spctra(1,islot), 
     &      spccmt(1,islot), icalsp(1,islot), spccal(1,islot),
     &      ierr)
         endif

         if(ierr.ne.0)then
*---if error, try folded 256 point file. (4 line header)
          call asccmf(spcnam(islot), spctra(1,islot), 
     &      spccmt(1,islot), icalsp(1,islot), spccal(1,islot),
     &      ierr)
         endif
           
         if (ierr.eq.0) then
            tmpcmt = spccmt(1,islot)
            spccmt(1,islot) = spccmt(2,islot)
            spccmt(2,islot) = tmpcmt
*---set file type 
            icalsp(5,islot) = inftyp
            normb4=.false.
         else
            call errmsg('Error loading CMU file. INFTYP=13')
         endif

*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.14)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;
c-14- ;; ASCII:  Huynh folded ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;
          call ascbhh(spcnam(islot), spctra(1,islot), 
     &      spccmt(1,islot), icalsp(1,islot), spccal(1,islot),
     &      ierr)
         if (ierr.eq.0) then
*---set file type (see readsp.for)
            icalsp(5,islot) = inftyp
            normb4=.false.
         else
            call errmsg('Error loading Emory file. INFTYP=14')
         endif
*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.15)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c-15- ;; ASCII:  Spartalian sawtooth ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         call kevasc(spcnam(islot), LSPEC, spctra(1,islot), 2,
     &      spccmt(1,islot), icalsp(1,islot), spccal(1,islot), ierr)
         if (ierr.eq.0) then
*---set file type (see readsp.for)
            icalsp(5,islot) = inftyp
            normb4=.false.
         else
            call errmsg('Error loading Vermont file. INFTYP=15')
         endif

*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.16)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;
c-16- ;; Monash ASCII        ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;
       call monasi(spcnam(islot), spctra(1,islot),
     &   spccmt(1,islot), icalsp(1,islot), spccal(1,islot), ierr)
         if (ierr.eq.0) then
*---set file type (see readsp.for)
            icalsp(5,islot) = inftyp
            normb4=.false.
         else
            call errmsg('Error: Monash ASCII file. INFTYP=16')
         endif

*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      elseif(inftyp.eq.17)then
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c-17-  ;; ASCII:  EG&G Maestro Print to File Pulse Height spectrum ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         call ascmaa(spcnam(islot), 0, lspec, 0, spctra(1,islot), 3,
     &      spccmt(1,islot), 3, icalsp(1,islot), 0, spccal(1,islot),
     &      ierr)
         if (ierr.eq.0) then
*---set file type (see readsp.for)
            icalsp(5,islot) = inftyp
            normb4=.true.
         else
            call errmsg
     &      ('Error: EG&G ASCII Pulse Height Spectrum. INFTYP=17')
         endif

*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      endif

*-------------------------------------------------------------------------
*---tidy up
      if ((ierr.ne.0).and.(ierr.ne.-999)) then
      elseif (ierr.ne.-999) then
         do 500 i = islot, isnew
*---if needed, normalized data
         if(.not. normb4)
     &      call mbnorm(icalsp(1,i), spctra(1,i),
     &         mcal, icalsp(1,i), spccal(1,i) )

*---if needed, let user edit data header
          if(icalsp(5,i).gt.3)  call edtcal(i, .false.)

c---recalc x-values and  scaled noise values
            if (spccal(4,i) .eq. 0.0) then
               call errmsg(
     &         'Warning: Area is zero. Scaled noise set to zero.')
            endif
            call caladj(MCAL, spccal(1,i), icalsp(1,i), icalsp(1,i),
     &         xspc(1,i), spctra(1,i), spcnoi(1,i))
  500    continue
      endif

      return
      end
