      subroutine rgrasc(FILNAM,md,SPEC,NTX,TEXT,ICAL,RCAL,IERR)
C
C     1. READ unfolded SPECTRUM AND ITS HEADER from ASCII file.
*        THIS FORMAT COMPATIBLE WITH FILES created by
*        Ranger Scientific spectrometers
*     2. fold the spectrum 
*     3. return folded  channel spectrum in SPEC
 
C       HEADER IS FOLLOWED BY A REAL ARRAY CONTAINING THE
C       SPECTRAL DATA.  LOWER BOUND SUBSCRIPT OF THE ARRAY
C       IS 1.   UPPER BOUND SUBSCRIPT IS NCHANS=ical(1).
C
C---history 960117 TK
*---mru 19980215 tk: define inocal.
C --------------------------------------------------
      include 'limits.inc'
      INCLUDE 'iocom.inc'
*---externals 
      CHARACTER FILNAM*(*),TEXT(6)*72
      REAL SPEC(md),RCAL(*)
      INTEGER I,ICAL(*),IERR
      INTEGER NTX
*---internals
      integer ispec(2*lspec), md, nl, l
      real tmpspc(2*lspec)
      character key*4

      REAL NONOYS(2*LSPEC),XPOS(2*LSPEC),NOCAL(MCAL)
      INTEGER INOCAL(MCAL)
      LOGICAL NOMASK(2*LSPEC)
      CHARACTER NOCMT(6)*72


*---external funcions
      logical getyn
      external getyn
 
*---number of channels in unfolded spectrum and folde data
      integer nuf,nf
*---define no cal values
      save inocal, nocal, nocmt
      data inocal/1024,9*0/
      DATA NOCAL/0.,0.,100.,1.,0.,0.,1.,0.,0.,0./
      DATA NOCMT/6*' '/
*-------------------------------------------------------------------------- 
*---executables

C OPEN FILE
      OPEN (JDISK,FILE=FILNAM,IOSTAT=IERR)
      IF ( IERR.NE.0 ) RETURN
 
*---initialize data header storage
      do 40 i=1,mcal
         rcal(i)=0.0
         ical(i)=0
40    continue 
      do 45 i=1,mcommt
         text(i)=' '
45    continue
      Text(1)= 'Ranger ASCII file.'

*---skip the 12 blank lines
        DO 55 I = 1,12
          READ (JDISK,*,IOSTAT=IERR,ERR=999) 
 55     CONTINUE
 
C READ IN THE unfolded NUF channel SPECTRUM
        nl=8
        l = 0  
        nuf = 0
  900   read (jdisk,9001,iostat=ierr,end=903,err=999) key, 
     &     (ispec(nl*l+i),i=1,nl)
*---Make sure a Ranger ASCII file is being read.
        if(l.eq.0 .and. key.ne.'   0')then
           ierr=-889
           goto 999
        endif

        l = l + 1
        nuf = nuf + nl
        goto 900
 
903     close(jdisk, iostat=ierr)
*---check spectrum length
        if(nuf.gt.2*lspec)then
           ierr=-nuf
           goto 900
        endif
*---convert to floating point storage
          do 904 i=1,nuf-1
            tmpspc(i)=ispec(i)
  904    continue
         tmpspc(nuf)=tmpspc(nuf-1)
*---patch for MS 900: that model uses 1st channel for time info
         tmpspc(1) = tmpspc(2)
*------------------------------------------------------------------
*---display raw data
          do 150 i=1,nuf
             xpos(i)=i
             nonoys(i)=0.0
             nomask(i)=.true.
  150     continue
       CALL SHODAT(.TRUE.,Nuf,XPOS,tmpspc,NONOYS,INOCAL,NOCAL,NOMASK,
     &   1.0,0,0,FILNAM,NOCMT,.FALSE.)
*--------------------------------------------------------------------
         call message(' ')
         if(getyn('Fold data ?'))then
*----fold spectrum
         CALL FALT(filnam, nuf, tmpspc, nf, spec, rcal(5), rcal(6),
     &      rcal(7), ierr)
         if (ierr.eq.0) ical(1) = nf
      else
*---do not fold spectrum
         call fixsawth(filnam,tmpspc,spec,nuf,rcal(5),rcal(6),
     &      rcal(7),ierr)
         if (ierr.eq.0) ical(1) = nuf
      endif
*----------------------------------------------------------------------
         if (ierr.eq.0) then
            ical(2) = 1
            do 200 i=3, 10
               ical(i) = 0
  200       continue
*---set file type (see readsp.for)
            ical(5) = 7

            do 210 i = 1,4
               rcal(i) = 0.0
  210       continue
            do 220 i = 8,10
               rcal(i) = 0.0
  220       continue
         endif
 
  999 continue
      RETURN
 
 9001 format(a4,8i8)
      END
