**************************************************************************
**************************************************************************
*I lost part of the text header that accompanied this, when I received it,
*so here are some vitals (it came with no instructions, so those and the
*comments are mine);
*
*I received this from STUART@ADS.COM, and feel you should drop THAT person
*a note of thanks from yourself and me. Stuart's original, that he sent me
*said that this originally appeared in "Toward a Universal Random Number
*Generator" by George Marsaglia and Arif Zaman. Florida State University
*Report: FSU-SCRI-87-50 (1987). It was later modified by F. James and
*published in "A Review of Pseudo-random Number Generators"
*
*The highest recognition is due to these authors, who made this available.
*
*
*Stuart says this is the BEST KNOWN RANDOM NUMBER GENERATOR available.
*It passes all tests for a random number generator, and has a period
*of 2^144, and will give bit-identical results on all machines with
*at least 24-bit manitissas in the floating point representation.
*
*I have run it on a machine that I believe has a 16 bit mantissa in the
*floating point, and it was NOT identical results. But it still functioned
*perfectly for my applications!
*
*The algorithm is a combination of Fibonacci sequence (with lags of 97
*and 33, and operation "subtraction plus one, modulo one") and an
*"arithmetic sequence" (using subtraction.
*
*There are three routines contained herein. I have separated them and the
*notes with double lines of asterisks (just delete all between them and the
*lines of asterisks).
*
*The first program, called TstRAN is a test for correct operation.
*
*The second part, RANMAR, is the function itself, which must be included
*in any program where you wish to call it from.
*
*The third part is the initialization routine, which asks for the number seeds.
*
*The first would actually be replaced by YOUR application (note the way the
*function is called, for anyone not familiar). The value returned by the RANMAR
*function is fully scalable (I use it between 0 & 100 % by saying
*
*           x=100*RANMAR()
*
*Now, RMARIN and RANMAR share initialization variables in a common block,
*so they can be separated between subroutines, etc (again, for anyone
*unfamiliar, I call RMARIN as a subroutine from my main, and then include
*RANMAR as a function in some of my subroutines where I need to generate
*random numbers).
**************************************************************************
**************************************************************************
      SUBROUTINE RMARIN()
C This is the initialization routine for the random number generator
C     RANMAR()
C NOTE: The seed variables can have values between:    0 <= IJ <= 31328
C                                                      0 <= KL <= 30081
 
      INTEGER IJ,KL,IHOUR,IMIN,ISEC
      INTEGER I,J,K,L,M,II,JJ
      REAL S,T
 
      INTEGER I97,J97
      REAL U(97),C,CD,CM
      LOGICAL TEST
      COMMON /RASET1/ U,C,CD,CM,I97,J97,TEST
 
c_CS 04Jun92 Uses interacter time/date routines to initialize generator
      CALL OSTIME(IHOUR,IMIN,ISEC)
      IJ = MOD(IHOUR*3600+IMIN*60+ISEC,31313)
      KL = MOD(ISEC*3600+IHOUR*60+IMIN,29297)
 
      IF ( IJ.LT.0 .OR. IJ.GT.31328 .OR. KL.LT.0 .OR. KL.GT.30081 ) THEN
        PRINT '(A)',
     &' The first random number seed must have a value between 0 and 313
     &28'
        PRINT '(A)',
     &        ' The second seed must have a value between 0 and 30081'
        STOP
      ENDIF
      I = MOD(IJ/177,177) + 2
      J = MOD(IJ,177) + 2
      K = MOD(KL/169,178) + 1
      L = MOD(KL,169)
      DO 100 II = 1,97
        S = 0.0
        T = 0.5
        DO 50 JJ = 1,24
          M = MOD(MOD(I*J,179)*K,179)
          I = J
          J = K
          K = M
          L = MOD(53*L+1,169)
          IF ( MOD(L*M,64).GE.32 ) S = S + T
          T = 0.5*T
 50     CONTINUE
        U(II) = S
 100  CONTINUE
      C = 362436.0/16777216.0
      CD = 7654321.0/16777216.0
      CM = 16777213.0/16777216.0
      I97 = 97
      J97 = 33
      TEST = .TRUE.
      RETURN
      END
