      subroutine shocbr(halves, nlines, rlpos, foldpt, nchan)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 1992 CS 
*---mru : 930218 tk
*---Purpose: Given line position of Iron metal peaks, show Mossbauer
*---         calibration info.
*--------------------------------------------------------------------
*---externals
      integer halves, nlines, nchan
      real rlpos(12), foldpt
*---parameters and common blocks
      include 'keycom.inc'
      include 'constcom.inc'
*---internals
      real pairv0, pair4dv, pair6dv, v0(0:3), dv(0:3)
      real halfv0, half4dv, half6dv
      integer line1, line2, line3, line4, i, ichr

      real truvel(12)
      save truvel
      data truvel/-5.33, -3.085, -0.84, 0.84, 3.085, 5.33,
     &   5.33, 3.085, 0.84, -0.84, -3.085, -5.33/
*----------------------------------------------------------------------
*---internal statement functions
      pairv0(line1, line2, line3, line4) = Nchan/2+0.5 +
     &  ( (rlpos(line1)+rlpos(line2))/2 - 
     &    (rlpos(line3)+rlpos(line4))/2   )/2
      pair4dv(line1, line2, line3, line4) =
     &   ((truvel(line2+1)-truvel(line1+1)) /
     &    (rlpos(line2)-rlpos(line1)) + 
     &   (truvel(line3+1)-truvel(line4+1)) /
     &    (rlpos(line4)-rlpos(line3))) / 2 
      pair6dv(line1, line2, line3, line4) =
     &   ((truvel(line2)-truvel(line1)) / (rlpos(line2)-rlpos(line1)) +
     &   (truvel(line3)-truvel(line4)) / (rlpos(line4)-rlpos(line3)))/2
      halfv0(line1, line2) = (rlpos(line1)+rlpos(line2)) / 2
      half4dv(line1, line2) = (truvel(line2)-truvel(line1)) /
     &   (rlpos(line2) - rlpos(line1))
      half6dv(line1, line2) = (truvel(line2+1)-truvel(line1+1)) /
     &   (rlpos(line2) - rlpos(line1))
*-----------------------------------------------------------------------
*---executables
      if (halves.eq.1) then
         if (nlines.eq.4) then
            v0(1) = halfv0(2,3)
            dv(1) = half4dv(2,3)
            v0(2) = halfv0(1,4)
            dv(2) = half4dv(1,4)
            v0(3) = 0.
            dv(3) = 0.
            v0(0) = (v0(1) + v0(2)) / 2
            dv(0) = (dv(1) + dv(2)) / 2
         else
            v0(1) = halfv0(3,4)
            dv(1) = half6dv(3,4)
            v0(2) = halfv0(2,5)
            dv(2) = half6dv(2,5)
            v0(3) = halfv0(1,6)
            dv(3) = half6dv(1,6)
            v0(0) = (v0(1) + v0(2) + v0(3)) / 3
            dv(0) = (dv(1) + dv(2) + dv(3)) / 3
         endif
      elseif (nlines.eq.4) then
         v0(1) = pairv0(2,3,8,9)
         dv(1) = pair4dv(2,3,8,9)
         v0(2) = pairv0(1,4,7,10)
         dv(2) = pair4dv(1,4,7,10)
         v0(3) = 0.
         dv(3) = 0.
         v0(0) = (v0(1) + v0(2)) / 2
         dv(0) = (dv(1) + dv(2)) / 2
      else
         v0(1) = pairv0(3,4,9,10)
         dv(1) = pair6dv(3,4,9,10)
         v0(2) = pairv0(2,5,8,11)
         dv(2) = pair6dv(2,5,8,11)
         v0(3) = pairv0(1,6,7,12)
         dv(3) = pair6dv(1,6,7,12)
         v0(0) = (v0(1) + v0(2) + v0(3)) / 3
         dv(0) = (dv(1) + dv(2) + dv(3)) / 3
      endif

*---Display on screen
      call wnactn('FCP')
      call normal
      call wnopen(10,10,55,7)
      call wnousx(2,1,'  Fe Metal Calibration:   Fold.Pt.=')
      call wnoure(foldpt,'(F7.2)')
      call wnousx(1,2,'Pair mm/s   Pave    dV')
      call wnousx(1,3,'---- ----- ------ -------')
      call bright
      call wnousx(2,4,'Avg ')
      call normal
      call wnousx(2,5,'3-4 ')
      call wnoure(dv34,'(F5.2)')
      call wnousx(2,6,'2-5 ')
      call wnoure(dv25,'(F5.2)')
      call wnousx(2,7,'1-6 ')
      call wnoure(dv16,'(F5.2)')
      do 600 i = 0, 3
         if (i.eq.0) then
            call bright
         else
            call normal
         endif
         call wnourx(12,i+4,v0(i),'(F6.2)')
         call wnourx(19,i+4,dv(i),'(F7.5)')
  600 continue

      call message('Press any key to continue...')
      call inkey(ichr)
      call wnclos(1)

      call sholst
      call shoact(.false.)

      return
      end
