      SUBROUTINE SHODAT(NUBOX,NPTS,X,Y,YNOI,JCAL,XYCAL,MSK,WEIGHT,KSYM,
     &                  CAT,NAM,CMT,FULSCR)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: tk, 911003
*---mru:  tk, 931202
*---Purpose:  SHODAT plots a single spectrum with or without a new box.
*---          SHODAT is THE plotting routine for WEB programs.
*---          All plotting of spectra should be done by calling SHODAT.
*---          The goal is to call Interacter routines only from SHODAT.
 
*---external storage
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'keycom.inc'
      INCLUDE 'plotcom.inc'
      INCLUDE 'scrncom.inc'
 
*---INPUT
*---switch for plotting new box with labels and titles
      LOGICAL NUBOX
*---number of points to plot
      INTEGER NPTS
*---beginning addresses for x and y data, y noise, and calibration info
      REAL X(NPTS),Y(NPTS),YNOI(NPTS),XYCAL(MCAL)
      INTEGER JCAL(MCAL)
*---spectrum mask
      LOGICAL MSK(NPTS)
*---scalar multiplier for y
      REAL WEIGHT
*---symbol index: See DATPLT.FOR
      INTEGER KSYM
*---Storage for spectrum name and six comment lines
      CHARACTER NAM*(*),CMT(MCOMMT)*(MCMTLEN)
*---Data catagory: selects color and, for cat<>0, provides storage for
*---               quick erase later.
*---               0 = data
*---               1 = theory
*---               2 = residuals
*---              <0 = subspectrum number = abs(cat)
      INTEGER CAT
*---Switch for full screen plot
      LOGICAL FULSCR,FULLSC
 
*---internal storage
*---symbol size
      REAL SIZE
*---plot title storage
      CHARACTER*72 PTITLE(2),XTITL,XTTITL,YTITL
*---ledgend text
      CHARACTER*8 GTEXT(1)
*---scaled data and noise
      INTEGER NXT,NPT
      INTEGER MLENGTH
      PARAMETER (MLENGTH=2*LSPEC)
      REAL XS(MLENGTH),YS(MLENGTH),YSNOI(MLENGTH),YSSUB(MLENGTH)
      REAL Y1(MLENGTH),YPLUSN(MLENGTH),XTLST(2,MTOP)
      LOGICAL MARKS(MLENGTH)
 
      INTEGER I
      REAL YSNMIN,YSNMAX,XSMIN,XSMAX,YSMAX,YSMIN
      REAL PWL,QWL,PWU,QWU
 
      REAL ARMAX1,ARMIN1
      INTEGER LENACT
      EXTERNAL ARMAX1,ARMIN1,LENACT
 
*---------------------------------------------------------------------
 
      IF ( .NOT.ZGRAPH ) RETURN
 
*---copy full screen switch to common/pbox/
      TFULL = FULSCR
      IF ( .NOT.UNIX ) THEN
        FULLSC = FULSCR
      ELSE
        FULLSC = .TRUE.
      ENDIF
 
      NPT = NPTS
 
*---Multiply Y by input weighting factor
      DO 100 I = 1,NPT
        Y1(I) = WEIGHT*Y(I)
 100  CONTINUE
 
*---Scale x and y data according to info in common block toggle
      CALL SCLDAT(jcal(10),NPT,X,Y1,YNOI,MSK,XYCAL,
     &            KXPLOT,KYPLOT,XS,YS,YSNOI,MARKS,NXT,XTLST)
 
*---SET UP THE SCALING AND CLEAR OLD SPECTRUM STATISTICS
      CALL ARMM1(YSNOI,NPT,YSNMIN,YSNMAX)
 
c     /* X-boundaries */
      IF ( .NOT.ZSCALE ) THEN
c        /* Zoom box boundaries */
        XSMIN = CLPLT
        XSMAX = CLPRT
      ELSEIF ( ZXAUTO ) THEN
c        /* Autoscaled boundaries */
        CALL ARMM1(XS,NPT,XSMIN,XSMAX)
      ELSE
c        /* Non-autoscale boundaries */
        XSMIN = manLT
        XSMAX = manRT
      ENDIF
 
c     /* Y-boundaries */
      IF ( .NOT.ZSCALE ) THEN
c        /* Zoom box boundaries */
        YSMIN = CLPBOT
        YSMAX = CLPTOP
      ELSEIF ( ZYAUTO ) THEN
c        /* Autoscaled boundaries */
        IF ( ZBAR ) THEN
 
c           /* Make sure error bars fit completely on screen */
          DO 120 I = 1,NPT
            YPLUSN(I) = YS(I) + YSNOI(I)
 120      CONTINUE
          YSMAX = ARMAX1(YPLUSN,NPT)
 
          DO 140 I = 1,NPT
            YPLUSN(I) = YS(I) - YSNOI(I)
 140      CONTINUE
          YSMIN = ARMIN1(YPLUSN,NPT)
        ELSE
          CALL ARMM1(YS,NPT,YSMIN,YSMAX)
        ENDIF
      ELSE
c        /* Non-autoscale boundaries */
        YSMIN = manBOT
        YSMAX = manTOP
      ENDIF
 
*---draw box
      IF ( LENACT(NAM).GT.0 ) THEN
        PTITLE(1) = NAM(1:LENACT(NAM))//': '//CMT(1)
      ELSE
        PTITLE(1) = CMT(1)
      ENDIF
      PTITLE(2) = CMT(2)
      GTEXT(1) = PTITLE(1)(1:8)
      IF ( NUBOX ) THEN
        IF ( FULLSC ) THEN
          PWL = 0.0
          QWL = 0.0
          PWU = 1.0
          QWU = 1.0
        ELSEIF ( FITTING ) THEN
          PWL = 0.0
          QWL = 0.0
          PWU = 1.0 - 10./ISCCOL
          QWU = BOXURY
        ELSE
          PWL = BOXLLX
          QWL = BOXLLY
          PWU = BOXURX
          QWU = BOXURY
        ENDIF
*---Define axes titles
        CALL PLTITL(KXPLOT,KYPLOT,MCAL,XYCAL,JCAL,XTITL,YTITL,XTTITL)
*---Plot the box, tic marks and titles.
        IF ( SHOSUB .AND. FITTING ) THEN
          CALL NEWBOX(XSMIN,YSMIN,XSMAX,YSMAX,NXT,XTLST,PWL,QWL,PWU,QWU,
     &                NSUBS,1,GTEXT,PTITLE,XTITL,XTTITL,YTITL)
        ELSE
          CALL NEWBOX(XSMIN,YSMIN,XSMAX,YSMAX,NXT,XTLST,PWL,QWL,PWU,QWU,
     &                0,1,GTEXT,PTITLE,XTITL,XTTITL,YTITL)
        ENDIF
      ENDIF
 
*931202 tk       size = 0.8
      SIZE = 0.5
      IF ( CAT.EQ.0 ) THEN
*---draw THE DATA
*---vertical error bars (or lineplot for theory spectrum being used as data)
        IF ( ZBAR ) THEN
          IF ( YSNMAX.LT.(YSMAX-YSMIN)/500 ) THEN
            CALL DATPLT(NPT,XS,YS,YSNOI,MARKS,0,SIZE,PORIG,CAT)
          ELSE
            CALL DATPLT(NPT,XS,YS,YSNOI,MARKS,-1,SIZE,PORIG,CAT)
          ENDIF
        ENDIF
*---Line plot
        IF ( ZLINE ) CALL DATPLT(NPT,XS,YS,YSNOI,MARKS,0,SIZE,PORIG,CAT)
*---'+' symbol
        IF ( ZSYMBL ) CALL DATPLT(NPT,XS,YS,YSNOI,MARKS,1,SIZE,PORIG,
     &                            CAT)
*---Single points
        IF ( ZPOINT ) CALL DATPLT(NPT,XS,YS,YSNOI,MARKS,11,SIZE,PORIG,
     &                            CAT)
      ELSEIF ( CAT.GT.0 ) THEN
*---draw theory or residuals with line
        CALL DATPLT(NPT,XS,YS,YSNOI,MARKS,0,SIZE,PORIG,CAT)
      ELSE
*---draw subspectra with line
        DO 150 I = 1,NPT
*patch 930313 tk            yssub(i) = ys(i) - cat*ystep*soffst
          YSSUB(I) = YS(I) - CAT*YSTEP
 150    CONTINUE
        CALL DATPLT(NPT,XS,YSSUB,YSNOI,MARKS,0,SIZE,PORIG,CAT)
      ENDIF
 
C Flush screen output
      CALL SCBUFF('FL')
 
      RETURN
      END
