 
*-----------------------------------------------------------------------
      SUBROUTINE SHOPAR(IERR)
*-----------------------------------------------------------------------
      INTEGER IERR
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    mru 20Jul93 cs
*     Writes formatted parameter file to unit JDISK, which is assumed
*     to already be open.  WARNING: the parameters written are taken
*     from PG0/PL0/etc instead of PGBEST/PLBEST/etc as in older
*     versions of this routine!
*
*     ierr   : [Output] Error code.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'iocom.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'constcom.inc'
 
      INTEGER I,J,ISUB
      CHARACTER DASH*60
*-----------------------------------------------------------------------
      INTEGER IJ2KON
      IJ2KON(I,J) = I + 100*J
*-----------------------------------------------------------------------
 
      DASH = 
     &    '------------------------------------------------------------'
 
C     /* Write the Title And Comments */
      WRITE (JDISK,*,IOSTAT=IERR,ERR=600)
     &        PROG//'_XP  Program            For contact: www.wmoss.org'
      WRITE (JDISK,*,IOSTAT=IERR,ERR=600) '''',FILNAM(2),''''
      WRITE (JDISK,*,IOSTAT=IERR,ERR=600) '''',PARCMT(1),''''
      WRITE (JDISK,*,IOSTAT=IERR,ERR=600) '''',PARCMT(2),''''
      WRITE (JDISK,*,IOSTAT=IERR,ERR=600) '''',PARCMT(3),''''
      WRITE (JDISK,*,IOSTAT=IERR,ERR=600) '''',PARCMT(4),''''
      WRITE (JDISK,*,IOSTAT=IERR,ERR=600) DASH
 
c     /* Write Integer Fitting Parameters */
      WRITE (JDISK,*,IOSTAT=IERR,ERR=600) 'Fit Controls'
      WRITE (JDISK,9001,IOSTAT=IERR,ERR=600)
      DO 100 I = 1,NFIPAR
        WRITE (JDISK,9002,IOSTAT=IERR,ERR=600) I,FITNAM(I),IFP(I)
 100  CONTINUE
 
c     /* Write Parameter Output File */
      WRITE (JDISK,*,IOSTAT=IERR,ERR=600) DASH
      WRITE (JDISK,*,IOSTAT=IERR,ERR=600) 'Parameter Output File'
      WRITE (JDISK,*,IOSTAT=IERR,ERR=600) '''',FILNAM(2),''''
 
*---------------------------------
*---Global Parameters
*---------------------------------
 
      DO 300 J = 1,NGLO
        WRITE (JDISK,*,IOSTAT=IERR,ERR=600) DASH
        WRITE (JDISK,*,IOSTAT=IERR,ERR=600) 'Global Integer Parameters'
        WRITE (JDISK,9001,IOSTAT=IERR,ERR=600)
        DO 150 I = 1,IGP(1,J)
          WRITE (JDISK,9002,IOSTAT=IERR,ERR=600) IJ2KON(I,J),IGPNAM(I,J)
     &           ,IGP(I,J)
 150    CONTINUE
 
        WRITE (JDISK,*,IOSTAT=IERR,ERR=600) DASH
        WRITE (JDISK,*,IOSTAT=IERR,ERR=600)
     &          'Global '//'Nonlinear Parameters'
        WRITE (JDISK,9004,IOSTAT=IERR,ERR=600)
        DO 200 I = 1,IGP(2,J)
          WRITE (JDISK,9005,IOSTAT=IERR,ERR=600) IJ2KON(I,J),PGNAM(I,J),
     &           PG0(I,J),KONG(I,J),PGLB(I,J),PGUB(I,J)
 200    CONTINUE
 300  CONTINUE
 
*----------------------------------
*---Local Parameters
*----------------------------------
 
      DO 500 ISUB = 1,NSUBS
        WRITE (JDISK,'(6(A6,I2,A2))',IOSTAT=IERR,ERR=600)
     &         ('Local ',ISUB,'  ',I=1,6)
        WRITE (JDISK,*,IOSTAT=IERR,ERR=600) 'Local Integer Parameters'
        WRITE (JDISK,9001,IOSTAT=IERR,ERR=600)
        DO 350 I = 1,ILP(1,ISUB)
          WRITE (JDISK,9002,IOSTAT=IERR,ERR=600) IJ2KON(I,ISUB),
     &           ILPNAM(I,ISUB),ILP(I,ISUB)
 350    CONTINUE
 
c        /* Linear Area Fractions */
        WRITE (JDISK,*,IOSTAT=IERR,ERR=600) DASH
        WRITE (JDISK,*,IOSTAT=IERR,ERR=600) 'Local Linear Parameters'
        WRITE (JDISK,9003,IOSTAT=IERR,ERR=600)
        DO 400 I = 1,ILP(3,ISUB)
          WRITE (JDISK,9005,IOSTAT=IERR,ERR=600) IJ2KON(I,ISUB),
     &           PLNNAM(I,ISUB),PLN0(I,ISUB),KONLN(I,ISUB),WEILN(I,ISUB)
 400    CONTINUE
 
*---local NONLINEAR
        WRITE (JDISK,*,IOSTAT=IERR,ERR=600) DASH
        WRITE (JDISK,*,IOSTAT=IERR,ERR=600)
     &          'Local '//'Nonlinear Parameters'
        WRITE (JDISK,9004,IOSTAT=IERR,ERR=600)
        DO 450 I = 1,ILP(2,ISUB)
          WRITE (JDISK,9005,IOSTAT=IERR,ERR=600) IJ2KON(I,ISUB),
     &           PLNAM(I,ISUB),PL0(I,ISUB),KONL(I,ISUB),PLLB(I,ISUB),
     &           PLUB(I,ISUB)
 450    CONTINUE
 500  CONTINUE
 
 600  RETURN
 
 9001 FORMAT ('   #   name             value')
 9002 FORMAT (1X,I4,' ''',A10,''' ',I9)
 9003 FORMAT ('   #   name          value          kon        wt')
 9004 FORMAT ('   #   name          value          kon        lb',11X,
     &        'ub')
 9005 FORMAT (1X,I4,' ''',A10,''' ',G13.7,1X,I6,1X,G13.7,1X,G13.7)
      END
