      SUBROUTINE SOP1(NSTATE)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: T.K. OCT. 30, 1988
*---mru:  930523 tk
*---Purpose: for single spin system,
*---CONSTRUCT SINGLE SPIN OPERATORS AND STORE IN COMMON/OP/
*---------------------------------------------------------------------
*---externals
      integer nstate
*---parameters and common blocks
      INCLUDE 'constcom.inc'
      INCLUDE 'opcom.inc'
*---internals
      integer i, j
      COMPLEX ZERO
      REAL SCOEF(MD1), s
*----------------------------------------------------------------------
*---executables
*---Check for too many states
      IF ( (NSTATE.LT.1) .OR. (NSTATE.GT.MD1) ) THEN
        CALL ERRMSG('Nstates too large! ')
        CALL ERRMSG('Too many states! Must abort (sorry).')
        CALL ENDGR
        STOP
      ENDIF
 
C---   INITIALIZE MATRICES TO ZERO.
      ZERO = (0.,0.)
      DO 100 I = 1,MD1
        DO 50 J = 1,MD1
          S1Z(I,J) = ZERO
          SP(I,J) = ZERO
          SM(I,J) = ZERO
 50     CONTINUE
 100  CONTINUE
 
C---   CONSTRUCT SPLUS AND SMINUS IN THE <S,M> BASIS.
      CALL SPLUS(MD1,NSTATE,SCOEF)
C---   SM=ADJOINT(SP)
      S = (NSTATE-1.)/2.
      DO 200 J = 2,NSTATE
        I = J - 1
        SP(I,J) = CMPLX(SCOEF(I),0.)
        SM(J,I) = CONJG(SP(I,J))
 200  CONTINUE
 
C---   CONSTRUCT SX, SY, AND SZ IN THE /S,M> BASIS.
      DO 300 I = 1,NSTATE
        DO 250 J = 1,NSTATE
          S1X(I,J) = 0.5*(SP(I,J)+SM(I,J))
          S1Y(I,J) = (0.,-0.5)*(SP(I,J)-SM(I,J))
 250    CONTINUE
        S1Z(I,I) = S - I + 1.0
 300  CONTINUE
 
C---   CONSTRUCT MATRICES FOR SQUARES OF SX, SY, AND SZ.
      CALL PROCM(S1X,NSTATE,0,S1X,0,NSTATE,S1X2,MD1)
      CALL PROCM(S1Y,NSTATE,0,S1Y,0,NSTATE,S1Y2,MD1)
      CALL PROCM(S1Z,NSTATE,0,S1Z,0,NSTATE,S1Z2,MD1)
 
      RETURN
      END
