      SUBROUTINE SOP2(NST1,nst2)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 930523 tk
*---mru:  930523 tk
*---Purpose: for two-spin system,
*---CONSTRUCT SINGLE SPIN OPERATORS for each spin AND STORE IN COMMON/OP/
*---------------------------------------------------------------------
*---externals
      integer nst1,nst2
*---parameters and common blocks
      INCLUDE 'constcom.inc'
      INCLUDE 'opcom.inc'
*---internals
      integer i, j
      COMPLEX ZERO,one
      REAL SCOEF(MD1), s
*----------------------------------------------------------------------
*---executables
*---Check for too many states
      IF ( (NST1.LT.1) .OR. (NST1.GT.MD1) ) THEN
        CALL ERRMSG('Illegal number of states for spin #1!')
        CALL ENDGR
        STOP
      ENDIF
      IF ( (NST2.LT.1) .OR. (NST2.GT.MD2) ) THEN
        CALL ERRMSG('Illegal number of states for spin #2!')
        CALL ENDGR
        STOP
      ENDIF

      ZERO = (0.,0.)
      one = (1.0,0.0) 
*---construct matrices for spin #1
C---   INITIALIZE MATRICES TO ZERO.
      DO 100 I = 1,MD1
        DO 50 J = 1,MD1
          is1(i,j) = zero
          S1Z(I,J) = ZERO
          SP(I,J) = ZERO
          SM(I,J) = ZERO
 50     CONTINUE
 100  CONTINUE
 
C---   CONSTRUCT SPLUS AND SMINUS IN THE <S,M> BASIS.
      CALL SPLUS(MD1,NST1,SCOEF)
C---   SM=ADJOINT(SP)
      S = (NST1-1.)/2.
      DO 200 J = 2,NST1
        I = J - 1
        SP(I,J) = CMPLX(SCOEF(I),0.)
        SM(J,I) = CONJG(SP(I,J))
 200  CONTINUE
 
C---   CONSTRUCT identity, SX, SY, AND SZ IN THE /S,M> BASIS.
      DO 300 I = 1,NST1
         DO 250 J = 1,NST1
          S1X(I,J) = 0.5*(SP(I,J)+SM(I,J))
          S1Y(I,J) = (0.,-0.5)*(SP(I,J)-SM(I,J))
 250    CONTINUE
        is1(i,i) = one
        S1Z(I,I) = S - I + 1.0
 300  CONTINUE
 
C---   CONSTRUCT MATRICES FOR SQUARES OF S1X, S1Y, AND S1Z.
      CALL PROCM(S1X,NST1,0,S1X,0,NST1,S1X2,MD1)
      CALL PROCM(S1Y,NST1,0,S1Y,0,NST1,S1Y2,MD1)
      CALL PROCM(S1Z,NST1,0,S1Z,0,NST1,S1Z2,MD1)
 
*---construct matrices for spin #2
C---   INITIALIZE MATRICES TO ZERO.
      ZERO = (0.,0.)
      DO 400 I = 1,MD2
        DO 450 J = 1,MD2
          is2(i,j) = zero
          s2Z(I,J) = ZERO
          SP(I,J) = ZERO
          SM(I,J) = ZERO
 450     CONTINUE
 400  CONTINUE
 
C---   CONSTRUCT SPLUS AND SMINUS IN THE <S,M> BASIS.
      CALL SPLUS(md2,NST2,SCOEF)
C---   SM=ADJOINT(SP)
      S = (NST2-1.)/2.
      DO 500 J = 2,NST2
        I = J - 1
        SP(I,J) = CMPLX(SCOEF(I),0.)
        SM(J,I) = CONJG(SP(I,J))
 500  CONTINUE
 
C---   CONSTRUCT identity, SX, SY, AND SZ IN THE /S,M> BASIS.
      DO 600 I = 1,NST2
        DO 550 J = 1,NST2
          s2X(I,J) = 0.5*(SP(I,J)+SM(I,J))
          s2Y(I,J) = (0.,-0.5)*(SP(I,J)-SM(I,J))
 550    CONTINUE
        is2(i,i) = one
        s2Z(I,I) = S - I + 1.0
 600  CONTINUE
 

*---CONSTRUCT MATRICES FOR SQUARES OF S2X, S2Y, and S2Z.
      CALL PROCM(S2X,NST2,0,S2X,0,NST2,S2X2,md2)
      CALL PROCM(S2Y,NST2,0,S2Y,0,NST2,S2Y2,md2)
      CALL PROCM(S2Z,NST2,0,S2Z,0,NST2,S2Z2,md2)
*---CONSTRUCT MATRICES FOR S2XY,S2YX,S2XZ,S2ZX,S2YZ,S2ZY
      CALL PROCM(S2X,NST2,0,S2Y,0,NST2,S2XY,md2)
      CALL PROCM(S2Y,NST2,0,S2X,0,NST2,S2YX,md2)
      CALL PROCM(S2X,NST2,0,S2Z,0,NST2,S2XZ,md2)
      CALL PROCM(S2Z,NST2,0,S2X,0,NST2,S2ZX,md2)
      CALL PROCM(S2Y,NST2,0,S2Z,0,NST2,S2YZ,md2)
      CALL PROCM(S2Z,NST2,0,S2Y,0,NST2,S2ZY,md2)
      
      RETURN
      END
