C WARNING:  SPECCOM.INC MUST _FOLLOW_ LIMITS.INC

*---------------*
* Spectrum List *
*---------------*-------------------------------------------------------
      common /allspc/ spctra, spcnoi, spccal, icalsp, spcmsk,
     &   xspc, spctot, actspc, spcnam, spccmt
      common /slct/ select, picked, repspc
*-----------------------------------------------------------------------

      character*(mfllen) spcnam(mmain)
      character*72 spccmt(mcommt,mmain)
      real spctra(lspec,mmain), spcnoi(lspec,mmain)
      real spccal(mcal,mmain), xspc(lspec,mmain)
      integer icalsp(mcal,mmain), spctot, actspc
      logical spcmsk(lspec,mmain)

      logical select(mmain), picked(mmain)
      integer repspc

*-----------------------------------------------------------------------
* spctra : Array of spectrum values.
* spcnoi : Array of spectrum noise values.
* spccal : Array of spectrum real calibration constants.
* icalsp : Array of spectrum integer calibration constants.
* xspc   : Array of X-positions for spectrum points
* spcnam : Array of filenames for the spectra on the list.
* spccmt : Array of comment sets for the spectra on the list.
*
* spctot : Number of spectra currently on the list.
* actspc : Number of the current active spectrum.
*
* select : Array of flags: Has the list spectrum been >>selected?
* picked : Array of flags: Has the list spectrum been _picked_?
* repspc : Number of the spectrum to display during fitting.
*        :    (WHY IS THIS HERE?)
*-----------------------------------------------------------------------

*--------------------*
* Fast-Erase Storage *
*--------------------*--------------------------------------------------
      common /oldspc/ thrx, resx, sbx, othx, tbound, rbound, sbound, 
     &   obound, thrspc, resspc, sbspc, othspc
*-----------------------------------------------------------------------
      integer tbound(2), rbound(2), sbound(2), obound(2)
      real thrspc(2*lspec), resspc(2*lspec), sbspc(2*lspec,mloc)
      real thrx(2*lspec), resx(2*lspec), sbx(2*lspec)
      real othspc(2*lspec, mloc), othx(2*lspec, mloc)
*-----------------------------------------------------------------------
* tbound : First & Last theory channels to erase.
* rbound : First & Last residue channels to erase.
* sbound : First & Last subspectrum channels to erase.
*
* thrspc : Values of theory to be erased.
* resspc : Values of residue to be erase.
* sbspc  : Array of subspectra to be erased.
*
* thrx   : X-coordinates of theory to be erased.
* resx   : X-coordinates of residue to be erased.
* sbx    : X-coordinates of the subspectra to be erased.
*-----------------------------------------------------------------------


