*---FILE: SPLUS.F
      SUBROUTINE SPLUS(ND,N,SCOEF)
C***
C***      THE SUBROUTINE SPLUS CALCULATES THE MATRIX ELEMENTS
C***       OF THE OPERATOR S PLUS WITHIN A SPIN MULTIPLET OF MULTIPLICITY
C***      N=2*S+1
C***      THE NON ZERO MATRIX ELEMENTS ARE
C***       (M+1/S PLUS/M)=SQRT(S*(S+1)-M*(M+1))
C***      THE ELEMENTS ARE STORED IN THE ARRAY SCOEF
      INTEGER N,ND
      REAL SCOEF(ND)
C***      N IS THE MULTIPLICITY OF THE SPIN, N=2*S+1
C***         SCOEF(1)=(S/SPLUS/S-1), SCOEF(2)=(S-1/SPLUS/S-2) , .....
C***
C***
      INTEGER N1,I
      REAL S,SQ,SM
 
      SCOEF(N) = 0.
      N1 = N - 1
      S = N1
      S = S/2.0
      SQ = S*(S+1)
      SM = S - 1.0
      DO 100 I = 1,N1
        SCOEF(I) = SQRT(SQ-SM*(SM+1))
        SM = SM - 1.0
 100  CONTINUE
      RETURN
      END
