      SUBROUTINE SSUB(IDAT,IOTHER)
*---WEB Research Co.
*---orig:  tk & cs 1991 
*---mru :  29Jul93 cs, 980313 tk
*---Purpose:  Spectral subtration with interactive graphics display.
*-----------------------------------------------------------------------
*---externals
      INTEGER IDAT,IOTHER
*---parameters and common blocks
      include 'limits.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'keycom.inc'
*---internals
      INTEGER DELAY
      PARAMETER (DELAY=85)
      LOGICAL PCHNGE,GETYN
      INTEGER I, J, ICHR,COUNT, npts
      REAL TMPSPC(LSPEC),PCT,PCT100, pct1, tarea, dpct
      REAL TMPSP2(LSPEC), SOTHER(LSPEC), nother(lspec)
      CHARACTER*(mfllen) INNAME
      CHARACTER*72 INCMNT
*---external funcions
      real addvec
      integer infocu
      external addvec, infocu
*-----------------------------------------------------------------------
*---executables 
      COUNT = 0
      PCHNGE = .FALSE.
      dpct = 1.0
 
      npts = icalsp(1,idat)

*---Interpolate spectrum
      call interp(mcal, icalsp(1,iother), spccal(1,iother),
     &   spctra(1,iother),
     &   spcnoi(1,iother), icalsp(1,idat), spccal(1,idat), sother,
     &   nother)

*---calc. normalized area of second spectrum
      PCT1 = abs(addvec(npts,sother))
      if(pct1.le.0.0)then
         call errmsg('Spectrum #2 has zero area.  Exit SSub.')
         return
      endif

      pct = pct1
      PCT100 = 100*pct1

  201 CALL MESSAGE('Subtracting ' // SPCNAM(IOTHER) // ' with area ')
      CALL CURSAV
      CALL OUTREA(PCT,'(F7.4)')
 
      do 100 i = 1, npts
         tmpspc(i) = sother(i)*pct/pct1
  100 continue

*---Display first spectrum
  150 CALL shodat(.true., npts, xspc(1,idat), spctra(1,idat),
     &   spcnoi(1,idat), icalsp(1,idat), spccal(1,idat), 
     &   spcmsk(1,idat), 1.0, -1, 0,
     &   spcnam(idat), spccmt(1,idat), .false.)

*---Display scaled copy of second spectrum
      call shodat(.false., npts, xspc(1,idat), tmpspc,
     &   nother, icalsp(1,idat), spccal(1,idat), spcmsk(1,idat),
     &   1.0, 1, 1, spcnam(idat), spccmt(1,idat), .false.)
      IF ( SHORES ) then
*---Display difference spectrum
         do 250 i = 1, npts
            tmpsp2(i) = spctra(i,actspc) - tmpspc(i)
  250    continue
         call shodat(.false., npts, xspc(1,idat), tmpsp2,
     &      nother, icalsp(1,idat), spccal(1,idat), spcmsk(1,idat),
     &      1.0, 1, 2, spcnam(idat), spccmt(1,idat), .false.)
      endif

*---Get keyboard input 
 300  CALL CURRES
      CALL OUTREA(PCT100/100,'(F7.4)')
      call outrea(dpct/100 , '(F7.4)')
      CALL INKEYI(ICHR)

*---Action according to ICHR
      IF ( ICHR.le. 0 ) THEN
         COUNT = COUNT + 1
         IF ( MOD(COUNT,DELAY).EQ.0 ) THEN
            COUNT = 0
            IF ( PCHNGE ) THEN
               PCT = PCT100/100
               PCHNGE = .FALSE.
               DO 310 I = 1, npts
                  TMPSPC(I) = PCT*SOTHER(I)/pct1
  310          CONTINUE

               call shodat(.false.,npts,xspc(1,idat),tmpspc,
     &            nother, icalsp(1,idat), spccal(1,idat), 
     &            spcmsk(1,idat),
     &            1.0, 1, 1,spcnam(idat),spccmt(1,idat),.false.)
               IF ( SHORES ) then
                  do 312 i = 1, npts
                     tmpsp2(i) = spctra(i,actspc) - tmpspc(i)
  312             continue
                  call shodat(.false.,npts,xspc(1,idat),tmpsp2,
     &               nother, icalsp(1,idat), spccal(1,idat), 
     &               spcmsk(1,idat),
     &               1.0, 1, 2,spcnam(idat),spccmt(1,idat),.false.)
               endif
            ENDIF
         ENDIF
      ELSEIF ( ((ICHR.EQ.ENTER) .OR. (ICHR.EQ.ESC)) .AND. .NOT.PCHNGE )
     &         THEN
        CALL MESSAGE(' ')
        IF ( GETYN('Store Difference?') ) THEN
 
          INNAME = ' '
          CALL MESSAGE('Name: ')
          CALL GETS(7,INFOCU(2),INNAME,mfllen,ICHR,.FALSE.)
          CALL MESSAGE(' ')
          IF ( (INNAME.NE.' ') .AND. (ICHR.NE.ESC) ) THEN
 
            INCMNT = ' '
            CALL MESSAGE('Comment: ')
            CALL GETS(10,INFOCU(2),INCMNT,72,ICHR,.FALSE.)
            CALL MESSAGE(' ')
            IF ( ICHR.NE.ESC ) THEN
 
              IF ( SPCTOT.LT.MMAIN ) SPCTOT = SPCTOT + 1
*---append difference spectrum and cal info to LIST
              SPCNAM(SPCTOT) = INNAME
              SPCCMT(1,SPCTOT) = INCMNT
              DO 315 J = 2,6
                SPCCMT(J,SPCTOT) = ' '
 315          CONTINUE
*---copy difference of normalized spectra to LIST 
*---also calc. area
              tarea = 0.0
              DO 320 I = 1, npts
*---difference spectrum
                SPCTRA(I,SPCTOT) = SPCTRA(I,IDAT) - TMPSPC(I)
*---noise in diff. spectrum = sqrt[ n1^2 + p^2 * n2^2) ]
                SPCNOI(I,SPCTOT) = SQRT( SPCNOI(I,IDAT)**2 + 
     &            (PCT*nother(i))**2)
*---x values
                xspc(I,spctot) = xspc(I,idat)
*---area
                tarea = tarea + spctra(i,spctot)
 320          CONTINUE
 
*---Copy cal arrays of first spectrum to those of diff.
              CALL VCOPY(mcal,SPCCAL(1,IDAT),SPCCAL(1,SPCTOT))
              DO 325 I = 1,mcal
                 ICALSP(I,SPCTOT) = ICALSP(I,IDAT)
  325         CONTINUE
*---Is first or second spectrum experimental (noise>0) ?
              if(icalsp(mcal,idat).eq.0.or.icalsp(mcal,iother).eq.0)then
                 icalsp(mcal,spctot) = 0
              else
                  icalsp(mcal,spctot) =+1
           endif

*tk 960108
*---In data header of diff. spectrum, store noise value of norm. diff. spec.
                 spccal(8,spctot) = spcnoi(1,spctot)
*---make diff. spectrum the active spectrum
                 ACTSPC = SPCTOT
*---display updated list
              CALL SHOLST
            ENDIF
          ENDIF
        ELSE
          CALL MESSAGE(' ')
          ACTSPC = IDAT
        ENDIF
        CALL SHOACT(.FALSE.)
        RETURN
      ELSEIF ( ICHR.EQ.UPARR ) THEN
        PCT100 = PCT100 + dpct
        PCHNGE = .TRUE.
        COUNT = 0
      ELSEIF ( ICHR.EQ.DNARR ) THEN
        PCT100 = PCT100 - dpct
        COUNT = 0
        PCHNGE = .TRUE.
      ELSEIF ( ICHR.EQ.CUPARR ) THEN
        PCT100 = PCT100 + 10*dpct
        COUNT = 0
        PCHNGE = .TRUE.
      ELSEIF ( ICHR.EQ.CDNARR ) THEN
        PCT100 = PCT100 - 10*dpct
        COUNT = 0
        PCHNGE = .TRUE.
      ELSEIF ( ICHR.EQ.RTARR ) THEN
        dpct = 2.0 * dpct
        COUNT = 0
        PCHNGE = .TRUE.
      ELSEIF ( ICHR.EQ.LTARR ) THEN
        dpct = 0.5 * dpct
        COUNT = 0
        PCHNGE = .TRUE.
      ELSEIF ( ICHR.EQ.HOME ) THEN
        PCT100 = 100*pct1
        dpct = 1.0
        COUNT = 0
        PCHNGE = .TRUE.
c      ELSEIF ( ICHR.EQ.PGUP ) THEN
c        IOTHER = IOTHER - 1
c        IF ( IOTHER.LT.1 ) IOTHER = SPCTOT
c        CALL THRERA
c        IF ( SHORES ) CALL RESERA
c        GOTO 200
c      ELSEIF ( ICHR.EQ.PGDN ) THEN
c        IOTHER = IOTHER + 1
c        IF ( IOTHER.GT.SPCTOT ) IOTHER = 1
c        CALL THRERA
c        IF ( SHORES ) CALL RESERA
c        GOTO 200
      ELSEIF ( (ICHR.EQ.CTRLP .and. .not. zcrip) .AND. (.NOT.PCHNGE) )
     & THEN
        CALL CLSCRN
        CALL INTPRN
        CALL shodat(.true.,icalsp(1,idat),xspc(1,idat),
     &     spctra(1,idat), spcnoi(1,idat),
     &     icalsp(1,idat), spccal(1,idat), spcmsk(1,idat),
     &     1.0,-1,0, spcnam(idat),
     &     spccmt(1,idat), .false.)

        call shodat(.false.,npts,xspc(1,idat),tmpspc,
     &     nother, icalsp(1,idat), spccal(1,idat), spcmsk(1,idat),
     &     1.0, 1, 1,spcnam(idat),spccmt(1,idat),.false.)
        IF ( SHORES ) then
           do 400 i = 1, npts
              tmpsp2(i) = spctra(i,actspc) - tmpspc(i)
  400      continue
           call shodat(.false.,npts,xspc(1,idat),tmpsp2,
     &        nother, icalsp(1,idat), spccal(1,idat), 
     &        spcmsk(1,idat),
     &        1.0, 1, 2,spcnam(idat),spccmt(1,idat),.false.)
        endif
        call clsprn
        call clrall
        CALL shodat(.true.,icalsp(1,idat),xspc(1,idat),
     &     spctra(1,idat), nother,
     &     icalsp(1,idat), spccal(1,idat), spcmsk(1,idat),
     &     1.0,-1,0, spcnam(idat),
     &     spccmt(1,idat), .false.)
        GOTO 201

c	PION Refresh SCRN
	ELSEIF ( ICHR.EQ.ALTR ) THEN
        call clrall
        CALL shodat(.true.,icalsp(1,idat),xspc(1,idat),
     &     spctra(1,idat), nother,
     &     icalsp(1,idat), spccal(1,idat), spcmsk(1,idat),
     &     1.0,-1,0, spcnam(idat),
     &     spccmt(1,idat), .false.)

      elseif (ichr.eq.F8) then
         if (zscale) then
            call zoom
         else
            zscale = .true.
         endif
         goto 150
      ENDIF
      GOTO 300
      END
