*-----------------------------------------------------------------------
      SUBROUTINE STORE(ILEVEL,NFREE,VFREE)
*-----------------------------------------------------------------------
      INTEGER ILEVEL,NFREE
      REAL VFREE(NFREE)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    mru 16Jul93 cs
*
*     Keeps the best parameter sets so far & their associated theory
*     throughout the fitting process.
*
*     ilevel  : Level of the parameters to be stored;
*     nfree   : Number of free variables at this level;
*     vfree   : Free variables at this level.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'varcom.inc'
      INCLUDE 'bestcom.inc'
 
      INTEGER I,J,K
*-----------------------------------------------------------------------
 
c     /* Check ilevel */
      IF ( ILEVEL.LT.1 .OR. ILEVEL.GT.MLEVEL+1 ) THEN
*---PION
*        PRINT *,CHAR(7),' ilevel out of range in store. ilevel=',ILEVEL
        RETURN
      ENDIF
 
      IF ( ILEVEL.LE.LOCLEV ) THEN
c        /* Global or Local level: copy lower level theory */
        DO 50 K = 0,NSUBS
          DO 20 J = 1,NSPEC
            DO 10 I = 1,ICAL(1,J)
              RESPONSE(I,J,K,ILEVEL) = RESPONSE(I,J,K,ILEVEL+1)
 10         CONTINUE
 20       CONTINUE
 50     CONTINUE
      ELSEIF ( ILEVEL.EQ.GARLEV ) THEN
c        /* GLOBAL AREA level: initial copy of uloloc theory */
        DO 100 J = 1,NSPEC
          DO 60 I = 1,ICAL(1,J)
            RESPONSE(I,J,0,GARLEV) = SPEC(I,J,2)
 60       CONTINUE
 100    CONTINUE
 
c        /* Copy and linearly scale the response subspectra */
        CALL STORLN
      ENDIF
 
c     /* Initialize variable values at this level to zero */
      DO 200 I = 1,MVAR
        BVAR(I,ILEVEL,MIN(ILEVEL,LINLEV)) = 0.0
 200  CONTINUE
 
c     /* Store best variables so far, for this level */
      DO 300 I = 1,NFREE
        BVAR(I,ILEVEL,MIN(ILEVEL,LINLEV)) = VFREE(I)
 300  CONTINUE
 
c     /* Copy lower-level best variables, if any */
      IF ( ILEVEL.LT.LINLEV ) THEN
        DO 350 J = ILEVEL + 1,MLEVEL + 1
          DO 320 I = 1,MVAR
            BVAR(I,J,ILEVEL) = BVAR(I,J,ILEVEL+1)
 320      CONTINUE
 350    CONTINUE
      ENDIF
 
      RETURN
      END
