      SUBROUTINE STRTCH
C---Subroutine STRTCH stretches THE VELOCITY SCALE OF AN
C       EXPERIMENTAL SPECTRUM TO A NEW VELOCITY SCALE.
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 900627 tk
*---mru : 960212 tk; 971216 tk
*------------------------------------------------------------------------
*---Assume baseline is zero
*---adapted to NUMOSS by tk 900627
*---use Interacter routines for i/o
*------------------------------------------------------------------------
*---storage
*---declare function chuspc to integer
      integer chuspc
 
      include 'limits.inc'
      include 'speccom.inc'
*---internal storage
      integer c1, i, ichr
      real step, v0, stepn, v0n
      integer iwidth, ispc, isn
      integer irow, icol, ierr
      character*(mfllen) nam
*--------------------------------------------------------------------------
*---executables
*---close window since STRTCH requires text mode.
        CALL WNCLOS(1)
*---Go to Text mode and clear screen
        CALL ENDGR
        CALL CLSCRN
 
*---define width of keyboard entry field
      IWIDTH = 12
*---define new spectrum number on LIST
      ISN = SPCTOT + 1
 
C***    choose SPECTRUM FROM LIST
      ISPC = CHUSPC('Choose')
      IF ( ISPC.LE.0 ) RETURN
*---copy old cal info
      DO 100 I = 1,10
         SPCCAL(I,ISN) = SPCCAL(I,ISPC)
         ICALSP(I,ISN) = ICALSP(I,ISPC)
 100  CONTINUE
 
      CALL CLSCRN
 
*---show old cal
      STEP = SPCCAL(7,ISPC)
      V0 = SPCCAL(6,ISPC)
 
   10 call normal
      call outsxy(1,2,'Old step [mm/s/ch] = ')
      call outrea(step,'(f6.4)')
      call outsxy(1,4,'Old V=0 channel = ')
      call outrea(v0,'(f6.2)')
*---get new cal from keyboard
      call outsxy(1,6,' New step [mm/s/ch] ?')
      stepn = step
      call getr(23,6,stepn,ichr,.false.)
      call outsxy(1,8,' New V=0 Channel [ch] ?')
      v0n = v0
      call getr(25,8,v0n,ichr,.false.)

*---save new info
      spccal(7,isn) = stepn
      spccal(6,isn) = v0n

*---stretch spectrum
      call interp(mcal, icalsp(1,ispc), spccal(1,ispc),
     &   spctra(1,ispc),
     &   spcnoi(1,ispc), icalsp(1,isn), spccal(1,isn), spctra(1,isn),
     &   spcnoi(1,isn))

*---get new name
      call outsxy(1,12,' Original spectrum name is '//spcnam(ispc))
      nam = spcnam(ispc)
      call outsxy(1,14,' New spectrum name ?')
      call gets(22,14, nam, 40, ichr, .false.)
 
*---put new spectrum and cal on LIST
      call ad2lst(isn, nam, spccmt(1,ispc), spctra(1,isn),
     &   spcnoi(1,isn), xspc(1,ispc), spcmsk(1,isn), spccal(1,isn),
     &   icalsp(1,ispc))
      spctot = isn

      call chkcal(isn, ierr, irow, icol)
      if (ierr.ne.0) then
         call clscrn
         call errmsg('Invalid calibration information! Try again.')
         goto 10
      endif
 
*---make new spectrum the active spectrum
      actspc = spctot
 
*---give advice
      call outsxy(1,16,'Comments may be edited in [ Files, Edit Cal ]')
      call outsxy(1,18,'Press a key to continue ...')
      call inkey(c1)

*---return to graphics mode
        CALL INTGRA
*---Update screen with new plot of active spectrum and numerical info.
          CALL SHOACT(.FALSE.)

      return
      end
