      SUBROUTINE ULOGL1()
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
C---orig 901030 TK
*---mru: 26Jul93 cs
*---Purpose:  Calc. and store electron spin expectation values.
*---SINGLE SPIN OPERATORS CONSTRUCTED PREVIOUSLY AND STORED IN /OP/.
*----------------------------------------------------------------------
*---MAXGRD := MAX. NUMBER OF GRID POINTS FOR POWDER AVERAGE.
*---MDOP1     := DIMENSION OF OPERATOR AND EIGENFUNCTION ARRAYS.
 
*---SPIN HAMILTONIAN PARAMETERS
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      include 'togcom.inc'
      integer n1st

      real pgbest(MGPAR,MGLO), xi2bst
      common /RGBEST/ pgbest, xi2bst
 
*---STORAGE FOR GRID
      INCLUDE 'gridcom.inc'
 
*---SINGLE SPIN OPERATORS
      INCLUDE 'opcom.inc'
 
      INCLUDE 'constcom.inc'
      INCLUDE 'iocom.inc'
 
*---EXPECTATION VALUES: USES CONSTANTS FROM OPCOM.INC AND GRIDCOM.INC
      INCLUDE 'expcom.inc'
 
*---STORAGE FOR "EFFECTIVE FIELD" AT CURRENT GRID POINT
      COMPLEX GXEX,GYEY,GZEZ
 
*---STORAGE FOR SQRT(-1)
      COMPLEX EYE
 
*---STORAGE FOR CONSTANTS APPEARING IN HAMILTONIAN
      COMPLEX CD,CEVRD,CBHAP,CSSQV3
 
*---STORAGE FOR DIAGONALIZATION OF HAMILTONIAN
      COMPLEX HAMIJ(MD1,MD1)
      REAL UR(MD1,MD1),UI(MD1,MD1),HR(MD1,MD1),
     &     HI(MD1,MD1)
      REAL FV1(MD1),FV2(MD1),FM1(2,MD1)
c      COMMON /HAMIL / HR,HI,UR,UI,ELVL,FV1,FV2,FM2
      COMPLEX C(MD1,MD1)
 
      integer i, j, idata, nchan, ig, ierr, idb4, ist
      real elvl, gx, gy, gz, a2l, fm2, d
      real evrd, s, hapb4, hap, p, temp

      integer lwork
      parameter(lwork = 3*md1)
      integer iwork(5*md1), ifail(md1), m
      real rwork(6*md1)
      complex work(lwork)

*---STATEMENT FUNCTION: KRONICKER DELTA FUNCTION
      integer idlt
      IDLT(I,J) = (I/J)*(J/I)
*-----------------------------------------------------------------------
*---executables 
      d    = pgbest(1,1)
      evrd = pgbest(2,1)
      a2l  = pgbest(3,1)
      gx   = pgbest(4,1)
      gy   = pgbest(5,1)
      gz   = pgbest(6,1)

*---PASS NUMBER OF STATES from parm vector TO THE COMMON BLOCKs
      n1st = igp(6,1)
      Ns1cm = N1ST
      ns1=  n1st
*---DEFINE SQRT(-1)
      EYE = (0.0,1.0)
 
*---CONSTANTS FOR HAM.
      S = (N1ST-1.0)/2.0
      CSSQV3 = CMPLX(S*(S+1.0)/3.0)
      CD = CMPLX(D)
      CEVRD = CMPLX(EVRD)
 
C---SCAN TABLE OF FIELD AND TEMPERATURE POINTS.
*---DIAGONALIZE HAMILTONIAN ONLY IF FIELD HAS CHANGED BY MORE THAN
*---0.010 KILOGAUSS
      HAPB4 = -1.23456e6
      DO 200 IDATA = 1, nspec
        NCHAN = INT(ICAL(1,IDATA))
        HAP = CAL(1,IDATA)
        TEMP = CAL(2,IDATA)
        IF ( ABS(HAP-HAPB4).GT.0.010 ) THEN
          CBHAP = CMPLX(BETAE*HAP)
 
*----NEW FIELD CALCULATION
*----DO POWDER AVERAGE
          DO 40 IG = 1,NGRID
            GXEX = CMPLX(GX*EX(IG))
            GYEY = CMPLX(GY*EY(IG))
            GZEZ = CMPLX(GZ*EZ(IG))
*---CONSTRUCT SINGLE SPIN HAMILTONIAN.
            DO 10 I = 1,N1ST
              DO 5 J = 1,N1ST
                HAMIJ(I,J) = CD*(S1Z2(I,J)-CSSQV3*CMPLX(IDLT(I,J))
     &             + CEVRD*(S1X2(I,J)-S1Y2(I,J)))
     &             + CBHAP*(GZEZ*S1Z(I,J)+GXEX*S1X(I,J)+GYEY*S1Y(I,J))
*---STORE REAL AND IMAGINARY PARTS FOR INPUT TO CH.
                HR(I,J) = REAL(HAMIJ(I,J))
                HI(I,J) = AIMAG(HAMIJ(I,J))
 5            CONTINUE
 10         CONTINUE
 
C DIAGONALIZE THE HAMILTONIAN. SOLVE FOR ENERGY LEVELS & EIGENVECTORS.
            if (idiag.eq.2) then
               call cheevx('V', 'A', 'L', N1ST, HAMIJ, MD1,
     &            0., 0., 0, 0, 0., M, ELEVEL(1,IG,IDATA), C, MD1, WORK,
     &            LWORK, RWORK, IWORK, IFAIL, IERR)
            else
               if (idiag.ne.0) then
                  CALL XCH(MD1, N1ST, HR, HI, ELEVEL(1,IG,IDATA), 1, UR,
     &               UI, FV1, FV2, FM1, IERR)
               else
C	Patched below by PION to be solved later 
C	call ch(... to call xch(...

                  CALL XCH(MD1, N1ST, HR, HI, ELEVEL(1,IG,IDATA), 1, UR,
     &               UI, FV1, FV2, FM1, IERR)
               endif
               if (ierr.ne.0) then
                  call errmsg ('WARNING: Nonzero error code from CH!')
               endif
               DO 20 I = 1,N1ST
                  DO 15 J = 1,N1ST
                     C(I,J) = UR(I,J) + EYE*UI(I,J)
   15             CONTINUE
   20          CONTINUE 
            endif

            CALL EXS1(S1X,C,N1ST,MD1,ES1X(1,IG,IDATA))
            CALL EXS1(S1Y,C,N1ST,MD1,ES1Y(1,IG,IDATA))
            CALL EXS1(S1Z,C,N1ST,MD1,ES1Z(1,IG,IDATA))
 
 40       CONTINUE
 
        ELSE
*---IF FIELD HAS NOT CHANGED, USE PREVIOUS RESULTS.
          IDB4 = IDATA - 1
          DO 60 IG = 1,NGRID
            DO 50 IST = 1,N1ST
              ELEVEL(IST,IG,IDATA) = ELEVEL(IST,IG,IDB4)
              ES1X(IST,IG,IDATA) = ES1X(IST,IG,IDB4)
              ES1Y(IST,IG,IDATA) = ES1Y(IST,IG,IDB4)
              ES1Z(IST,IG,IDATA) = ES1Z(IST,IG,IDB4)
 50         CONTINUE
 60       CONTINUE
 
        ENDIF
*---NEW TEMPERATURE CALCULATION.
 
C---   CALCULATE THERMAL EXPECTATION VALUE OF S.
        DO 100 IG = 1,NGRID
          CALL BOPOP(MD1,N1ST,TEMP,ELEVEL(1,IG,IDATA),BPOP(1,IG,IDATA))
 
          ES1XT(IG,IDATA) = 0
          ES1YT(IG,IDATA) = 0
          ES1ZT(IG,IDATA) = 0
          DO 80 I = 1,N1ST
            P = BPOP(I,IG,IDATA)
            ES1XT(IG,IDATA) = ES1XT(IG,IDATA) + P*ES1X(I,IG,IDATA)
            ES1YT(IG,IDATA) = ES1YT(IG,IDATA) + P*ES1Y(I,IG,IDATA)
            ES1ZT(IG,IDATA) = ES1ZT(IG,IDATA) + P*ES1Z(I,IG,IDATA)
 80       CONTINUE
 100    CONTINUE
 
        HAPB4 = HAP
 200  CONTINUE
 
      RETURN
      END
