      SUBROUTINE ULOGL4()
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 930523 tk
*---mru : 26Jul93 cs
*---Purpose:  Calculate and store expectation values and energy levels
*---          of two-spin system.  Does calculation over angular grid.
*----------------------------------------------------------------------
*---SINGLE SPIN OPERATORS CONSTRUCTED PREVIOUSLY AND STORED IN /OP2/.
*----------------------------------------------------------------------
*---parameters and common blocks
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      integer n1st,n2st
      real  D1,E1VRD1,G1X,G1Y,G1Z,D2,E2VRD2,G2X,G2Y,G2Z,
     & al,be,ga,jx,jy,jz

      real pgbest(MGPAR,MGLO), xi2bst
      common /rgbest/ pgbest, xi2bst

      INCLUDE 'constcom.inc'
      INCLUDE 'iocom.inc'
 
*---STORAGE FOR GRID
      INCLUDE 'gridcom.inc'
*---storage for SPIN OPERATORS
      INCLUDE 'opcom.inc'
*---EXPECTATION VALUES: USES CONSTANTS FROM OPCOM.INC AND GRIDCOM.INC
      INCLUDE 'expcom.inc'
*---STORAGE FOR direction cosines of Happ AT CURRENT GRID POINT
      real exig,eyig,ezig
*---storage for D tensor, G tensor of spin 2.  And rotation matrix R.
*---Dr and Gr are D and G rotated to spin 1 frame.
      real D(3,3),G(3,3),R(3,3),Gr(3,3),Dr(3,3)
*---STORAGE FOR SQRT(-1)
      COMPLEX EYE
*---STORAGE FOR CONSTANTS APPEARING IN HAMILTONIAN
      real s1,s2
      COMPLEX CD1,CEVRD1,CS1SQ3,CBHAP
      COMPLEX S2SQ3
*---STORAGE FOR DIAGONALIZATION OF HAMILTONIAN
      COMPLEX HAMIJ
      REAL UR(MDsys,MDsys),UI(MDsys,MDsys),HR(MDsys,MDsys),
     &     HI(MDsys,MDsys)
      REAL FV1(MDsys),FV2(MDsys),FM1(2,MDsys)
c      COMMON /HAMIL2/ HR,HI,UR,UI,FV1,FV2
 
      integer idata, nchan, ig, ierr, idb4, ist
      integer ih,jh,i1,j1,i2,j2
      real hapb4, hap, temp, p
*-------------------------------------------------------------------------
*---executables 
      d1     = pgbest(1,1)
      e1vrd1 = pgbest(2,1)
      g1x    = pgbest(3,1)
      g1y    = pgbest(4,1)
      g1z    = pgbest(5,1)
      d2     = pgbest(6,1)
      e2vrd2 = pgbest(7,1)
      g2x    = pgbest(8,1)
      g2y    = pgbest(9,1)
      g2z    = pgbest(10,1)
      al     = pgbest(11,1)
      be     = pgbest(12,1)
      ga     = pgbest(13,1)
      jx     = pgbest(14,1)
      jy     = pgbest(15,1)
      jz     = pgbest(16,1)

      n1st = igp(6,1)
      n2st = igp(7,1)

*---PASS NUMBER OF ELECTRONIC STATES TO THE COMMON BLOCK
      ns1cm = N1ST
      ns1 = n1st
      ns2cm = n2st
      ns2 = n2st
      nscm = n1st*n2st
      ns = nscm

*---DEFINE SQRT(-1)
      EYE = (0.0,1.0)
 
*---CONSTANTS FOR HAM.
      S1 = (N1ST-1.0)/2.0
      CS1SQ3 = CMPLX(S1*(S1+1.0)/3.0)
      CD1 = CMPLX(D1)
      CEVRD1 = CMPLX(E1VRD1)
      S2 = (N2ST-1.0)/2.0
      S2SQ3 = S2*(S2+1.0)/3.0

*---Calc. D and G tensor for second spin.
*---Calc. rotation matrix.
      call eul2mat(al*rpd,be*rpd,ga*rpd,R)
*---Define diagonal G tensor.
      call mident3(G)
      G(1,1) = G2x
      G(2,2) = G2y
      G(3,3) = G2z
*---Transform G from spin 2 frame to spin 1 frame
*?????Transform G  or G(adjoint(G))  ????? see Abragam and Bleaney, p.652
      call strnf3(R,G,Gr)
*---Define diagonal D tensor.
      call mident3(D)
      D(1,1) = D2*( E2vrD2 - S2sq3)
      D(2,2) = D2*(-E2vrD2 - S2sq3)
      D(3,3) = D2*( 1.0    - S2sq3)
*---Transform D from spin 2 frame to spin 1 frame
      call strnf3(R,D,Dr)
 
C---SCAN TABLE OF FIELD AND TEMPERATURE POINTS.
*---DIAGONALIZE HAMILTONIAN ONLY IF FIELD HAS CHANGED BY MORE THAN
*---0.010 KILOGAUSS
      HAPB4 = -1.0
      DO 200 IDATA = 1, nspec
        NCHAN = INT(ICAL(1,IDATA))
        HAP = CAL(1,IDATA)
        TEMP = CAL(2,IDATA)
        IF ( ABS(HAP-HAPB4).GT.0.010 ) THEN
          CBHAP = CMPLX(BETAE*HAP)
 
*----NEW FIELD CALCULATION
*----DO POWDER AVERAGE
          DO 40 IG = 1,NGRID
            exig = EX(IG)
            eyig = EY(IG)
            ezig = EZ(IG)
****************************************************************************
*---CONSTRUCT two SPIN HAMILTONIAN.
      DO 45 IH=1,ns
      I2=1 + (IH-1)/n1st
      I1=IH-(I2-1)*n1st
      DO 45 JH=1,IH
      J2= 1 + (JH-1)/n1st
      J1=JH-(J2-1)*n1st

*---Zero field splitting for first spin
      hamij=cD1*(S1Z2(I1,J1)-CS1sq3*IS1(I1,J1)
     1                +cevrd1*(S1X2(I1,J1)-S1Y2(I1,J1)))*IS2(I2,J2)

*---Zero field splitting for second spin
*---Angles are in units of degrees.
      hamij=hamij
     1+( Dr(1,1)*S2X2(I2,J2)+Dr(2,2)*S2Y2(I2,J2)+ Dr(3,3)*S2Z2(I2,J2)
     2  +Dr(1,2)*(S2XY(I2,J2)+S2YX(I2,J2))
     2  +Dr(2,3)*(S2YZ(I2,J2)+S2ZY(I2,J2))
     3  +Dr(1,3)*(S2XZ(I2,J2)+S2ZX(I2,J2)))*IS1(I1,J1)

*---Zeeman term for spin 1
      hamij= hamij
     1 +cbhap*( ezig*G1Z*S1Z(I1,J1)
     2         +eyig*G1Y*S1Y(I1,J1)
     3         +exig*G1X*S1X(I1,J1))*IS2(I2,J2)
*---Zeeman term for spin 2
      hamij= hamij
     1 +cbhap*( (exig*Gr(1,1)+eyig*Gr(2,1)+ezig*Gr(3,1))*S2x(i2,j2)
     2         +(exig*Gr(1,2)+eyig*Gr(2,2)+ezig*Gr(3,2))*S2y(i2,j2)
     3         +(exig*Gr(1,3)+eyig*Gr(2,3)+ezig*Gr(3,3))*S2z(i2,j2))
     4 *is1(i1,j1)

*---Exchange coupling term
      hamij=hamij+JZ*S1Z(I1,J1)*S2Z(I2,J2)
     7                     +JY*S1Y(I1,J1)*S2Y(I2,J2)
     8                     +JX*S1X(I1,J1)*S2X(I2,J2)
*---Store real and imaginary parts for input to CH.
      hr(ih,jh) = real(hamij)
      hi(ih,jh) = aimag(hamij)
*      print *,ih,jh,hamij,hr(ih,jh),hi(ih,jh)
45    CONTINUE
***********************************************************************

 
C DIAGONALIZE THE HAMILTONIAN. SOLVE FOR ENERGY LEVELS & EIGENVECTORS.
            CALL XCH(MDsys,NS,HR,HI,ELEVEL(1,IG,IDATA),1,UR,UI,FV1,
     &               FV2,FM1,IERR)
            IF ( IERR.NE.0 ) THEN
              call errmsg('ABORTING')
              call errmsg('On return from CH, ierr .ne. 0')
              call endgr
              STOP
            ENDIF

            CALL EXSu(mdsys,md1,md2,ur,ui,ns,S1X,N1ST,is2,n2st,
     &                ES1x(1,IG,IDATA))
            CALL EXSu(mdsys,md1,md2,ur,ui,ns,S1y,N1ST,is2,n2st,
     &                ES1y(1,IG,IDATA))
            CALL EXSu(mdsys,md1,md2,ur,ui,ns,S1z,N1ST,is2,n2st,
     &                ES1z(1,IG,IDATA))
            CALL EXSu(mdsys,md1,md2,ur,ui,ns,is1,N1ST,s2x,n2st,
     &                ES2x(1,IG,IDATA))
            CALL EXSu(mdsys,md1,md2,ur,ui,ns,is1,N1ST,s2y,n2st,
     &                ES2y(1,IG,IDATA))
            CALL EXSu(mdsys,md1,md2,ur,ui,ns,is1,N1ST,s2z,n2st,
     &                ES2z(1,IG,IDATA))

 
 40       CONTINUE
 
        ELSE
*---IF FIELD HAS NOT CHANGED, USE PREVIOUS RESULTS.
          IDB4 = IDATA - 1
          DO 60 IG = 1,NGRID
            DO 50 IST = 1,NS
              ELEVEL(IST,IG,IDATA) = ELEVEL(IST,IG,IDB4)
              ES1X(IST,IG,IDATA) = ES1X(IST,IG,IDB4)
              ES1Y(IST,IG,IDATA) = ES1Y(IST,IG,IDB4)
              ES1Z(IST,IG,IDATA) = ES1Z(IST,IG,IDB4)
              ES2X(IST,IG,IDATA) = ES2X(IST,IG,IDB4)
              ES2Y(IST,IG,IDATA) = ES2Y(IST,IG,IDB4)
              ES2Z(IST,IG,IDATA) = ES2Z(IST,IG,IDB4)
 50         CONTINUE
 60       CONTINUE
 
        ENDIF
*---NEW TEMPERATURE CALCULATION.
 
C---   CALCULATE THERMAL EXPECTATION VALUE OF S.
        DO 100 IG = 1,NGRID
          CALL BOPOP(MDsys,NS,TEMP,ELEVEL(1,IG,IDATA),BPOP(1,IG,IDATA))
 
          ES1XT(IG,IDATA) = 0
          ES1YT(IG,IDATA) = 0
          ES1ZT(IG,IDATA) = 0
          ES2XT(IG,IDATA) = 0
          ES2YT(IG,IDATA) = 0
          ES2ZT(IG,IDATA) = 0
          DO 80 Ist = 1,Ns
            P = BPOP(Ist,IG,IDATA)
            ES1XT(IG,IDATA) = ES1XT(IG,IDATA) + P*ES1X(Ist,IG,IDATA)
            ES1YT(IG,IDATA) = ES1YT(IG,IDATA) + P*ES1Y(Ist,IG,IDATA)
            ES1ZT(IG,IDATA) = ES1ZT(IG,IDATA) + P*ES1Z(Ist,IG,IDATA)
            ES2XT(IG,IDATA) = ES2XT(IG,IDATA) + P*ES2X(Ist,IG,IDATA)
            ES2YT(IG,IDATA) = ES2YT(IG,IDATA) + P*ES2Y(Ist,IG,IDATA)
            ES2ZT(IG,IDATA) = ES2ZT(IG,IDATA) + P*ES2Z(Ist,IG,IDATA)
 80       CONTINUE
 100    CONTINUE
 
        HAPB4 = HAP
 200  CONTINUE
 
      RETURN
      END
