*-----------------------------------------------------------------------
      SUBROUTINE ULOLC1(isub)
*-----------------------------------------------------------------------
      integer isub
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     before 920528 tk, mru 28Jul93 cs
*
*     For a single spin system and given expectation of electronic
*     spin, calculate Mossbauer spectra for a single subsite.
*
*     isub   : [Input]  Subsite to calculate.
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'constcom.inc'
      include 'iocom.inc'
      include 'parcom.inc'
      include 'opcom.inc'
      include 'expcom.inc'

c     ;; Current value of parameters
      real plbest(MLPAR,MLOC)
      common /rlbest/ plbest
c     ;; patch: storage for efg of site #1 for print out on Postscipt plot
      real v1(3,3)
      common /efg1/ v1

      real RAD
      parameter (RAD = 0.017453292)

c     ;; Storage for hyperfine tensors
      real a(3,3), v(3,3), r(3,3), tv(3,3)

      integer i, j, idata, nchan, kpol, krelax
      real deq, eta, al, be, ga, axx, ayy, azz, shift, fwhm
*-----------------------------------------------------------------------

c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c     ;; Define current subsystem constants ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

c     ;; Define efg tensor
      deq = plbest(1,isub)
      eta = plbest(2,isub)
      al  = plbest(3,isub) * RAD
      be  = plbest(4,isub) * RAD
      ga  = plbest(5,isub) * RAD
      call e2mzim(al, be, ga, r)
      call mident3(tv)
      tv(3,3) = deq / sqrt(1.0+ eta*eta/3.0)
      tv(1,1) = 0.5 * tv(3,3) * (eta-1.0)
      tv(2,2) = - tv(1,1) - tv(3,3)
      call strnf3(r, tv, v)

c     ;; patch: store efg of site #1 for Postscipt plots
      if (isub.eq.1) then
         do 21 i = 1, 3
            do 20 j = 1, i
               v1(i,j) = v(i,j)
   20       continue
   21    continue
      endif

c     ;; Define magnetic hyperfine tensor
      al  = plbest(9,isub)  * RAD
      be  = plbest(10,isub) * RAD
      ga  = plbest(11,isub) * RAD
      call e2mzim(al, be, ga, r)
      axx = plbest(6,isub)
      ayy = plbest(7,isub)
      azz = plbest(8,isub)
      call mident3(tv)
      tv(1,1) = axx
      tv(2,2) = ayy
      tv(3,3) = azz
      call strnf3(r, tv, a)

c     ;; Define isomer shift
      shift = plbest(12,isub)

c     ;; Define linewidth
      fwhm  = plbest(13,isub)

c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c     ;; Calculate spectrum for each field & temp ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

      do 100 idata = 1, nspec
         nchan  = ical(1,idata)
         kpol   = ical(3,idata)
         krelax = ical(4,idata)
         if (krelax.eq.1) then
c           ;; Slow: calc ns1 spectra
            call smgrid(mdsys, ns1, es1x(1,1,idata), es1y(1,1,idata),
     &         es1z(1,1,idata), bpop(1,1,idata), a, v, shift, fwhm,
     &         kpol, LSPEC, nchan, cal(1,idata), locspc(1,idata,isub))
         else
c           ;; Fast: calc. spectrum using thermal averages of 
c           ;; spin expectation values.
            call smgrid(1, 1, es1xt(1,idata), es1yt(1,idata),
     &         es1zt(1,idata), bpop(1,1,idata), a, v, shift, fwhm, kpol,
     &         LSPEC, nchan, cal(1,idata), locspc(1,idata,isub))
         endif
  100 continue

      return
      end
