*-----------------------------------------------------------------------
      subroutine ulolc4(isub)
*-----------------------------------------------------------------------
      integer isub
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     930527 TK, mru 28Jul93 cs
*     For a two-spin system and given expectation of electronic 
*     spin, calculate Mossbauer spectra for a single subsite using the
*     parameters in PLBEST.
*
*     isub   : Subsite to calculate.
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'constcom.inc'
      include 'iocom.inc'
      include 'parcom.inc'
      include 'opcom.inc'
      include 'expcom.inc'
      real plbest(MLPAR,MLOC)
      common /rlbest/ plbest
c     ;; Patch: storage for efg of site #1 for print out on Postscipt plot
      real V1(3,3)
      common/efg1/ V1

      real RAD
      parameter (RAD = 0.017453292)

c     ;; Storage for hyperfine tensors
      REAL A(3,3), V(3,3), R(3,3), TV(3,3)

      integer i, j, idata, nchan, kpol, krelax
      real deq, eta, al, be, ga, axx, ayy, azz, shift, fwhm
*-----------------------------------------------------------------------

c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c     ;; Define current subsystem constants ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

c     ;; Define efg tensor
      deq = plbest(1,isub)
      eta = plbest(2,isub)
      al  = plbest(3,isub) * RAD
      be  = plbest(4,isub) * RAD
      ga  = plbest(5,isub) * RAD
      call e2mzim(al, be, ga, r)
      call mident3(tv)
      tv(3,3) = deq / sqrt(1.0 + eta*eta/3.0)
      tv(1,1) = 0.5 * tv(3,3) * (eta-1.0)
      tv(2,2) = -tv(1,1) - tv(3,3)
      call strnf3(r, tv, v)

c     ;; Patch: store efg of site #1 for Postscipt plots
      if (isub.eq.1) then
         do 21 i = 1, 3
            do 20 j = 1, i
               v1(i,j) = v(i,j)
   20       continue
   21    continue
      endif

c     ;; Define magnetic hyperfine tensor
      al = plbest(9,isub)  * RAD
      be = plbest(10,isub) * RAD
      ga = plbest(11,isub) * RAD
      call e2mzim(al, be, ga, r)
      axx = plbest(6,isub)
      ayy = plbest(7,isub)
      azz = plbest(8,isub)
      call mident3(tv)
      tv(1,1) = axx
      tv(2,2) = ayy
      tv(3,3) = azz
      call strnf3(r, tv, a)

c     ;; Define isomer shift
      shift = plbest(12,isub)

c     ;; Define linewidth
      fwhm = plbest(13,isub)

c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c     ;; Calculate spectrum for each field & temp ;;
c     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

      do 100 idata = 1, nspec
         nchan  = ical(1,idata)
         kpol   = ical(3,idata)
         krelax = ical(4,idata)

c        ;; Select which electron local spin coupled to this nucleus.
         if (ilp(4,isub).eq.1) then
c           ;; Couple to electron spin #1
            if (krelax.eq.1) then
c              ;; Slow: calc spectrum for each system state.
               call smgrid(mdsys, ns, es1x(1,1,idata), es1y(1,1,idata),
     &            es1z(1,1,idata), bpop(1,1,idata), a, v, shift, fwhm,
     &            kpol, LSPEC, nchan, cal(1,idata),
     &            locspc(1,idata,isub))
            else
c              ;; Fast: calc. 1 spectrum using thermal averages of
c              ;; spin expectation values.
               call smgrid(1, 1, es1xt(1,idata), es1yt(1,idata),
     &            es1zt(1,idata), bpop(1,1,idata), a, v, shift, fwhm,
     &            kpol, LSPEC, nchan, cal(1,idata),
     &            locspc(1,idata,isub))
            endif
         else
c           ;; Couple to electron spin #2
            if (krelax.eq.1) then
c              ;; Slow: calc spectrum for each system state
               call smgrid(mdsys, ns, es2x(1,1,idata), es2y(1,1,idata),
     &            es2z(1,1,idata), bpop(1,1,idata), a, v, shift, fwhm,
     &            kpol, lspec, nchan, cal(1,idata),
     &            locspc(1,idata,isub))
            else
c              ;; Fast: calc. 1 spectrum using thermal averages of
c              ;; spin expectation values.
               call smgrid(1, 1, es2xt(1,idata), es2yt(1,idata),
     &            es2zt(1,idata), bpop(1,1,idata), a, v, shift, fwhm,
     &            kpol, LSPEC, nchan, cal(1,idata),
     &            locspc(1,idata,isub))
            endif
         endif
  100 continue

      return
      end
