      subroutine ulolc8(isub)
*-----------------------------------------------------------------------
*---externals
      integer isub
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     orig: 971211 tk
*     mru : 19980302 tk
*
*     Calculate subspectrum consisting of a single Gaussian
*     absorption line, using the parameters in the PLBEST array.
*     Gaussian nornmalized to Area = 1.0 integrated over x-range
*     of calculation.
*
*     isub   : Subsite to calculate.
*-----------------------------------------------------------------------
*---Common Blocks
      include 'limits.inc'
      include 'parcom.inc'
      include 'constcom.inc'
      real plbest(MLPAR,MLOC)
      common /rlbest/ plbest
*---Internals
      real czero, step, cshift, cfwhm, a, area
      integer npts, ispec, i

      external vel2ch
      real vel2ch
*-----------------------------------------------------------------------
*---executables

      do 100 ispec = 1,nspec
*---Energy = zero channel [channels]
         czero = cal(6,ispec)
*---dEnergy / channel  [keV/channel]
         step = cal(7,ispec)
*---Center of line [channels]
         cshift = vel2ch(plbest(1,isub), czero, step)
*---Full Width at Half Maximum [channels]
         cfwhm = plbest(2,isub) / step
*---Number of channels in spectrum
         npts = ical(1,ispec)

*---Calc. Gaussian shape. Assume cfwhm >> 1 channel.
*---Shape factor: 
      a = -alog(2.0)*4.0/(cfwhm**2)

      area = 0.0
      do 10 i=1,npts
        locspc(i,ispec,isub) = -exp( a * (i-cshift)**2 )
        area = area + locspc(i,ispec,isub)
10    continue
*---Normalize area
      if (area .eq. 0.0) then
        call errmsg('Area of Gaussian = 0 in subroutine ULOCL7.')
      endif
      area = abs(area)
      do 20 i=1,npts
        locspc(i,ispec,isub) = locspc(i,ispec,isub) / area
20    continue

  100 continue
 
      return
      end
