*     VARCOM.INC
*     Generic version
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    mru 16Jul93 cs

*----------------------------*
* Global nonlinear variables *
*----------------------------*------------------------------------------
      common /vglob/ vg0, vgbest, vglb, vgub, ngfree
*-----------------------------------------------------------------------
      real vg0(mvar), vgbest(mvar), vglb(mvar), vgub(mvar)
      integer ngfree
*-----------------------------------------------------------------------
* vg0    : Global variables:  initial values.
* vgbest : Global variables:  optimized values.
* vglb   : Lower bounds for global variables.
* vgub   : Upper bounds for global variables.
* ngfree : Number of free global nonlinear parameters.     
*-----------------------------------------------------------------------

*---------------------------*
* Local nonlinear variables *
*---------------------------*-------------------------------------------
      common /vlocal/ vl0, vlbest, vllb, vlub, nlfree
*-----------------------------------------------------------------------
      real vl0(mvar), vlbest(mvar), vllb(mvar), vlub(mvar)
      integer nlfree
*-----------------------------------------------------------------------
* vl0    : Local variables:  initial values.
* vlbest : Local variables:  optimized values.
* vllb   : Lower bounds for local variables.
* vlub   : Upper bounds for local variables.
* nlfree : Number of free local nonlinear parameters.     
*-----------------------------------------------------------------------


*-----------------------*
* Global area variables *
*-----------------------*-----------------------------------------------
      common /vgarea/ va0, vabest, valb, vaub, nafree
*-----------------------------------------------------------------------
      real va0(mvar), vabest(mvar), valb(mvar), vaub(mvar)
      integer nafree
*-----------------------------------------------------------------------
* va0    : Global area variables:  initial values.
* vabest : Global area variables:  optimized values.
* valb   : Lower bounds for global area variables.
* vaub   : Upper bounds for global area variables.
* nafree : Number of free global areas.
*-----------------------------------------------------------------------


*------------------*
* Linear variables *
*------------------*----------------------------------------------------
      common /vlin  / vln0, vlnb, vlnlb, vlnub, nlnfr, vbl0, vblb,
     &   vbllb, vblub, nblfr
*-----------------------------------------------------------------------
      real vln0(mvar), vlnb(mvar), vlnlb(mvar), vlnub(mvar)
      real vbl0(mvar), vblb(mvar), vbllb(mvar), vblub(mvar)
      integer nlnfr, nblfr
*-----------------------------------------------------------------------
* vln0   : Linear variables:  initialized values.
* vlnb   : Linear variables:  optimized values.
* vlnlb  : Lower bounds for linear variables.
* vlnub  : Upper bounds for linear variables.
* nlnfr  : Number of free linear parameters.
*-----------------------------------------------------------------------

c  ;; Storage for current best parameters */
      real pgbest(MGPAR,MGLO), rx2bst
      real plbest(MLPAR,MLOC)
      real pabest(MAPAR,LT1)
      real plinb(MLLPAR,MLOC), pbbest(MBLPAR,LT1)
      common /rgbest/ pgbest, rx2bst
      common /rlbest/ plbest
      common /rabest/ pabest
      common /rlinb / plinb, pbbest

      real x2bstl, x2bstg, x2bsta
      integer iterl, iterg, iterga
      common /lbest / x2bstl, iterl
      common /gbest / x2bstg, iterg
      common /gabest/ x2bsta, iterga
