      PROGRAM WMOSS
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig TAK 900123
*---MRU  17May93 CS
*---Purpose:
*TK'S LEAST SQUARES FITTING PROGRAM WITH THESE FEATURES:
*1. NON-ITERATIVE OPTIMIZATION OF LINEAR PARAMETERS
*2. MODULAR STRUCTURE WITH USER SUPPLYING THE FOLLOWING ROUTINES:
*   URFGBL -- THEORETICAL MODEL FOR GLOBAL SYSTEM
*   URFLOC -- THEORETICAL MODEL FOR LOCAL SYSTEM
*   DATREA -- ROUTINE TO READ DATA FILE.
*   SNDEF  -- ROUTINE TO DEFINE NOISE IN DATA IF NOISE FIGURES
*             ARE NOT INCLUDED IN DATA FILES.  SNDEF SHOULD BE CALLED
*             BY DATREA.
*   DATWRI -- ROUTINE TO WRITE DATA FILE.
*             NOTE,
*             DATA FILE ALSO STORES VALUES OF THEORETICAL FIT.
*   INTFUN -- ROUTINE TO INITIAL USER'S THEORETICAL MODEL
*3. ACCURATE NOISE VALUES
*   ARE REQUIRED FOR PROPER CALCULATION OF XI^2.
*4. OPTION FOR ANNEALING OF FINAL FIT IS PROVIDED.
*5. OPTION FOR ANALYZING UNCERTAINTITIES OF AND CORRELATIONS BETWEEN
*   FREE PARAMETERS VIA MONTE-CARLO SIMULATION IS PROVIDED.
*----------------------------------------------------------------------
*DEFINE COMMON BLOCKS
      INCLUDE 'iocom.inc'
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'constcom.inc'
      INCLUDE 'speccom.inc'
      include 'togcom.inc'
      include 'fftcom.inc'

      integer lenact
      external lenact
*-------------------------------------------------------------------
*-EXECUTABLE STATEMENTS START HERE.
      INCLUDE 'constdef.inc'
      INCLUDE 'iodef.inc'

      CALL CHKLIM
*Initialize user options/flags
      CALL INTTOG
*READ CONFIG FILE
      CALL GETCFG
*PRINT GREETING
      CALL BANNER
*CLEAR DATA TABLE
      CALL CLRTAB
*Initialize Fourier transform routine
      CALL RFFTI(2*LSPEC,WSAVE)
      lstfft = 2*lspec
*READ SCREEN FILE
      call getscr
 
      SPCTOT = 0
      ACTSPC = 0
 
*INITIALIZE SPECTRUM MASK (Must be called before INTGRA)
      CALL INTMSK
*INITIALIZE INTERACTER TEXT ROUTINES
      call inttxt
*INITIALIZE INTERACTER GRAPHICS ROUTINES
      CALL INTGRA
*INITIALIZE RANDOM NUMBER GENERATOR
      call rmarin
*INITIALIZE COMMON BLOCK VARIABLES
      call intcom
 
      CALL TOPMNU
 
*RETURN TO TEXT MODE
      CALL ENDGR
*EXIT INTERACTER
      call endtxt
 
      STOP
      END
