 
*FROM: NETLIBD@ANTARES.MCS.ANL.GOV (NETLIB)
*STATUS: R
*CAVEAT RECEPTOR.  (JACK) DONGARRA@ANL-MCS.ARPA, (ERIC GROSSE) RESEARCH!EHG
*CAREFUL! ANYTHING FREE COMES WITH NO GUARANTEE.
*** FROM NETLIB, THU JAN 19 10:07:24 CST 1989 ***
 
      SUBROUTINE XCH(NM,N,AR,AI,W,MATZ,ZR,ZI,FV1,FV2,FM1,IERR)
*---CONVERTED TO SINGLE PRECISION BY TK, 900315.  MRU 900821 TK
 
      INTEGER I,J,N,NM,IERR,MATZ
      REAL AR(NM,N),AI(NM,N),W(N),ZR(NM,N),ZI(NM,N),FV1(N),FV2(N),
     &     FM1(2,N)
C
C     THIS SUBROUTINE CALLS THE RECOMMENDED SEQUENCE OF
C     SUBROUTINES FROM THE EIGENSYSTEM SUBROUTINE PACKAGE (EISPACK)
C     TO FIND THE EIGENVALUES AND EIGENVECTORS (IF DESIRED)
C     OF A COMPLEX HERMITIAN MATRIX.
C
C     ON INPUT
C
C        NM  MUST BE SET TO THE ROW DIMENSION OF THE TWO-DIMENSIONAL
C        ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C        DIMENSION STATEMENT.
C
C        N  IS THE ORDER OF THE MATRIX  A=(AR,AI).
C
C        AR  AND  AI  CONTAIN THE REAL AND IMAGINARY PARTS,
C        RESPECTIVELY, OF THE COMPLEX HERMITIAN MATRIX.
C
C        MATZ  IS AN INTEGER VARIABLE SET EQUAL TO ZERO IF
C        ONLY EIGENVALUES ARE DESIRED.  OTHERWISE IT IS SET TO
C        ANY NON-ZERO INTEGER FOR BOTH EIGENVALUES AND EIGENVECTORS.
C
C     ON OUTPUT
C
C        W  CONTAINS THE EIGENVALUES IN ASCENDING ORDER.
C
C        ZR  AND  ZI  CONTAIN THE REAL AND IMAGINARY PARTS,
C        RESPECTIVELY, OF THE EIGENVECTORS IF MATZ IS NOT ZERO.
C
C        IERR  IS AN INTEGER OUTPUT VARIABLE SET EQUAL TO AN ERROR
C           COMPLETION CODE DESCRIBED IN THE DOCUMENTATION FOR TQLRAT
C           AND TQL2.  THE NORMAL COMPLETION CODE IS ZERO.
C
C        FV1, FV2, AND  FM1  ARE TEMPORARY STORAGE ARRAYS.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO BURTON S. GARBOW,
C     MATHEMATICS AND COMPUTER SCIENCE DIV, ARGONNE NATIONAL LABORATORY
C
C     THIS VERSION DATED AUGUST 1983.
C
C     ------------------------------------------------------------------
C
      IF ( N.LE.NM ) THEN
C
*_CS 17Jun91 patch: calls htridi with modified pythag routine

        CALL XHTRIDI(NM,N,AR,AI,W,FV1,FV2,FM1)
        IF ( MATZ.NE.0 ) THEN
C     .......... FIND BOTH EIGENVALUES AND EIGENVECTORS ..........
          DO 20 I = 1,N
C
            DO 10 J = 1,N
              ZR(J,I) = 0.0E0
 10         CONTINUE
C
            ZR(I,I) = 1.0E0
 20       CONTINUE
C
*_CS 17Jun91 patch: calls tql2 with modified pythag routine
          CALL XTQL2(NM,N,W,FV1,ZR,IERR)
          IF ( IERR.EQ.0 ) CALL HTRIBK(NM,N,AR,AI,FM1,N,ZR,ZI)
        ELSE
C     .......... FIND EIGENVALUES ONLY ..........
          CALL TQLRAT(N,W,FV2,IERR)
        ENDIF
      ELSE
        IERR = 10*N
      ENDIF
      RETURN
      END
