      SUBROUTINE XN57E(HEFX,HEFY,HEFZ,VXX,VYY,VZZ,VXY,VXZ,VYZ,coef)
 
      real hefx, hefy, hefz, vxx, vyy, vzz, vxy, vxz, vyz

C***
C***    THE SUBROUTINE N57H SETS UP THE MATRIX OF THE 3/2 57FE
C***    HYPERFINE HAMILTONIAN IN THE BASIS 3/2,1/2,-1/2,-3/2
C***
C***    INPUT PARAMETERS
C***    VXX,VYY,VZZ,VXY,VXZ,VYZ
C***    =COMPONENTS OF THE EFG IN MM/S
C***     HEFX,HEFY,HEFZ
C***    =COMPONENTS OF THE EFFECTIVE MAGNETIC FIELD IN KG
C***
C***    OUTPUT PARAMETERS
      real coef(10)
C***    HMATR(I,J,1) CONTAINS THE REAL PART, HMATR(I,J,2) THE
C***    IMAGINARY PART OF THE 3/2 57FE HYPERFINE HAMILTONIAN
C***    IN THE BASIS 3/2,1/2,-1/2,-3/2
C***
C***    SET UP THE HAMILTONIAN OF THE EXCITED STATE

      real k1,k2,k3,k4,rt1ov3
      parameter(k1=.0101431, k2=.00585612, k3=.28867514, k4=.00676207)
*---RT1OV3 := 1/sqrt(3)
      parameter(RT1OV3 = 0.5573502692)

      coef(1) = 0.5*Vzz
      coef(2) = (k1/3.0)*Hefz
      coef(3) = RT1OV3*Vxz
      coef(4) = k2*Hefx
      coef(5) = RT1OV3*Vyz
      coef(6) = k2*Hefy
      coef(7) = k4*Hefx
      coef(8) = k4*Hefy
      coef(9) = k3*(Vxx-Vyy)
      coef(10) = RT1OV3*Vxy

      RETURN
      END
